=== modified file 'drizzled/cached_item.cc'
--- drizzled/cached_item.cc	2011-03-21 18:32:26 +0000
+++ drizzled/cached_item.cc	2011-06-22 20:05:58 +0000
@@ -94,7 +94,7 @@
   {
     if ((null_value= item->null_value))
       // New value was null
-      return(true);
+      return true;
     tmp=true;
   }
   else if (null_value)
@@ -121,9 +121,9 @@
   {
     null_value= item->null_value;
     value=nr;
-    return(true);
+    return true;
   }
-  return(false);
+  return false;
 }
 
 bool Cached_item_int::cmp(void)
@@ -133,9 +133,9 @@
   {
     null_value= item->null_value;
     value=nr;
-    return(true);
+    return true;
   }
-  return(false);
+  return false;
 }
 
 

=== modified file 'drizzled/common_fwd.h'
--- drizzled/common_fwd.h	2011-04-29 16:12:27 +0000
+++ drizzled/common_fwd.h	2011-06-22 16:36:40 +0000
@@ -20,6 +20,7 @@
 #include <boost/shared_ptr.hpp>
 #include <boost/thread/condition_variable.hpp>
 #include <boost/thread/mutex.hpp>
+#include <cstring>
 #include <string>
 #include <vector>
 
@@ -56,7 +57,6 @@
 namespace internal
 {
   struct io_cache_st;
-  
   struct st_my_thread_var;
 }
 

=== modified file 'drizzled/create_field.cc'
--- drizzled/create_field.cc	2011-03-28 02:46:21 +0000
+++ drizzled/create_field.cc	2011-06-22 20:05:58 +0000
@@ -109,17 +109,15 @@
        old_field->getTable()->timestamp_field != old_field ||  /* timestamp field */
        unireg_check == Field::TIMESTAMP_UN_FIELD))        /* has default val */
   {
-    ptrdiff_t diff;
-
     /* Get the value from default_values */
-    diff= (ptrdiff_t) (orig_field->getTable()->getDefaultValues() - orig_field->getTable()->getInsertRecord());
+    ptrdiff_t diff= (ptrdiff_t) (orig_field->getTable()->getDefaultValues() - orig_field->getTable()->getInsertRecord());
     orig_field->move_field_offset(diff);	// Points now at default_values
     if (! orig_field->is_real_null())
     {
-      char buff[MAX_FIELD_WIDTH], *pos;
-      String tmp(buff, sizeof(buff), charset), *res;
-      res= orig_field->val_str_internal(&tmp);
-      pos= (char*) memory::sql_strmake(res->ptr(), res->length());
+      char buff[MAX_FIELD_WIDTH];
+      String tmp(buff, sizeof(buff), charset);
+      String* res= orig_field->val_str_internal(&tmp);
+      char* pos= (char*) memory::sql_strmake(res->ptr(), res->length());
       def= new Item_string(pos, res->length(), charset);
     }
     orig_field->move_field_offset(-diff);	// Back to getInsertRecord()
@@ -208,7 +206,7 @@
   {
     my_error(ER_TOO_BIG_SCALE, MYF(0), decimals, fld_name,
              NOT_FIXED_DEC-1);
-    return(true);
+    return true;
   }
 
   sql_type= fld_type;
@@ -245,12 +243,12 @@
       {
         my_error(ER_TOO_BIG_PRECISION, MYF(0), length, fld_name,
                 DECIMAL_MAX_PRECISION);
-        return(true);
+        return true;
       }
       if (length < decimals)
       {
         my_error(ER_M_BIGGER_THAN_D, MYF(0), fld_name);
-        return(true);
+        return true;
       }
       length= class_decimal_precision_to_length(length, decimals, fld_type_modifier & UNSIGNED_FLAG);
       pack_length= class_decimal_get_binary_size(length, decimals);
@@ -276,7 +274,7 @@
           decimals != NOT_FIXED_DEC)
       {
         my_error(ER_M_BIGGER_THAN_D, MYF(0), fld_name);
-        return(true);
+        return true;
       }
       break;
     case DRIZZLE_TYPE_MICROTIME:
@@ -371,7 +369,7 @@
     if (res->length())
     {
       my_error(ER_BLOB_CANT_HAVE_DEFAULT, MYF(0), field_name);
-      return(true);
+      return true;
     }
   }
 

=== modified file 'drizzled/current_session.cc'
--- drizzled/current_session.cc	2011-02-17 00:14:13 +0000
+++ drizzled/current_session.cc	2011-06-21 14:55:36 +0000
@@ -20,30 +20,35 @@
 #include <config.h>
 #include <drizzled/current_session.h>
 
-namespace drizzled
-{
-
-static MySessionVar THR_Session;
-static MyMemoryRootVar THR_Mem_root;
-
-MySessionVar &currentSession(void)
-{
-  return THR_Session;
-}
-
-MyMemoryRootVar &currentMemRoot(void)
-{
-  return THR_Mem_root;
-}
-
-Session *_current_session(void)
+namespace drizzled {
+
+static boost::thread_specific_ptr<Session> THR_Session;
+static boost::thread_specific_ptr<memory::Root> THR_Mem_root;
+
+Session* _current_session()
 {
   return THR_Session.get();
 }
 
-memory::Root *current_mem_root(void)
-{
-  return *(currentMemRoot().get());
+memory::Root* current_mem_root()
+{
+  return THR_Mem_root.get();
+}
+
+void setCurrentSession(Session* v)
+{
+  if (v)
+    THR_Session.reset(v);
+  else
+    THR_Session.release();
+}
+
+void setCurrentMemRoot(memory::Root* v)
+{
+  if (v)
+    THR_Mem_root.reset(v);
+  else
+    THR_Mem_root.release();
 }
 
 } /* namespace drizzled */

=== modified file 'drizzled/current_session.h'
--- drizzled/current_session.h	2011-03-28 21:07:04 +0000
+++ drizzled/current_session.h	2011-06-21 14:55:36 +0000
@@ -31,10 +31,7 @@
 #define current_session ::drizzled::_current_session()
 memory::Root *current_mem_root();
 
-typedef boost::thread_specific_ptr<Session> MySessionVar;
-typedef boost::thread_specific_ptr<memory::Root *> MyMemoryRootVar;
-
-MySessionVar &currentSession();
-MyMemoryRootVar &currentMemRoot();
+void setCurrentSession(Session*);
+void setCurrentMemRoot(memory::Root*);
 
 } /* namespace drizzled */

=== modified file 'drizzled/cursor.cc'
--- drizzled/cursor.cc	2011-03-21 18:32:26 +0000
+++ drizzled/cursor.cc	2011-06-22 17:21:46 +0000
@@ -89,8 +89,7 @@
     on this->table->mem_root and we will not be able to reclaim that memory
     when the clone Cursor object is destroyed.
   */
-  if (!(new_handler->ref= (unsigned char*) mem_root->alloc_root(ALIGN_SIZE(ref_length)*2)))
-    return NULL;
+  new_handler->ref= mem_root->alloc(ALIGN_SIZE(ref_length)*2);
 
   identifier::Table identifier(getTable()->getShare()->getSchemaName(),
                              getTable()->getShare()->getTableName(),
@@ -249,13 +248,9 @@
     (void) extra(HA_EXTRA_NO_READCHECK);	// Not needed in SQL
 
     /* ref is already allocated for us if we're called from Cursor::clone() */
-    if (!ref && !(ref= (unsigned char*) getTable()->alloc_root(ALIGN_SIZE(ref_length)*2)))
-    {
-      close();
-      error=HA_ERR_OUT_OF_MEM;
-    }
-    else
-      dup_ref=ref+ALIGN_SIZE(ref_length);
+    if (!ref)
+      ref= getTable()->alloc(ALIGN_SIZE(ref_length)*2);
+    dup_ref=ref+ALIGN_SIZE(ref_length);
   }
   return error;
 }

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2011-06-16 16:39:05 +0000
+++ drizzled/drizzled.cc	2011-06-22 16:36:40 +0000
@@ -610,7 +610,7 @@
     unlink(session);
 }
 
-void Session::unlink(Session::shared_ptr &session)
+void Session::unlink(const Session::shared_ptr& session)
 {
   --connection_count;
 

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2011-06-20 11:52:00 +0000
+++ drizzled/field.cc	2011-06-22 14:19:44 +0000
@@ -612,7 +612,7 @@
 
 void *Field::operator new(size_t size, memory::Root *mem_root)
 {
-  return mem_root->alloc_root(static_cast<uint32_t>(size));
+  return mem_root->alloc(size);
 }
 
 enum_field_types Field::field_type_merge(enum_field_types a,
@@ -1037,7 +1037,7 @@
 
 Field *Field::new_field(memory::Root *root, Table *new_table, bool)
 {
-  Field* tmp= (Field*) root->memdup_root((char*) this,size_of());
+  Field* tmp= (Field*) root->memdup(this,size_of());
   if (tmp->table->maybe_null)
     tmp->flags&= ~NOT_NULL_FLAG;
   tmp->table= new_table;
@@ -1064,7 +1064,7 @@
 
 Field *Field::clone(memory::Root *root, Table *new_table)
 {
-  Field *tmp= (Field*) root->memdup_root((char*) this,size_of());
+  Field *tmp= (Field*) root->memdup(this,size_of());
   tmp->init(new_table);
   tmp->move_field_offset((ptrdiff_t) (new_table->getInsertRecord() - new_table->getDefaultValues()));
   return tmp;

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2011-06-20 15:04:56 +0000
+++ drizzled/field.h	2011-06-22 15:11:11 +0000
@@ -362,15 +362,13 @@
     return false;
   }
   virtual void free() {}
-  virtual Field *new_field(memory::Root *root,
-                           Table *new_table,
-                           bool keep_type);
+  virtual Field *new_field(memory::Root*, Table*, bool keep_type);
   virtual Field *new_key_field(memory::Root *root, Table *new_table,
                                unsigned char *new_ptr,
                                unsigned char *new_null_ptr,
                                uint32_t new_null_bit);
   /** This is used to generate a field in Table from TableShare */
-  Field *clone(memory::Root *mem_root, Table *new_table);
+  Field* clone(memory::Root*, Table*);
   void move_field(unsigned char *ptr_arg,unsigned char *null_ptr_arg,unsigned char null_bit_arg)
   {
     ptr= ptr_arg;

=== modified file 'drizzled/function/func.cc'
--- drizzled/function/func.cc	2011-05-12 23:43:47 +0000
+++ drizzled/function/func.cc	2011-06-21 18:18:14 +0000
@@ -156,8 +156,7 @@
       args= tmp_arg;
     else
     {
-      if (!(args=(Item**) getSession().getMemRoot()->allocate(sizeof(Item*)*arg_count)))
-        return;
+      args=(Item**) getSession().mem.alloc(sizeof(Item*)*arg_count);
     }
     memcpy(args, item->args, sizeof(Item*)*arg_count);
   }

=== modified file 'drizzled/function/str/pad.cc'
--- drizzled/function/str/pad.cc	2011-04-15 11:33:18 +0000
+++ drizzled/function/str/pad.cc	2011-06-22 17:45:22 +0000
@@ -66,19 +66,16 @@
 String *Item_func_rpad::val_str(String *str)
 {
   assert(fixed == 1);
+  null_value=1;
   uint32_t res_byte_length,res_char_length,pad_char_length,pad_byte_length;
-  char *to;
   const char *ptr_pad;
   /* must be int64_t to avoid truncation */
   int64_t count= args[1]->val_int();
-  int64_t byte_count;
   String *res= args[0]->val_str(str);
   String *rpad= args[2]->val_str(&rpad_str);
 
-  if (!res || args[1]->null_value || !rpad ||
-      ((count < 0) && !args[1]->unsigned_flag))
-    goto err;
-  null_value=0;
+  if (!res || args[1]->null_value || !rpad || ((count < 0) && !args[1]->unsigned_flag))
+    return 0;
   /* Assumes that the maximum length of a String is < INT32_MAX. */
   /* Set here so that rest of code sees out-of-bound value as such. */
   if ((uint64_t) count > INT32_MAX)
@@ -86,26 +83,25 @@
   if (count <= (res_char_length= res->numchars()))
   {						// String to pad is big enough
     res->length(res->charpos((int) count));	// Shorten result if longer
-    return (res);
+    null_value=0;
+    return res;
   }
   pad_char_length= rpad->numchars();
 
-  byte_count= count * collation.collation->mbmaxlen;
+  int64_t byte_count= count * collation.collation->mbmaxlen;
   if ((uint64_t) byte_count > session.variables.max_allowed_packet)
   {
     push_warning_printf(&session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
 			ER_WARN_ALLOWED_PACKET_OVERFLOWED,
 			ER(ER_WARN_ALLOWED_PACKET_OVERFLOWED),
 			func_name(), session.variables.max_allowed_packet);
-    goto err;
+    return 0;
   }
   if (args[2]->null_value || !pad_char_length)
-    goto err;
+    return 0;
   res_byte_length= res->length();	/* Must be done before alloc_buffer */
-  if (!(res= alloc_buffer(res,str,&tmp_value, (ulong) byte_count)))
-    goto err;
-
-  to= (char*) res->ptr()+res_byte_length;
+  res= alloc_buffer(res,str,&tmp_value, (ulong) byte_count);
+  char* to= (char*) res->ptr()+res_byte_length;
   ptr_pad=rpad->ptr();
   pad_byte_length= rpad->length();
   count-= res_char_length;
@@ -121,11 +117,8 @@
     to+= pad_byte_length;
   }
   res->length(to- (char*) res->ptr());
-  return (res);
-
- err:
-  null_value=1;
-  return 0;
+  null_value=0;
+  return res;
 }
 
 
@@ -207,7 +200,7 @@
 
   if (args[2]->null_value || !pad_char_length)
     goto err;
-  str->alloc((uint32_t) byte_count);
+  str->alloc((size_t) byte_count);
   str->length(0);
   str->set_charset(collation.collation);
   count-= res_char_length;

=== modified file 'drizzled/internal/m_string.h'
--- drizzled/internal/m_string.h	2011-04-20 23:31:05 +0000
+++ drizzled/internal/m_string.h	2011-06-21 17:27:41 +0000
@@ -41,10 +41,8 @@
 
 #include <drizzled/visibility.h>
 
-namespace drizzled
-{
-namespace internal
-{
+namespace drizzled {
+namespace internal {
 
 extern void bmove_upp(unsigned char *dst,const unsigned char *src,size_t len);
 
@@ -64,7 +62,8 @@
 extern	char *strxncpy(char *dst,size_t len, const char *src, ...);
 
 /* Conversion routines */
-typedef enum {
+typedef enum 
+{
   MY_GCVT_ARG_FLOAT,
   MY_GCVT_ARG_DOUBLE
 } my_gcvt_arg_type;

=== modified file 'drizzled/internal/my_open.cc'
--- drizzled/internal/my_open.cc	2011-03-18 16:51:42 +0000
+++ drizzled/internal/my_open.cc	2011-06-22 16:36:40 +0000
@@ -25,10 +25,8 @@
 #include <cstring>
 
 
-namespace drizzled
-{
-namespace internal
-{
+namespace drizzled {
+namespace internal {
 
 /*
   Open a file

=== modified file 'drizzled/internal/my_sync.cc'
--- drizzled/internal/my_sync.cc	2011-02-17 00:14:13 +0000
+++ drizzled/internal/my_sync.cc	2011-06-22 20:05:58 +0000
@@ -84,7 +84,7 @@
     else if (my_flags & MY_WME)
       my_error(EE_SYNC, MYF(ME_BELL+ME_WAITTANG), "unknown", errno);
   }
-  return(res);
+  return res;
 } /* my_sync */
 
 
@@ -121,7 +121,7 @@
   }
   else
     res= 1;
-  return(res);
+  return res;
 }
 #else
 int my_sync_dir(const char *, myf)

=== modified file 'drizzled/item/cache.h'
--- drizzled/item/cache.h	2011-03-14 05:40:28 +0000
+++ drizzled/item/cache.h	2011-06-21 16:06:22 +0000
@@ -57,8 +57,7 @@
 
   void set_used_tables(table_map map) { used_table_map= map; }
 
-  virtual bool allocate(uint32_t)
-  { return 0; }
+  virtual void allocate(uint32_t) {};
   virtual bool setup(Item *item)
   {
     example= item;

=== modified file 'drizzled/item/cache_int.h'
--- drizzled/item/cache_int.h	2011-03-14 05:40:28 +0000
+++ drizzled/item/cache_int.h	2011-06-21 16:06:22 +0000
@@ -21,13 +21,10 @@
 
 #include <drizzled/item/cache.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
-class Item_cache_int: public Item_cache
+class Item_cache_int : public Item_cache
 {
-protected:
-  int64_t value;
 public:
   Item_cache_int(): Item_cache(), value(0) {}
   Item_cache_int(enum_field_types field_type_arg):
@@ -41,6 +38,8 @@
   type::Decimal *val_decimal(type::Decimal *);
   enum Item_result result_type() const { return INT_RESULT; }
   bool result_as_int64_t() { return true; }
+protected:
+  int64_t value;
 };
 
 } /* namespace drizzled */

=== modified file 'drizzled/item/cache_row.cc'
--- drizzled/item/cache_row.cc	2011-02-17 00:14:13 +0000
+++ drizzled/item/cache_row.cc	2011-06-21 16:06:22 +0000
@@ -86,24 +86,23 @@
 }
 
 
-bool Item_cache_row::allocate(uint32_t num)
+void Item_cache_row::allocate(uint32_t num)
 {
   item_count= num;
-  return (!(values=
-            (Item_cache **) getSession().calloc(sizeof(Item_cache *)*item_count)));
+  values= (Item_cache **) getSession().mem.calloc(sizeof(Item_cache *)*item_count);
 }
 
 
 bool Item_cache_row::setup(Item * item)
 {
   example= item;
-  if (!values && allocate(item->cols()))
-    return 1;
+  if (!values)
+    allocate(item->cols());
   for (uint32_t i= 0; i < item_count; i++)
   {
     Item *el= item->element_index(i);
-    Item_cache *tmp;
-    if (!(tmp= values[i]= Item_cache::get_cache(el)))
+    Item_cache *tmp= values[i]= Item_cache::get_cache(el);
+    if (!tmp)
       return 1;
     tmp->setup(el);
   }

=== modified file 'drizzled/item/cache_row.h'
--- drizzled/item/cache_row.h	2011-03-29 10:15:45 +0000
+++ drizzled/item/cache_row.h	2011-06-21 16:06:22 +0000
@@ -37,7 +37,7 @@
     'allocate' used only in row transformer, to preallocate space for row
     cache.
   */
-  bool allocate(uint32_t num);
+  void allocate(uint32_t num);
   /*
     'setup' is needed only by row => it not called by simple row subselect
     (only by IN subselect (in subselect optimizer))

=== modified file 'drizzled/item/cmpfunc.cc'
--- drizzled/item/cmpfunc.cc	2011-03-29 20:45:43 +0000
+++ drizzled/item/cmpfunc.cc	2011-06-21 18:18:14 +0000
@@ -3357,7 +3357,7 @@
 void cmp_item_row::alloc_comparators()
 {
   if (!comparators)
-    comparators= (cmp_item **) current_session->calloc(sizeof(cmp_item *)*n);
+    comparators= (cmp_item **) current_session->mem.calloc(sizeof(cmp_item *)*n);
 }
 
 
@@ -4482,9 +4482,7 @@
       {
         pattern     = first + 1;
         pattern_len = (int) len - 2;
-        int *suff = (int*) session->getMemRoot()->allocate((int) (sizeof(int)*
-                                                                  ((pattern_len + 1)*2+
-                                                                   alphabet_size)));
+        int *suff = (int*) session->mem.alloc(sizeof(int) * ((pattern_len + 1)*2+ alphabet_size));
         bmGs      = suff + pattern_len + 1;
         bmBc      = bmGs + pattern_len + 1;
         turboBM_compute_good_suffix_shifts(suff);

=== modified file 'drizzled/item/field.cc'
--- drizzled/item/field.cc	2011-05-28 16:23:09 +0000
+++ drizzled/item/field.cc	2011-06-22 20:05:58 +0000
@@ -34,8 +34,7 @@
 
 #include <boost/dynamic_bitset.hpp>
 
-namespace drizzled
-{
+namespace drizzled {
 
 /**
   Store the pointer to this item field into a list if not already there.
@@ -63,10 +62,10 @@
   while ((curr_item= item_list_it++))
   {
     if (curr_item->eq(this, 1))
-      return(false); /* Already in the set. */
+      return false; /* Already in the set. */
   }
   item_list->push_back(this);
-  return(false);
+  return false;
 }
 
 
@@ -1197,7 +1196,7 @@
     res= field_conv(to,result_field);
     null_value=0;
   }
-  return(res);
+  return res;
 }
 
 

=== modified file 'drizzled/item/string.cc'
--- drizzled/item/string.cc	2011-05-05 10:53:09 +0000
+++ drizzled/item/string.cc	2011-06-21 17:27:41 +0000
@@ -30,7 +30,7 @@
   String tmp, cstr, *ostr= val_str(&tmp);
   cstr.copy(ostr->ptr(), ostr->length(), tocs);
   Item_string* conv= new Item_string(cstr.ptr(), cstr.length(), cstr.charset(), collation.derivation);
-  char* ptr= getSession().strmake(cstr.ptr(), cstr.length());
+  char* ptr= getSession().mem.strmake(cstr);
 
   conv->str_value.set(ptr, cstr.length(), cstr.charset());
   /* Ensure that no one is going to change the result string */

=== modified file 'drizzled/item/subselect.cc'
--- drizzled/item/subselect.cc	2011-03-21 18:32:26 +0000
+++ drizzled/item/subselect.cc	2011-06-22 20:05:58 +0000
@@ -353,7 +353,7 @@
   {
     /* Always compute IN for the first row as the cache is not valid for it. */
     if (!first_execution)
-      return(false);
+      return false;
     first_execution= false;
   }
 
@@ -1122,8 +1122,7 @@
 
   if (!abort_on_null && left_expr->maybe_null && !pushed_cond_guards)
   {
-    if (!(pushed_cond_guards= (bool*)join->session->getMemRoot()->allocate(sizeof(bool))))
-      return(RES_ERROR);
+    pushed_cond_guards= (bool*)join->session->mem.alloc(sizeof(bool));
     pushed_cond_guards[0]= true;
   }
 
@@ -1391,9 +1390,7 @@
 
     if (!abort_on_null && left_expr->maybe_null && !pushed_cond_guards)
     {
-      if (!(pushed_cond_guards= (bool*)join->session->getMemRoot()->allocate(sizeof(bool) *
-                                                        left_expr->cols())))
-        return(RES_ERROR);
+      pushed_cond_guards= (bool*)join->session->mem.alloc(sizeof(bool) * left_expr->cols());
       for (uint32_t i= 0; i < cols_num; i++)
         pushed_cond_guards[i]= true;
     }
@@ -1731,7 +1728,7 @@
   }
 err:
   session->setWhere(save_where);
-  return(res);
+  return res;
 }
 
 
@@ -1794,10 +1791,8 @@
     subselect_single_select_engine *old_engine_ptr;
 
     old_engine_ptr= static_cast<subselect_single_select_engine *>(engine);
-
-    if (!(new_engine= new subselect_hash_sj_engine(session, this,
-                                                   old_engine_ptr)) ||
-        new_engine->init_permanent(unit->get_unit_column_types()))
+    new_engine= new subselect_hash_sj_engine(session, this, old_engine_ptr);
+    if (new_engine->init_permanent(unit->get_unit_column_types()))
     {
       Item_subselect::trans_res new_trans_res;
       /*
@@ -1809,9 +1804,7 @@
       new_engine= NULL;
       exec_method= NOT_TRANSFORMED;
       if (left_expr->cols() == 1)
-        new_trans_res= single_value_in_to_exists_transformer(
-                           old_engine_ptr->join,
-                           Eq_creator::instance());
+        new_trans_res= single_value_in_to_exists_transformer(old_engine_ptr->join, Eq_creator::instance());
       else
         new_trans_res= row_value_in_to_exists_transformer(old_engine_ptr->join);
       res= (new_trans_res != Item_subselect::RES_OK);
@@ -1837,11 +1830,10 @@
       we should set the correct limit if given in the query.
     */
     unit->global_parameters->select_limit= NULL;
-    if ((res= new_engine->init_runtime()))
-      return(res);
+    new_engine->init_runtime();
   }
 
-  return(res);
+  return res;
 }
 
 
@@ -2167,9 +2159,7 @@
       session->lex().current_select= save_select;
       return(join->error ? join->error : 1);
     }
-    if (save_join_if_explain())
-     return(1);
-
+    save_join_if_explain();
     if (item->engine_changed)
     {
       return(1);
@@ -2249,8 +2239,7 @@
   return(0);
 }
 
-bool 
-subselect_single_select_engine::save_join_if_explain()
+void subselect_single_select_engine::save_join_if_explain()
 {
   /*
     Save this JOIN to join->tmp_join since the original layout will be
@@ -2280,10 +2269,8 @@
     */
     select_lex->uncacheable.set(UNCACHEABLE_EXPLAIN);
     select_lex->master_unit()->uncacheable.set(UNCACHEABLE_EXPLAIN);
-    if (join->init_save_join_tab())
-      return true;
+    join->init_save_join_tab();
   }
-  return false;
 }
 
 
@@ -3023,14 +3010,11 @@
     result stream in a temporary table. The temporary table itself is
     managed (created/filled/etc) internally by the interceptor.
   */
-  if (!(tmp_result_sink= new select_union))
-    return(true);
+  tmp_result_sink= new select_union;
 
-  if (tmp_result_sink->create_result_table(
-                         session, tmp_columns, true,
-                         session->options | TMP_TABLE_ALL_COLUMNS,
-                         "materialized subselect"))
-    return(true);
+  if (tmp_result_sink->create_result_table(session, tmp_columns, true, 
+    session->options | TMP_TABLE_ALL_COLUMNS, "materialized subselect"))
+    return true;
 
   tmp_table= tmp_result_sink->table;
   tmp_key= tmp_table->key_info;
@@ -3053,7 +3037,7 @@
     tmp_table= NULL;
     delete result;
     result= NULL;
-    return(true);
+    return true;
   }
   result= tmp_result_sink;
 
@@ -3073,20 +3057,14 @@
     - here we initialize only those members that are used by
       subselect_uniquesubquery_engine, so these objects are incomplete.
   */
-  if (!(tab= (JoinTable*) session->getMemRoot()->allocate(sizeof(JoinTable))))
-    return(true);
+  tab= (JoinTable*) session->mem.alloc(sizeof(JoinTable));
   new (tab) JoinTable();
   tab->table= tmp_table;
   tab->ref.key= 0; /* The only temp table index. */
   tab->ref.key_length= tmp_key->key_length;
-  if (!(tab->ref.key_buff=
-        (unsigned char*) session->calloc(ALIGN_SIZE(tmp_key->key_length) * 2)) ||
-      !(tab->ref.key_copy=
-        (StoredKey**) session->getMemRoot()->allocate((sizeof(StoredKey*) *
-                                  (tmp_key_parts + 1)))) ||
-      !(tab->ref.items=
-        (Item**) session->getMemRoot()->allocate(sizeof(Item*) * tmp_key_parts)))
-    return(true);
+  tab->ref.key_buff= (unsigned char*) session->mem.calloc(ALIGN_SIZE(tmp_key->key_length) * 2);
+  tab->ref.key_copy= (StoredKey**) session->mem.alloc((sizeof(StoredKey*) * (tmp_key_parts + 1)));
+  tab->ref.items= (Item**) session->mem.alloc(sizeof(Item*) * tmp_key_parts);
 
   KeyPartInfo *cur_key_part= tmp_key->key_part;
   StoredKey **ref_key= tab->ref.key_copy;
@@ -3112,7 +3090,7 @@
   tab->ref.key_err= 1;
   tab->ref.key_parts= tmp_key_parts;
 
-  return(false);
+  return false;
 }
 
 
@@ -3124,7 +3102,7 @@
   @retval false if success
 */
 
-bool subselect_hash_sj_engine::init_runtime()
+void subselect_hash_sj_engine::init_runtime()
 {
   /*
     Create and optimize the JOIN that will be used to materialize
@@ -3134,7 +3112,6 @@
   /* Let our engine reuse this query plan for materialization. */
   materialize_join= materialize_engine->join;
   materialize_join->change_result(result);
-  return false;
 }
 
 
@@ -3191,8 +3168,7 @@
     if ((res= materialize_join->optimize()))
       goto err;
 
-    if (materialize_engine->save_join_if_explain())
-      goto err;
+    materialize_engine->save_join_if_explain();
 
     materialize_join->exec();
     if ((res= test(materialize_join->error || session->is_fatal_error)))
@@ -3220,7 +3196,7 @@
       empty_result_set= true;
       item_in->value= false;
       /* TODO: check we need this: item_in->null_value= false; */
-      return(false);
+      return false;
     }
     /* Set tmp_param only if its usable, i.e. tmp_param->copy_field != NULL. */
     tmp_param= &(item_in->unit->outer_select()->join->tmp_table_param);
@@ -3230,7 +3206,7 @@
 err:
     session->lex().current_select= save_select;
     if (res)
-      return(res);
+      return res;
   }
 
   /*

=== modified file 'drizzled/item/subselect.h'
--- drizzled/item/subselect.h	2011-03-29 10:48:07 +0000
+++ drizzled/item/subselect.h	2011-06-21 15:57:11 +0000
@@ -490,7 +490,7 @@
   bool is_executed() const { return executed; }
   bool no_rows();
   virtual enum_engine_type engine_type() { return SINGLE_SELECT_ENGINE; }
-  bool save_join_if_explain();
+  void save_join_if_explain();
 
   friend class subselect_hash_sj_engine;
   friend class Item_in_subselect;
@@ -676,7 +676,7 @@
   ~subselect_hash_sj_engine();
 
   bool init_permanent(List<Item> *tmp_columns);
-  bool init_runtime();
+  void init_runtime();
   void cleanup();
   int prepare() { return 0; }
   int exec();

=== modified file 'drizzled/item/sum.cc'
--- drizzled/item/sum.cc	2011-03-28 02:46:21 +0000
+++ drizzled/item/sum.cc	2011-06-22 20:05:58 +0000
@@ -413,8 +413,7 @@
   if (arg_count <= 2)
     args=tmp_args;
   else
-    if (!(args= (Item**) session->getMemRoot()->allocate(sizeof(Item*)*arg_count)))
-      return;
+    args= (Item**) session->mem.alloc(sizeof(Item*)*arg_count);
   memcpy(args, item->args, sizeof(Item*)*arg_count);
 }
 
@@ -2658,7 +2657,7 @@
         uint32_t *length;
         compare_key= (qsort_cmp2) composite_key_cmp;
         cmp_arg= (void*) this;
-        field_lengths= (uint32_t*) session->getMemRoot()->allocate(table->getShare()->sizeFields() * sizeof(uint32_t));
+        field_lengths= (uint32_t*) session->mem.alloc(table->getShare()->sizeFields() * sizeof(uint32_t));
         for (tree_key_length= 0, length= field_lengths, field= table->getFields();
              field < field_end; ++field, ++length)
         {
@@ -3204,10 +3203,10 @@
     assertion here when this is fixed.
   */
   if (table || tree)
-    return(false);
+    return false;
 
   if (!(tmp_table_param= new Tmp_Table_Param))
-    return(true);
+    return true;
 
   /* We'll convert all blobs to varchar fields in the temporary table */
   tmp_table_param->convert_blob_length= max_length *
@@ -3223,7 +3222,7 @@
       if (item->is_null())
       {
         always_null= 1;
-        return(false);
+        return false;
       }
     }
   }
@@ -3237,7 +3236,7 @@
   */
   if (arg_count_order &&
       setup_order(session, args, context->table_list, list, all_fields, *order))
-    return(true);
+    return true;
 
   count_field_types(select_lex, tmp_table_param, all_fields, 0);
   tmp_table_param->force_copy_fields= force_copy_fields;
@@ -3266,7 +3265,7 @@
                                 (select_lex->options | session->options),
                                 HA_POS_ERROR, (char*) "")))
   {
-    return(true);
+    return true;
   }
 
   table->cursor->extra(HA_EXTRA_NO_ROWS);
@@ -3300,7 +3299,7 @@
                               tree_key_length,
                               (size_t)session->variables.max_heap_table_size);
 
-  return(false);
+  return false;
 }
 
 

=== modified file 'drizzled/item/type_holder.cc'
--- drizzled/item/type_holder.cc	2011-02-17 00:14:13 +0000
+++ drizzled/item/type_holder.cc	2011-06-22 20:05:58 +0000
@@ -31,8 +31,7 @@
 
 using namespace std;
 
-namespace drizzled
-{
+namespace drizzled {
 
 Item_type_holder::Item_type_holder(Session *session, Item *item)
   :Item(session, item), enum_set_typelib(0), fld_type(get_real_type(item))
@@ -149,7 +148,7 @@
                  item->collation.collation->name,
                  item->collation.derivation_name(),
                  "UNION");
-        return(true);
+        return true;
       }
       /*
         To figure out max_length, we have to take into account possible
@@ -196,7 +195,7 @@
   /* Remember decimal integer part to be used in DECIMAL_RESULT handleng */
   prev_decimal_int_part= decimal_int_part();
 
-  return(false);
+  return false;
 }
 
 

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2011-06-14 20:59:28 +0000
+++ drizzled/join.cc	2011-06-22 20:05:58 +0000
@@ -104,14 +104,14 @@
                                              uint32_t depth,
                                              uint32_t prune_level);
 static uint32_t determine_search_depth(Join* join);
-static bool make_simple_join(Join *join,Table *tmp_table);
+static void make_simple_join(Join*, Table*);
 static void make_outerjoin_info(Join *join);
 static bool make_join_select(Join *join, optimizer::SqlSelect *select,COND *item);
-static bool make_join_readinfo(Join *join);
+static void make_join_readinfo(Join&);
 static void update_depend_map(Join *join);
 static void update_depend_map(Join *join, Order *order);
 static Order *remove_constants(Join *join,Order *first_order,COND *cond, bool change_list, bool *simple_order);
-static int return_zero_rows(Join *join,
+static void return_zero_rows(Join *join,
                             select_result *res,
                             TableList *tables,
                             List<Item> &fields,
@@ -314,8 +314,7 @@
 
 bool Join::is_top_level_join() const
 {
-  return (unit == &session->lex().unit && (unit->fake_select_lex == 0 ||
-                                          select_lex == unit->fake_select_lex));
+  return unit == &session->lex().unit && (unit->fake_select_lex == 0 || select_lex == unit->fake_select_lex);
 }
 
 /**
@@ -366,31 +365,25 @@
   /* Check that all tables, fields, conds and order are ok */
 
   if (!(select_options & OPTION_SETUP_TABLES_DONE) &&
-      setup_tables_and_check_access(session, &select_lex->context, join_list,
-                                    tables_list, &select_lex->leaf_tables,
-                                    false))
+      setup_tables_and_check_access(session, &select_lex->context, join_list, tables_list, &select_lex->leaf_tables, false))
   {
       return(-1);
   }
 
   TableList *table_ptr;
-  for (table_ptr= select_lex->leaf_tables;
-       table_ptr;
-       table_ptr= table_ptr->next_leaf)
+  for (table_ptr= select_lex->leaf_tables; table_ptr; table_ptr= table_ptr->next_leaf)
   {
     tables++;
   }
 
 
-  if (setup_wild(session, fields_list, &all_fields, wild_num) ||
-      select_lex->setup_ref_array(session, og_num) ||
-      setup_fields(session, (*rref_pointer_array), fields_list, MARK_COLUMNS_READ,
-       &all_fields, 1) ||
-      setup_without_group(session, (*rref_pointer_array), tables_list,
-        select_lex->leaf_tables, fields_list,
-        all_fields, &conds, order, group_list,
-        &hidden_group_fields))
-    return(-1);
+  if (setup_wild(session, fields_list, &all_fields, wild_num))
+    return -1;
+  select_lex->setup_ref_array(session, og_num);
+  if (setup_fields(session, *rref_pointer_array, fields_list, MARK_COLUMNS_READ, &all_fields, 1) ||
+    setup_without_group(session, *rref_pointer_array, tables_list, select_lex->leaf_tables, fields_list,
+    all_fields, &conds, order, group_list, &hidden_group_fields))
+    return -1;
 
   ref_pointer_array= *rref_pointer_array;
 
@@ -1026,8 +1019,7 @@
         test(select_options & OPTION_BUFFER_RESULT)));
 
   // No cache for MATCH == 'Don't use join buffering when we use MATCH'.
-  if (make_join_readinfo(this))
-    return 1;
+  make_join_readinfo(*this);
 
   /* Create all structures needed for materialized subquery execution. */
   if (setup_subquery_materialization())
@@ -1231,8 +1223,7 @@
       if (!group_list && ! exec_tmp_table1->distinct && order && simple_order)
       {
         session->set_proc_info("Sorting for order");
-        if (create_sort_index(session, this, order,
-                              HA_POS_ERROR, HA_POS_ERROR, true))
+        if (create_sort_index(session, this, order, HA_POS_ERROR, HA_POS_ERROR, true))
         {
           return 1;
         }
@@ -1272,12 +1263,8 @@
       If this join belongs to an uncacheable subquery save
       the original join
     */
-    if (select_lex->uncacheable.any() && 
-        ! is_top_level_join() &&
-        init_save_join_tab())
-    {
-      return -1;
-    }
+    if (select_lex->uncacheable.any() && not is_top_level_join())
+      init_save_join_tab();
   }
 
   error= 0;
@@ -1353,26 +1340,20 @@
    @retval 0      success.
    @retval 1      error occurred.
 */
-bool Join::init_save_join_tab()
+void Join::init_save_join_tab()
 {
-  if (!(tmp_join= (Join*)session->getMemRoot()->allocate(sizeof(Join))))
-    return 1;
+  tmp_join= (Join*)session->mem.alloc(sizeof(Join));
 
   error= 0;              // Ensure that tmp_join.error= 0
   restore_tmp();
-
-  return 0;
 }
 
-bool Join::save_join_tab()
+void Join::save_join_tab()
 {
   if (! join_tab_save && select_lex->master_unit()->uncacheable.any())
   {
-    if (!(join_tab_save= (JoinTable*)session->getMemRoot()->duplicate((unsigned char*) join_tab,
-            sizeof(JoinTable) * tables)))
-      return 1;
+    join_tab_save= (JoinTable*)session->mem.memdup(join_tab, sizeof(JoinTable) * tables);
   }
-  return 0;
 }
 
 /**
@@ -1447,12 +1428,7 @@
 
   if (zero_result_cause)
   {
-    (void) return_zero_rows(this, result, select_lex->leaf_tables,
-                            *columns_list,
-          send_row_on_empty_set(),
-          select_options,
-          zero_result_cause,
-          having);
+    return_zero_rows(this, result, select_lex->leaf_tables, *columns_list, send_row_on_empty_set(), select_options, zero_result_cause, having);
     return;
   }
 
@@ -1587,8 +1563,7 @@
     {         /* Must copy to another table */
       /* Free first data from old join */
       curr_join->join_free();
-      if (make_simple_join(curr_join, curr_tmp_table))
-        return;
+      make_simple_join(curr_join, curr_tmp_table);
       calc_group_buffer(curr_join, group_list);
       count_field_types(select_lex, &curr_join->tmp_table_param,
       curr_join->tmp_all_fields1,
@@ -1631,12 +1606,9 @@
       if (curr_join->group_list)
       {
         session->set_proc_info("Creating sort index");
-        if (curr_join->join_tab == join_tab && save_join_tab())
-        {
-          return;
-        }
-        if (create_sort_index(session, curr_join, curr_join->group_list,
-                  HA_POS_ERROR, HA_POS_ERROR, false) ||
+        if (curr_join->join_tab == join_tab)
+          save_join_tab();
+        if (create_sort_index(session, curr_join, curr_join->group_list, HA_POS_ERROR, HA_POS_ERROR, false) ||
             make_group_fields(this, curr_join))
         {
           return;
@@ -1712,8 +1684,7 @@
       curr_join->select_distinct=0;
     }
     curr_tmp_table->reginfo.lock_type= TL_UNLOCK;
-    if (make_simple_join(curr_join, curr_tmp_table))
-      return;
+    make_simple_join(curr_join, curr_tmp_table);
     calc_group_buffer(curr_join, curr_join->group_list);
     count_field_types(select_lex, &curr_join->tmp_table_param, *curr_all_fields, 0);
 
@@ -1819,8 +1790,8 @@
           }
         }
       }
-      if (curr_join->join_tab == join_tab && save_join_tab())
-        return;
+      if (curr_join->join_tab == join_tab)
+        save_join_tab();
       /*
         Here we sort rows for order_st BY/GROUP BY clause, if the optimiser
         chose FILESORT to be faster than INDEX SCAN or there is no
@@ -2192,7 +2163,7 @@
   }
 
   /* This must use calloc() as rollup_make_fields depends on this */
-  sum_funcs= (Item_sum**) session->calloc(sizeof(Item_sum**) * (func_count+1) +
+  sum_funcs= (Item_sum**) session->mem.calloc(sizeof(Item_sum**) * (func_count+1) +
               sizeof(Item_sum***) * (group_parts+1));
   sum_funcs_end= (Item_sum***) (sum_funcs+func_count+1);
   return(sum_funcs == 0);
@@ -2221,7 +2192,7 @@
   Item *item;
 
   if (*sum_funcs && !recompute)
-    return(false); /* We have already initialized sum_funcs. */
+    return false; /* We have already initialized sum_funcs. */
 
   func= sum_funcs;
   while ((item=it++))
@@ -2243,15 +2214,14 @@
       sum_funcs_end[i]= func;
   }
   else if (rollup.getState() == Rollup::STATE_READY)
-    return(false);                         // Don't put end marker
+    return false;                         // Don't put end marker
   *func=0;          // End marker
-  return(false);
+  return false;
 }
 
 /** Allocate memory needed for other rollup functions. */
 bool Join::rollup_init()
 {
-  Item **ref_array;
 
   tmp_table_param.quick_group= 0; // Can't create groups in tmp table
   rollup.setState(Rollup::STATE_INITED);
@@ -2262,19 +2232,10 @@
   */
   tmp_table_param.group_parts= send_group_parts;
 
-  rollup.setNullItems((Item_null_result**) session->getMemRoot()->allocate((sizeof(Item*) +
-                                                                sizeof(Item**) +
-                                                                sizeof(List<Item>) +
-                                                                ref_pointer_array_size)
-                                                               * send_group_parts ));
-  if (! rollup.getNullItems())
-  {
-    return 1;
-  }
-
+  rollup.setNullItems((Item_null_result**) session->mem.alloc((sizeof(Item*) + sizeof(Item**) + sizeof(List<Item>) + ref_pointer_array_size) * send_group_parts));
   rollup.setFields((List<Item>*) (rollup.getNullItems() + send_group_parts));
   rollup.setRefPointerArrays((Item***) (rollup.getFields() + send_group_parts));
-  ref_array= (Item**) (rollup.getRefPointerArrays()+send_group_parts);
+  Item** ref_array= (Item**) (rollup.getRefPointerArrays()+send_group_parts);
 
   /*
     Prepare space for field list for the different levels
@@ -2298,8 +2259,7 @@
   }
 
   List<Item>::iterator it(all_fields.begin());
-  Item *item;
-  while ((item= it++))
+  while (Item* item= it++)
   {
     Order *group_tmp;
     bool found_in_group= 0;
@@ -2604,9 +2564,9 @@
   result= res;
   if (result->prepare(fields_list, select_lex->master_unit()))
   {
-    return(true);
+    return true;
   }
-  return(false);
+  return false;
 }
 
 /**
@@ -3406,9 +3366,7 @@
   optimizer::Position cur_pos;
 
   table_count=join->tables;
-  if (!(join->join_tab=join_tab=
-  (JoinTable*) session->getMemRoot()->allocate(sizeof(JoinTable)*table_count)))
-    return(true);
+  join->join_tab=join_tab= (JoinTable*) session->mem.alloc(sizeof(JoinTable)*table_count);
 
   for (i= 0; i < table_count; i++)
     new (join_tab+i) JoinTable();
@@ -3441,7 +3399,7 @@
         join->full_join=1;
     }
     else if (create_ref_for_key(join, j, keyuse, used_tables))
-      return(true);                        // Something went wrong
+      return true;                        // Something went wrong
   }
 
   for (i=0 ; i < table_count ; i++)
@@ -3533,7 +3491,7 @@
   */
   if (join->session->lex().is_single_level_stmt())
     join->session->status_var.last_query_cost= join->best_read;
-  return(false);
+  return false;
 }
 
 /**
@@ -4221,7 +4179,7 @@
     join->best_read= DBL_MAX;
     if (best_extension_by_limited_search(join, remaining_tables, idx, record_count,
                                          read_time, search_depth, prune_level))
-      return(true);
+      return true;
 
     if (size_remain <= search_depth)
     {
@@ -4229,7 +4187,7 @@
         'join->best_positions' contains a complete optimal extension of the
         current partial QEP.
       */
-      return(false);
+      return false;
     }
 
     /* select the first table in the optimal extension as most promising */
@@ -4398,7 +4356,7 @@
 {
   Session *session= join->session;
   if (session->getKilled())  // Abort
-    return(true);
+    return true;
 
   /*
      'join' is a partial plan with lower cost than the best plan so far,
@@ -4478,7 +4436,7 @@
                                              current_read_time,
                                              search_depth - 1,
                                              prune_level))
-          return(true);
+          return true;
         std::swap(join->best_ref[idx], *pos);
       }
       else
@@ -4501,7 +4459,7 @@
       restore_prev_nj_state(s);
     }
   }
-  return(false);
+  return false;
 }
 
 /**
@@ -4554,33 +4512,27 @@
   return search_depth;
 }
 
-static bool make_simple_join(Join *join,Table *tmp_table)
+static void make_simple_join(Join *join,Table *tmp_table)
 {
-  Table **tableptr;
-  JoinTable *join_tab;
-
   /*
     Reuse Table * and JoinTable if already allocated by a previous call
     to this function through Join::exec (may happen for sub-queries).
   */
   if (!join->table_reexec)
   {
-    if (!(join->table_reexec= (Table**) join->session->getMemRoot()->allocate(sizeof(Table*))))
-      return(true);
+    join->table_reexec= (Table**) join->session->mem.alloc(sizeof(Table*));
     if (join->tmp_join)
       join->tmp_join->table_reexec= join->table_reexec;
   }
   if (!join->join_tab_reexec)
   {
-    if (!(join->join_tab_reexec=
-          (JoinTable*) join->session->getMemRoot()->allocate(sizeof(JoinTable))))
-      return(true);
+    join->join_tab_reexec= (JoinTable*) join->session->mem.alloc(sizeof(JoinTable));
     new (join->join_tab_reexec) JoinTable();
     if (join->tmp_join)
       join->tmp_join->join_tab_reexec= join->join_tab_reexec;
   }
-  tableptr= join->table_reexec;
-  join_tab= join->join_tab_reexec;
+  Table** tableptr= join->table_reexec;
+  JoinTable* join_tab= join->join_tab_reexec;
 
   join->join_tab=join_tab;
   join->table=tableptr; tableptr[0]=tmp_table;
@@ -4614,8 +4566,6 @@
   join_tab->read_record.init();
   tmp_table->status=0;
   tmp_table->null_row=0;
-
-  return false;
 }
 
 /**
@@ -4839,11 +4789,7 @@
       if (tmp || !cond || tab->type == AM_REF || tab->type == AM_REF_OR_NULL ||
           tab->type == AM_EQ_REF)
       {
-        optimizer::SqlSelect *sel= tab->select= ((optimizer::SqlSelect*)
-            session->getMemRoot()->duplicate((unsigned char*) select,
-              sizeof(*select)));
-        if (! sel)
-          return 1;			// End of memory
+        optimizer::SqlSelect *sel= tab->select= ((optimizer::SqlSelect*)session->mem.memdup(select, sizeof(*select)));
         /*
            If tab is an inner table of an outer join operation,
            add a match guard to the pushed down predicate.
@@ -4977,8 +4923,7 @@
                                          current_map,
                                          current_map, 0)))
             {
-              tab->cache.select= (optimizer::SqlSelect*)
-                session->getMemRoot()->duplicate((unsigned char*) sel, sizeof(optimizer::SqlSelect));
+              tab->cache.select= (optimizer::SqlSelect*)session->mem.memdup(sel, sizeof(optimizer::SqlSelect));
               tab->cache.select->cond= tmp;
               tab->cache.select->read_tables= join->const_table_map;
             }
@@ -5094,13 +5039,13 @@
     false - OK
     true  - Out of memory
 */
-static bool make_join_readinfo(Join *join)
+static void make_join_readinfo(Join& join)
 {
   bool sorted= true;
 
-  for (uint32_t i= join->const_tables ; i < join->tables ; i++)
+  for (uint32_t i= join.const_tables; i < join.tables; i++)
   {
-    JoinTable *tab=join->join_tab+i;
+    JoinTable *tab=join.join_tab+i;
     Table *table=tab->table;
     tab->read_record.table= table;
     tab->read_record.cursor= table->cursor;
@@ -5114,10 +5059,7 @@
 
     if (tab->insideout_match_tab)
     {
-      if (! (tab->insideout_buf= (unsigned char*) join->session->getMemRoot()->allocate(tab->table->key_info
-                                                                       [tab->index].
-                                                                       key_length)))
-        return true;
+      tab->insideout_buf= join.session->mem.alloc(tab->table->key_info[tab->index].key_length);
     }
 
     optimizer::AccessMethodFactory &factory= optimizer::AccessMethodFactory::singleton();
@@ -5136,9 +5078,7 @@
     access_method->getStats(table, tab);
   }
 
-  join->join_tab[join->tables-1].next_select= NULL; /* Set by do_select */
-
-  return false;
+  join.join_tab[join.tables-1].next_select= NULL; /* Set by do_select */
 }
 
 /** Update the dependency map for the tables. */
@@ -5263,24 +5203,13 @@
   return(first_order);
 }
 
-static int return_zero_rows(Join *join,
-                            select_result *result,
-                            TableList *tables,
-		                        List<Item> &fields,
-                            bool send_row,
-                            uint64_t select_options,
-                            const char *info,
-                            Item *having)
+static void return_zero_rows(Join *join, select_result *result, TableList *tables, List<Item> &fields, bool send_row, uint64_t select_options, const char *info, Item *having)
 {
   if (select_options & SELECT_DESCRIBE)
   {
-    optimizer::ExplainPlan planner(join,
-                                   false,
-                                   false,
-                                   false,
-                                   info);
+    optimizer::ExplainPlan planner(join, false, false, false, info);
     planner.printPlan();
-    return 0;
+    return;
   }
 
   join->join_free();
@@ -5296,15 +5225,13 @@
   if (send_row)
   {
     List<Item>::iterator it(fields.begin());
-    Item *item;
-    while ((item= it++))
+    while (Item* item= it++)
       item->no_rows_in_result();
     result->send_data(fields);
   }
   result->send_eof();				// Should be safe
   /* Update results for FOUND_ROWS */
   join->session->limit_found_rows= join->session->examined_row_count= 0;
-  return(0);
 }
 
 /**
@@ -5429,7 +5356,6 @@
 */
 static COND *simplify_joins(Join *join, List<TableList> *join_list, COND *conds, bool top)
 {
-  TableList *table;
   NestedJoin *nested_join;
   TableList *prev_table= 0;
   List<TableList>::iterator li(join_list->begin());
@@ -5438,7 +5364,7 @@
     Try to simplify join operations from join_list.
     The most outer join operation is checked for conversion first.
   */
-  while ((table= li++))
+  while (TableList* table= li++)
   {
     table_map used_tables;
     table_map not_null_tables= (table_map) 0;
@@ -5569,14 +5495,13 @@
     no ON expression and not a semi-join => can be flattened.
   */
   li= join_list->begin();
-  while ((table= li++))
+  while (TableList* table= li++)
   {
     nested_join= table->getNestedJoin();
     if (nested_join && !table->on_expr)
     {
-      TableList *tbl;
       List<TableList>::iterator it(nested_join->join_list.begin());
-      while ((tbl= it++))
+      while (TableList* tbl= it++)
       {
         tbl->setEmbedding(table->getEmbedding());
         tbl->setJoinList(table->getJoinList());
@@ -5589,18 +5514,12 @@
 
 static int remove_duplicates(Join *join, Table *entry,List<Item> &fields, Item *having)
 {
-  int error;
-  uint32_t reclength,offset;
-  uint32_t field_count;
-  Session *session= join->session;
-
   entry->reginfo.lock_type=TL_WRITE;
 
   /* Calculate how many saved fields there is in list */
-  field_count=0;
+  uint32_t field_count= 0;
   List<Item>::iterator it(fields.begin());
-  Item *item;
-  while ((item=it++))
+  while (Item* item=it++)
   {
     if (item->get_tmp_table_field() && ! item->const_item())
       field_count++;
@@ -5612,29 +5531,24 @@
     return(0);
   }
   Field **first_field=entry->getFields() + entry->getShare()->sizeFields() - field_count;
-  offset= (field_count ?
-           entry->getField(entry->getShare()->sizeFields() - field_count)->offset(entry->getInsertRecord()) : 0);
-  reclength= entry->getShare()->getRecordLength() - offset;
+  uint32_t offset= field_count ? entry->getField(entry->getShare()->sizeFields() - field_count)->offset(entry->getInsertRecord()) : 0;
+  uint32_t reclength= entry->getShare()->getRecordLength() - offset;
 
   entry->free_io_cache();				// Safety
   entry->cursor->info(HA_STATUS_VARIABLE);
+  int error;
   if (entry->getShare()->db_type() == heap_engine ||
       (!entry->getShare()->blob_fields &&
-       ((ALIGN_SIZE(reclength) + HASH_OVERHEAD) * entry->cursor->stats.records <
-        session->variables.sortbuff_size)))
+       ((ALIGN_SIZE(reclength) + HASH_OVERHEAD) * entry->cursor->stats.records < join->session->variables.sortbuff_size)))
   {
-    error= remove_dup_with_hash_index(join->session, entry,
-                                      field_count, first_field,
-                                      reclength, having);
+    error= remove_dup_with_hash_index(join->session, entry, field_count, first_field, reclength, having);
   }
   else
   {
     error= remove_dup_with_compare(join->session, entry, first_field, offset, having);
   }
-
   free_blobs(first_field);
-
-  return(error);
+  return error;
 }
 
 /**
@@ -5652,19 +5566,17 @@
                                bool *hidden_group_fields)
 {
   int res;
-  nesting_map save_allow_sum_func=session->lex().allow_sum_func ;
+  nesting_map save_allow_sum_func=session->lex().allow_sum_func;
 
   session->lex().allow_sum_func&= ~(1 << session->lex().current_select->nest_level);
   res= session->setup_conds(tables, conds);
 
   session->lex().allow_sum_func|= 1 << session->lex().current_select->nest_level;
-  res= res || setup_order(session, ref_pointer_array, tables, fields, all_fields,
-                          order);
+  res= res || setup_order(session, ref_pointer_array, tables, fields, all_fields, order);
   session->lex().allow_sum_func&= ~(1 << session->lex().current_select->nest_level);
-  res= res || setup_group(session, ref_pointer_array, tables, fields, all_fields,
-                          group, hidden_group_fields);
+  res= res || setup_group(session, ref_pointer_array, tables, fields, all_fields, group, hidden_group_fields);
   session->lex().allow_sum_func= save_allow_sum_func;
-  return(res);
+  return res;
 }
 
 /**
@@ -5702,11 +5614,10 @@
   optimizer::Position *partial_pos;
 
   table_count= join->tables;
-  stat= (JoinTable*) join->session->calloc(sizeof(JoinTable)*table_count);
-  stat_ref= (JoinTable**) join->session->getMemRoot()->allocate(sizeof(JoinTable*)*MAX_TABLES);
-  table_vector= (Table**) join->session->getMemRoot()->allocate(sizeof(Table*)*(table_count*2));
-  if (! stat || ! stat_ref || ! table_vector)
-    return 1;
+  stat= (JoinTable*) join->session->mem.calloc(sizeof(JoinTable)*table_count);
+  stat_ref= (JoinTable**) join->session->mem.alloc(sizeof(JoinTable*)*MAX_TABLES);
+  table_vector= (Table**) join->session->mem.alloc(sizeof(Table*)*(table_count*2));
+  // table_vector= new (join->session->mem) Table*[2 * table_count];
 
   join->best_ref=stat_vector;
 
@@ -5736,8 +5647,7 @@
     table->quick_keys.reset();
     table->reginfo.join_tab=s;
     table->reginfo.not_exists_optimize=0;
-    memset(table->const_key_parts, 0,
-           sizeof(key_part_map)*table->getShare()->sizeKeys());
+    memset(table->const_key_parts, 0, sizeof(key_part_map)*table->getShare()->sizeKeys());
     all_table_map|= table->map;
     s->join=join;
     s->info=0;					// For describe
@@ -6110,7 +6020,7 @@
     join->best_read= 1.0;
   }
   /* Generate an execution plan from the found optimal join order. */
-  return (join->session->getKilled() || get_best_combination(join));
+  return join->session->getKilled() || get_best_combination(join);
 }
 
 /**
@@ -6135,11 +6045,9 @@
 static uint32_t build_bitmap_for_nested_joins(List<TableList> *join_list, uint32_t first_unused)
 {
   List<TableList>::iterator li(join_list->begin());
-  TableList *table;
-  while ((table= li++))
+  while (TableList* table= li++)
   {
-    NestedJoin *nested_join;
-    if ((nested_join= table->getNestedJoin()))
+    if (NestedJoin* nested_join= table->getNestedJoin())
     {
       /*
         It is guaranteed by simplify_joins() function that a nested join
@@ -6182,15 +6090,15 @@
   for (; a && b; a=a->next,b=b->next)
   {
     if (!(*a->item)->eq(*b->item,1))
-      return (Table *) NULL;
+      return NULL;
     map|= a->item[0]->used_tables();
   }
   if (!map || (map & (RAND_TABLE_BIT | OUTER_REF_TABLE_BIT)))
-    return (Table *) NULL;
+    return NULL;
 
   for (; !(map & tables->table->map); tables= tables->next_leaf) {};
   if (map != tables->table->map)
-    return (Table *) NULL;				// More than one table
+    return NULL;				// More than one table
   return tables->table;
 }
 
@@ -6206,8 +6114,7 @@
 static void reset_nj_counters(List<TableList> *join_list)
 {
   List<TableList>::iterator li(join_list->begin());
-  TableList *table;
-  while ((table= li++))
+  while (TableList* table= li++)
   {
     NestedJoin *nested_join;
     if ((nested_join= table->getNestedJoin()))
@@ -6216,7 +6123,6 @@
       reset_nj_counters(&nested_join->join_list);
     }
   }
-  return;
 }
 
 /**
@@ -6316,12 +6222,10 @@
 static bool add_ref_to_table_cond(Session *session, JoinTable *join_tab)
 {
   if (!join_tab->ref.key_parts)
-    return(false);
+    return false;
 
   Item_cond_and *cond=new Item_cond_and();
   Table *table=join_tab->table;
-  if (!cond)
-    return(true);
 
   for (uint32_t i=0 ; i < join_tab->ref.key_parts ; i++)
   {
@@ -6330,7 +6234,7 @@
     cond->add(new Item_func_equal(new Item_field(field), value));
   }
   if (session->is_fatal_error)
-    return(true);
+    return true;
 
   if (!cond->fixed)
     cond->fix_fields(session, (Item**)&cond);

=== modified file 'drizzled/join.h'
--- drizzled/join.h	2011-03-28 21:40:10 +0000
+++ drizzled/join.h	2011-06-22 16:36:40 +0000
@@ -34,11 +34,8 @@
 
 namespace drizzled {
 
-class Join :public memory::SqlAlloc
+class Join : public memory::SqlAlloc, boost::noncopyable
 {
-  Join(const Join &rhs);                        /**< not implemented */
-  Join& operator=(const Join &rhs);             /**< not implemented */
-
   /**
    * Contains a partial query execution plan which is extended during
    * cost-based optimization.
@@ -293,8 +290,8 @@
   /** Cleanup this Join, possibly for reuse */
   void cleanup(bool full);
   void clear();
-  bool save_join_tab();
-  bool init_save_join_tab();
+  void save_join_tab();
+  void init_save_join_tab();
   bool send_row_on_empty_set()
   {
     return (do_send_rows && tmp_table_param.sum_func_count != 0 &&

=== modified file 'drizzled/main.cc'
--- drizzled/main.cc	2011-06-16 15:27:28 +0000
+++ drizzled/main.cc	2011-06-21 14:55:36 +0000
@@ -376,7 +376,7 @@
   /* Send server startup event */
   {
     Session::shared_ptr session= Session::make_shared(plugin::Listen::getNullClient(), catalog::local());
-    currentSession().reset(session.get());
+    setCurrentSession(session.get());
     transaction_services.sendStartupEvent(*session);
     plugin_startup_window(modules, *session.get());
   }
@@ -401,7 +401,7 @@
   /* Send server shutdown event */
   {
     Session::shared_ptr session= Session::make_shared(plugin::Listen::getNullClient(), catalog::local());
-    currentSession().reset(session.get());
+    setCurrentSession(session.get());
     transaction_services.sendShutdownEvent(*session.get());
   }
 

=== modified file 'drizzled/memory/multi_malloc.h'
--- drizzled/memory/multi_malloc.h	2011-03-14 05:40:28 +0000
+++ drizzled/memory/multi_malloc.h	2011-06-21 14:08:41 +0000
@@ -19,11 +19,11 @@
 
 #pragma once
 
-namespace drizzled
-{
-namespace memory
-{
+namespace drizzled {
+namespace memory {
+
 void* multi_malloc(bool zerofill, ...) __attribute__((malloc));
+
 } /* namespace memory */
 } /* namespace drizzled */
 

=== modified file 'drizzled/memory/root.cc'
--- drizzled/memory/root.cc	2011-06-14 21:15:09 +0000
+++ drizzled/memory/root.cc	2011-06-22 14:35:11 +0000
@@ -24,13 +24,14 @@
 #include <drizzled/memory/root.h>
 #include <drizzled/internal/my_sys.h>
 #include <drizzled/internal/m_string.h>
+#include <drizzled/sql_string.h>
 
 #include <algorithm>
 
 using namespace std;
 
-namespace drizzled
-{
+namespace drizzled {
+namespace memory {
 
 static const unsigned int MAX_BLOCK_TO_DROP= 4096;
 static const unsigned int MAX_BLOCK_USAGE_BEFORE_DROP= 10;
@@ -44,30 +45,24 @@
  * chunk for memory allocation and pre-allocates first block if specified.
  * Altough error can happen during execution of this function if
  * pre_alloc_size is non-0 it won't be reported. Instead it will be
- * reported as error in first alloc_root() on this memory root.
+ * reported as error in first alloc() on this memory root.
  *
  * @param  mem_root       memory root to initialize
  * @param  block_size     size of chunks (blocks) used for memory allocation
  *                       (It is external size of chunk i.e. it should include
  *                      memory required for internal structures, thus it
- *                      should be no less than memory::ROOT_MIN_BLOCK_SIZE)
+ *                      should be no less than ROOT_MIN_BLOCK_SIZE)
  *
  */
-void memory::Root::init_alloc_root(size_t block_size_arg)
+void Root::init(size_t block_size_arg)
 {
   free= used= pre_alloc= 0;
   min_malloc= 32;
-  block_size= block_size_arg - memory::ROOT_MIN_BLOCK_SIZE;
-  error_handler= 0;
+  block_size= block_size_arg - ROOT_MIN_BLOCK_SIZE;
   block_num= 4;			/* We shift this with >>2 */
   first_block_usage= 0;
 }
 
-memory::Root::~Root()
-{
-}
-
-
 /**
  * @details
  * Function aligns and assigns new value to block size; then it tries to
@@ -83,15 +78,15 @@
  *                        must be equal to or greater than block size,
  *                        otherwise means 'no prealloc'.
  */
-void memory::Root::reset_root_defaults(size_t block_size_arg, size_t pre_alloc_size)
+void Root::reset_defaults(size_t block_size_arg, size_t pre_alloc_size)
 {
-  block_size= block_size_arg - memory::ROOT_MIN_BLOCK_SIZE;
+  block_size= block_size_arg - ROOT_MIN_BLOCK_SIZE;
   if (pre_alloc_size)
   {
-    size_t size= pre_alloc_size + ALIGN_SIZE(sizeof(memory::internal::UsedMemory));
+    size_t size= pre_alloc_size + ALIGN_SIZE(sizeof(internal::UsedMemory));
     if (not pre_alloc || pre_alloc->size != size)
     {
-      memory::internal::UsedMemory *mem, **prev= &this->free;
+      internal::UsedMemory *mem, **prev= &this->free;
       /*
         Free unused blocks, so that consequent calls
         to reset_root_defaults won't eat away memory.
@@ -105,7 +100,7 @@
           pre_alloc= mem;
           return;
         }
-        if (mem->left + ALIGN_SIZE(sizeof(memory::internal::UsedMemory)) == mem->size)
+        if (mem->left + ALIGN_SIZE(sizeof(internal::UsedMemory)) == mem->size)
         {
           /* remove block from the list and free it */
           *prev= mem->next;
@@ -115,7 +110,7 @@
           prev= &mem->next;
       }
       /* Allocate new prealloc block and add it to the end of free list */
-      mem= static_cast<memory::internal::UsedMemory *>(malloc(size));
+      mem= static_cast<internal::UsedMemory *>(malloc(size));
       mem->size= size;
       mem->left= pre_alloc_size;
       mem->next= *prev;
@@ -134,7 +129,7 @@
  * obtaining more memory from the heap if necessary
  *
  * @pre
- * mem_root must have been initialised via init_alloc_root()
+ * mem_root must have been initialised via init()
  *
  * @param  mem_root  The memory Root to allocate from
  * @param  length    The size of the block to allocate
@@ -142,15 +137,14 @@
  * @todo Would this be more suitable as a member function on the
  * Root class?
  */
-void *memory::Root::alloc_root(size_t length)
+unsigned char* Root::alloc(size_t length)
 {
-  unsigned char* point;
-  memory::internal::UsedMemory *next= NULL;
-  memory::internal::UsedMemory **prev;
+  internal::UsedMemory *next= NULL;
   assert(alloc_root_inited());
 
   length= ALIGN_SIZE(length);
-  if ((*(prev= &this->free)) != NULL)
+  internal::UsedMemory **prev= &this->free;
+  if (*prev)
   {
     if ((*prev)->left < length &&
 	this->first_block_usage++ >= MAX_BLOCK_USAGE_BEFORE_DROP &&
@@ -162,26 +156,24 @@
       this->used= next;
       this->first_block_usage= 0;
     }
-    for (next= *prev ; next && next->left < length ; next= next->next)
+    for (next= *prev; next && next->left < length; next= next->next)
       prev= &next->next;
   }
   if (! next)
   {						/* Time to alloc new block */
-    size_t get_size, tmp_block_size;
-
-    tmp_block_size= this->block_size * (this->block_num >> 2);
-    get_size= length+ALIGN_SIZE(sizeof(memory::internal::UsedMemory));
+    size_t tmp_block_size= this->block_size * (this->block_num >> 2);
+    size_t get_size= length+ALIGN_SIZE(sizeof(internal::UsedMemory));
     get_size= max(get_size, tmp_block_size);
 
-    next = static_cast<memory::internal::UsedMemory *>(malloc(get_size));
+    next = static_cast<internal::UsedMemory *>(malloc(get_size));
     this->block_num++;
     next->next= *prev;
     next->size= get_size;
-    next->left= get_size-ALIGN_SIZE(sizeof(memory::internal::UsedMemory));
+    next->left= get_size-ALIGN_SIZE(sizeof(internal::UsedMemory));
     *prev=next;
   }
 
-  point= (unsigned char*) ((char*) next+ (next->size-next->left));
+  unsigned char* point= (unsigned char*) ((char*) next+ (next->size-next->left));
   /** @todo next part may be unneeded due to this->first_block_usage counter*/
   if ((next->left-= length) < this->min_malloc)
   {						/* Full block */
@@ -202,9 +194,9 @@
  * @details
  * The variable arguments are a list of alternating pointers and lengths,
  * terminated by a null pointer:
- * @li <tt>char ** pointer1</tt>
+ * @li <tt>char* * pointer1</tt>
  * @li <tt>uint length1</tt>
- * @li <tt>char ** pointer2</tt>
+ * @li <tt>char* * pointer2</tt>
  * @li <tt>uint length2</tt>
  * @li <tt>...</tt>
  * @li <tt>NULL</tt>
@@ -217,28 +209,27 @@
  * A pointer to the beginning of the allocated memory block in case of 
  * success or NULL if out of memory
  */
-void *memory::Root::multi_alloc_root(int unused, ...)
+void* Root::multi_alloc(int unused, ...)
 {
   va_list args;
-  char **ptr, *start, *res;
+  char* *ptr, *start, *res;
   size_t tot_length, length;
 
   (void)unused; // For some reason Sun Studio registers unused as not used.
   va_start(args, unused);
   tot_length= 0;
-  while ((ptr= va_arg(args, char **)))
+  while ((ptr= va_arg(args, char* *)))
   {
     length= va_arg(args, uint);
     tot_length+= ALIGN_SIZE(length);
   }
   va_end(args);
 
-  if (!(start= (char*) this->alloc_root(tot_length)))
-    return(0);
+  start= (char*) this->alloc(tot_length);
 
   va_start(args, unused);
   res= start;
-  while ((ptr= va_arg(args, char **)))
+  while ((ptr= va_arg(args, char* *)))
   {
     *ptr= res;
     length= va_arg(args, uint);
@@ -252,16 +243,16 @@
  * @brief
  * Mark all data in blocks free for reusage 
  */
-void memory::Root::mark_blocks_free()
+void Root::mark_blocks_free()
 {
-  memory::internal::UsedMemory *next;
-  memory::internal::UsedMemory **last;
+  internal::UsedMemory *next;
+  internal::UsedMemory **last;
 
   /* iterate through (partially) free blocks, mark them free */
   last= &free;
   for (next= free; next; next= *(last= &next->next))
   {
-    next->left= next->size - ALIGN_SIZE(sizeof(memory::internal::UsedMemory));
+    next->left= next->size - ALIGN_SIZE(sizeof(internal::UsedMemory));
   }
 
   /* Combine the free and the used list */
@@ -270,7 +261,7 @@
   /* now go through the used blocks and mark them free */
   for (; next; next= next->next)
   {
-    next->left= next->size - ALIGN_SIZE(sizeof(memory::internal::UsedMemory));
+    next->left= next->size - ALIGN_SIZE(sizeof(internal::UsedMemory));
   }
 
   /* Now everything is set; Indicate that nothing is used anymore */
@@ -280,12 +271,12 @@
 
 /**
  * @brief
- * Deallocate everything used by memory::alloc_root or just move
+ * Deallocate everything used by alloc_root or just move
  * used blocks to free list if called with MY_USED_TO_FREE
  *
  * @note
  * One can call this function either with root block initialised with
- * init_alloc_root() or with a zero:ed block.
+ * init() or with a zero:ed block.
  * It's also safe to call this multiple times with the same mem_root.
  *
  * @param   root     Memory root
@@ -294,27 +285,27 @@
  *   @li   KEEP_PREALLOC        If this is not set, then free also the
  *        		        preallocated block
  */
-void memory::Root::free_root(myf MyFlags)
+void Root::free_root(myf MyFlags)
 {
-  memory::internal::UsedMemory *next,*old;
-
-  if (MyFlags & memory::MARK_BLOCKS_FREE)
+  if (MyFlags & MARK_BLOCKS_FREE)
   {
     this->mark_blocks_free();
     return;
   }
-  if (!(MyFlags & memory::KEEP_PREALLOC))
+  if (!(MyFlags & KEEP_PREALLOC))
     this->pre_alloc=0;
 
-  for (next=this->used; next ;)
+  for (internal::UsedMemory* next= this->used; next;)
   {
-    old=next; next= next->next ;
+    internal::UsedMemory* old =next; 
+    next= next->next;
     if (old != this->pre_alloc)
       std::free(old);
   }
-  for (next=this->free ; next ;)
+  for (internal::UsedMemory* next=this->free; next;)
   {
-    old=next; next= next->next;
+    internal::UsedMemory* old= next; 
+    next= next->next;
     if (old != this->pre_alloc)
       std::free(old);
   }
@@ -322,7 +313,7 @@
   if (this->pre_alloc)
   {
     this->free=this->pre_alloc;
-    this->free->left=this->pre_alloc->size-ALIGN_SIZE(sizeof(memory::internal::UsedMemory));
+    this->free->left=this->pre_alloc->size-ALIGN_SIZE(sizeof(internal::UsedMemory));
     this->free->next=0;
   }
   this->block_num= 4;
@@ -334,9 +325,9 @@
  * Duplicate a null-terminated string into memory allocated from within the
  * specified Root
  */
-char *memory::Root::strdup_root(const char *str)
+char* Root::strdup(const char* str)
 {
-  return strmake_root(str, strlen(str));
+  return strmake(str, strlen(str));
 }
 
 /**
@@ -350,17 +341,24 @@
  * even if the original string wasn't (one additional byte is allocated for
  * this purpose).
  */
-char *memory::Root::strmake_root(const char *str, size_t len)
+char* Root::strmake(const char* str, size_t len)
 {
-  char *pos;
-  if ((pos= (char *)alloc_root(len+1)))
-  {
-    memcpy(pos,str,len);
-    pos[len]=0;
-  }
+  char* pos= (char*)alloc(len + 1);
+  memcpy(pos, str, len);
+  pos[len]= 0;
   return pos;
 }
 
+char* Root::strmake(const std::string& v)
+{
+  return strmake(v.data(), v.size());
+}
+
+char* Root::strmake(const String& v)
+{
+  return strmake(v.ptr(), v.length());
+}
+
 /**
  * @brief
  * Duplicate the provided block into memory allocated from within the specified
@@ -370,14 +368,12 @@
  * non-NULL pointer to a copy of the data if memory could be allocated, otherwise
  * NULL
  */
-void *memory::Root::memdup_root(const void *str, size_t len)
+void* Root::memdup(const void* str, size_t len)
 {
-  void *pos;
-
-  if ((pos= this->alloc_root(len)))
-    memcpy(pos,str,len);
-
+  void* pos= alloc(len);
+  memcpy(pos, str, len);
   return pos;
 }
 
+}
 } /* namespace drizzled */

=== modified file 'drizzled/memory/root.h'
--- drizzled/memory/root.h	2011-03-28 21:07:04 +0000
+++ drizzled/memory/root.h	2011-06-22 19:56:58 +0000
@@ -18,11 +18,8 @@
  * @brief Memory root declarations
  */
 
-
-
 #pragma once
 
-#include <cstddef>
 #include <drizzled/common_fwd.h>
 #include <drizzled/definitions.h>
 #include <drizzled/visibility.h>
@@ -43,16 +40,15 @@
 /* move used to free list and reuse them */
 static const int MARK_BLOCKS_FREE= 2;
 
-namespace internal {
-
-class UsedMemory
-{			   /* struct for once_alloc (block) */
-public:
-  UsedMemory *next;	   /* Next block in use */
-  size_t left;		   /* memory left in block  */            
-  size_t size;		   /* size of block */
-};
-
+namespace internal 
+{
+  class UsedMemory
+  {			   /* struct for once_alloc (block) */
+  public:
+    UsedMemory *next;	   /* Next block in use */
+    size_t left;		   /* memory left in block  */            
+    size_t size;		   /* size of block */
+  };
 }
 
 static const size_t ROOT_MIN_BLOCK_SIZE= (MALLOC_OVERHEAD + sizeof(internal::UsedMemory) + 8);
@@ -60,7 +56,6 @@
 class DRIZZLED_API Root
 {
 public:
-
   Root() :
     free(0),
     used(0),
@@ -68,8 +63,7 @@
     min_malloc(0),
     block_size(0),
     block_num(0),
-    first_block_usage(0),
-    error_handler(0)
+    first_block_usage(0)
   { }
 
   Root(size_t block_size_arg)
@@ -79,11 +73,8 @@
     block_size= block_size_arg - memory::ROOT_MIN_BLOCK_SIZE;
     block_num= 4;			/* We shift this with >>2 */
     first_block_usage= 0;
-    error_handler= 0;
   }
 
-  ~Root();
-
   /**
    * blocks with free memory in it 
    */
@@ -113,33 +104,37 @@
    */
   unsigned int first_block_usage;
 
-  void (*error_handler)(void);
-  void reset_root_defaults(size_t block_size, size_t prealloc_size);
-  void *alloc_root(size_t Size);
-  inline void *allocate(size_t Size)
-  {
-    return alloc_root(Size);
-  }
+  void reset_defaults(size_t block_size, size_t prealloc_size);
+  unsigned char* alloc(size_t Size);
   void mark_blocks_free();
-  void *memdup_root(const void *str, size_t len);
-  char *strdup_root(const char *str);
-
-  char *strmake_root(const char *str,size_t len);
-  void init_alloc_root(size_t block_size= ROOT_MIN_BLOCK_SIZE);
-
-  inline void *duplicate(const void *str, size_t len)
-  {
-    return memdup_root(str, len);
-  }
+  void* memdup(const void*, size_t);
+  char* strdup(const char*);
+
+  char* strmake(const char*, size_t);
+  char* strmake(const std::string&);
+  char* strmake(const String&);
+  void init(size_t block_size= ROOT_MIN_BLOCK_SIZE);
 
   inline bool alloc_root_inited()
   {
     return min_malloc != 0;
   }
   void free_root(myf MyFLAGS);
-  void *multi_alloc_root(int unused, ...);
+  void* multi_alloc(int unused, ...);
+
+  void* calloc(size_t size)
+  {
+    void* ptr= alloc(size);
+    memset(ptr, 0, size);
+    return ptr;
+  }
 };
 
 } /* namespace memory */
 } /* namespace drizzled */
 
+inline void* operator new(size_t size, drizzled::memory::Root& root)
+{
+  return root.alloc(size);
+}
+

=== modified file 'drizzled/memory/sql_alloc.cc'
--- drizzled/memory/sql_alloc.cc	2011-02-17 00:14:13 +0000
+++ drizzled/memory/sql_alloc.cc	2011-06-22 16:36:40 +0000
@@ -25,90 +25,45 @@
 #include <drizzled/current_session.h>
 #include <drizzled/error.h>
 #include <drizzled/definitions.h>
-
 #include <drizzled/internal/my_sys.h>
 
-namespace drizzled
-{
-
-static void sql_alloc_error_handler(void)
-{
-  errmsg_printf(error::ERROR, "%s",ER(ER_OUT_OF_RESOURCES));
-}
-
-void memory::init_sql_alloc(memory::Root *mem_root, size_t block_size, size_t)
-{
-  mem_root->init_alloc_root(block_size);
-  mem_root->error_handler= sql_alloc_error_handler;
-}
-
-
-void *memory::sql_alloc(size_t Size)
-{
-  memory::Root *root= current_mem_root();
-  return root->alloc_root(Size);
-}
-
-
-void *memory::sql_calloc(size_t size)
-{
-  void *ptr;
-
-  if ((ptr=memory::sql_alloc(size)))
-    memset(ptr, 0, size);
-
+namespace drizzled {
+namespace memory {
+
+void* sql_alloc(size_t Size)
+{
+  return current_mem_root()->alloc(Size);
+}
+
+void* sql_calloc(size_t size)
+{
+  void* ptr= sql_alloc(size);
+  memset(ptr, 0, size);
   return ptr;
 }
 
-
-char *memory::sql_strdup(const char *str)
-{
-  size_t len= strlen(str)+1;
-  char *pos;
-  if ((pos= (char*) memory::sql_alloc(len)))
-    memcpy(pos,str,len);
-  return pos;
-}
-
-
-char *memory::sql_strmake(const char *str, size_t len)
-{
-  char *pos;
-  if ((pos= (char*) memory::sql_alloc(len+1)))
-  {
-    memcpy(pos,str,len);
-    pos[len]=0;
-  }
-  return pos;
-}
-
-
-void* memory::sql_memdup(const void *ptr, size_t len)
-{
-  void *pos;
-  if ((pos= memory::sql_alloc(len)))
-    memcpy(pos,ptr,len);
-  return pos;
-}
-
-void *memory::SqlAlloc::operator new(size_t size)
-{
-  return memory::sql_alloc(size);
-}
-
-void *memory::SqlAlloc::operator new[](size_t size)
-{
-  return memory::sql_alloc(size);
-}
-
-void *memory::SqlAlloc::operator new[](size_t size, memory::Root *mem_root)
-{
-  return mem_root->alloc_root(size);
-}
-
-void *memory::SqlAlloc::operator new(size_t size, memory::Root *mem_root)
-{
-  return mem_root->alloc_root(size);
-}
-
+char* sql_strdup(const char* str)
+{
+  size_t len= strlen(str) + 1;
+  char* pos= (char*) sql_alloc(len);
+  memcpy(pos, str, len);
+  return pos;
+}
+
+char* sql_strmake(const char* str, size_t len)
+{
+  char* pos= (char*) sql_alloc(len + 1);
+  memcpy(pos, str, len);
+  pos[len]= 0;
+  return pos;
+}
+
+void* sql_memdup(const void* ptr, size_t len)
+{
+  void* pos= sql_alloc(len);
+  memcpy(pos,ptr,len);
+  return pos;
+}
+
+}
 } /* namespace drizzled */

=== modified file 'drizzled/memory/sql_alloc.h'
--- drizzled/memory/sql_alloc.h	2011-03-28 21:07:04 +0000
+++ drizzled/memory/sql_alloc.h	2011-06-22 16:36:40 +0000
@@ -17,46 +17,61 @@
  *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
-
-
 #pragma once
 
-#include <unistd.h>
 #include <drizzled/memory/root.h>
-
 #include <drizzled/visibility.h>
 
 namespace drizzled {
 namespace memory {
 
-void init_sql_alloc(Root *root, size_t block_size, size_t pre_alloc_size);
-void *sql_alloc(size_t);
-void *sql_calloc(size_t);
-char *sql_strdup(const char *str);
-char *sql_strmake(const char *str, size_t len);
-void *sql_memdup(const void * ptr, size_t size);
+void* sql_alloc(size_t);
+void* sql_calloc(size_t);
+char* sql_strdup(const char*);
+char* sql_strmake(const char*, size_t);
+void* sql_memdup(const void*, size_t);
 
 class DRIZZLED_API SqlAlloc
 {
 public:
-  static void *operator new(size_t size);
-  static void *operator new[](size_t size);
-  static void *operator new[](size_t size, Root *mem_root);
-  static void *operator new(size_t size, Root *mem_root);
-  static void operator delete(void *, size_t)
-  {  }
-  static void operator delete(void *, Root *)
-  {  }
-  static void operator delete[](void *, Root *)
-  {  }
-  static void operator delete[](void *, size_t)
-  {  }
-  SqlAlloc() {}
-  /**
-   * @TODO: Make this virtual... but List<> must be fixed first
-   */
-  ~SqlAlloc() {}
-
+  static void *operator new(size_t size)
+  {
+    return memory::sql_alloc(size);
+  }
+
+  static void *operator new[](size_t size)
+  {
+    return memory::sql_alloc(size);
+  }
+
+  static void *operator new[](size_t size, Root& root)
+  {
+    return root.alloc(size);
+  }
+
+  static void *operator new(size_t size, Root& root)
+  {
+    return root.alloc(size);
+  }
+
+  static void *operator new[](size_t size, Root* root)
+  {
+    return root->alloc(size);
+  }
+
+  static void *operator new(size_t size, Root* root)
+  {
+    return root->alloc(size);
+  }
+
+  static void operator delete(void*, size_t)
+  {  }
+  static void operator delete(void*, Root*)
+  {  }
+  static void operator delete[](void*, Root*)
+  {  }
+  static void operator delete[](void*, size_t)
+  {  }
 };
 
 }

=== modified file 'drizzled/module/loader.cc'
--- drizzled/module/loader.cc	2011-03-23 09:26:52 +0000
+++ drizzled/module/loader.cc	2011-06-21 19:11:23 +0000
@@ -107,36 +107,14 @@
   Item *item;
 };
 
-class Bookmark
-{
-public:
-  Bookmark() :
-    type_code(0),
-    offset(0),
-    version(0),
-    key("")
-  {}
-  uint8_t type_code;
-  int offset;
-  uint32_t version;
-  string key;
-};
-
-typedef boost::unordered_map<string, Bookmark> bookmark_unordered_map;
-static bookmark_unordered_map bookmark_hash;
-
-
-
 /* prototypes */
-static void plugin_prune_list(vector<string> &plugin_list,
-                              const vector<string> &plugins_to_remove);
+static void plugin_prune_list(vector<string> &plugin_list, const vector<string> &plugins_to_remove);
 static bool plugin_load_list(module::Registry &registry,
                              memory::Root *tmp_root,
                              const set<string> &plugin_list,
                              po::options_description &long_options,
                              bool builtin= false);
-static int test_plugin_options(memory::Root *, module::Module *,
-                               po::options_description &long_options);
+static int test_plugin_options(memory::Root*, module::Module*, po::options_description&long_options);
 static void unlock_variables(Session *session, drizzle_system_variables *vars);
 static void cleanup_variables(drizzle_system_variables *vars);
 
@@ -418,10 +396,8 @@
   return false;
 }
 
-
 void module_shutdown(module::Registry &registry)
 {
-
   if (initialized)
   {
     reap_needed= true;

=== modified file 'drizzled/my_hash.cc'
--- drizzled/my_hash.cc	2011-06-14 20:59:28 +0000
+++ drizzled/my_hash.cc	2011-06-22 20:05:58 +0000
@@ -262,13 +262,13 @@
     unsigned char *key= (unsigned char*) hash_key(info, record, &idx, 1);
     if (hash_search(info, key, idx))
       /* Duplicate entry */
-      return(true);
+      return true;
   }
 
   flag=0;
   if (!(empty=(HASH_LINK*) alloc_dynamic(&info->array)))
     /* No more memory */
-    return(true);
+    return true;
 
   data=dynamic_element(&info->array,0,HASH_LINK*);
   halfbuff= info->blength >> 1;

=== modified file 'drizzled/optimizer/access_method/system.cc'
--- drizzled/optimizer/access_method/system.cc	2011-02-17 00:14:13 +0000
+++ drizzled/optimizer/access_method/system.cc	2011-06-21 12:02:57 +0000
@@ -26,8 +26,7 @@
 
 using namespace drizzled;
 
-bool optimizer::System::getStats(Table *table,
-                                 JoinTable *join_tab)
+bool optimizer::System::getStats(Table *table, JoinTable *join_tab)
 {
   table->status= STATUS_NO_RECORD;
   join_tab->read_first_record= reinterpret_cast<Read_record_func>(join_tab->joinReadSystem());

=== modified file 'drizzled/optimizer/quick_group_min_max_select.cc'
--- drizzled/optimizer/quick_group_min_max_select.cc	2011-03-21 18:32:26 +0000
+++ drizzled/optimizer/quick_group_min_max_select.cc	2011-06-22 19:56:58 +0000
@@ -37,9 +37,9 @@
 using namespace std;
 
 namespace drizzled {
+namespace optimizer {
 
-optimizer::QuickGroupMinMaxSelect::
-QuickGroupMinMaxSelect(Table *table,
+QuickGroupMinMaxSelect::QuickGroupMinMaxSelect(Table *table,
                        Join *join_arg,
                        bool have_min_arg,
                        bool have_max_arg,
@@ -88,7 +88,7 @@
   assert(! parent_alloc);
   if (! parent_alloc)
   {
-    memory::init_sql_alloc(&alloc, join->session->variables.range_alloc_block_size, 0);
+    alloc.init(join->session->variables.range_alloc_block_size);
     join->session->mem_root= &alloc;
   }
   else
@@ -96,19 +96,17 @@
 }
 
 
-int optimizer::QuickGroupMinMaxSelect::init()
+int QuickGroupMinMaxSelect::init()
 {
   if (group_prefix) /* Already initialized. */
     return 0;
 
-  if (! (last_prefix= (unsigned char*) alloc.alloc_root(group_prefix_len)))
-      return 1;
+  last_prefix= alloc.alloc(group_prefix_len);
   /*
     We may use group_prefix to store keys with all select fields, so allocate
     enough space for it.
   */
-  if (! (group_prefix= (unsigned char*) alloc.alloc_root(real_prefix_len + min_max_arg_len)))
-    return 1;
+  group_prefix= alloc.alloc(real_prefix_len + min_max_arg_len);
 
   if (key_infix_len > 0)
   {
@@ -116,33 +114,17 @@
       The memory location pointed to by key_infix will be deleted soon, so
       allocate a new buffer and copy the key_infix into it.
     */
-    unsigned char *tmp_key_infix= (unsigned char*) alloc.alloc_root(key_infix_len);
-    if (! tmp_key_infix)
-      return 1;
+    unsigned char *tmp_key_infix= alloc.alloc(key_infix_len);
     memcpy(tmp_key_infix, this->key_infix, key_infix_len);
     this->key_infix= tmp_key_infix;
   }
 
   if (min_max_arg_part)
   {
-    if (have_min)
-    {
-      if (! (min_functions= new List<Item_sum>))
-        return 1;
-    }
-    else
-      min_functions= NULL;
-    if (have_max)
-    {
-      if (! (max_functions= new List<Item_sum>))
-        return 1;
-    }
-    else
-      max_functions= NULL;
-
-    Item_sum *min_max_item= NULL;
+    min_functions= have_min ? new List<Item_sum> : NULL;
+    max_functions= have_max ? new List<Item_sum> : NULL;
     Item_sum **func_ptr= join->sum_funcs;
-    while ((min_max_item= *(func_ptr++)))
+    while (Item_sum* min_max_item= *(func_ptr++))
     {
       if (have_min && (min_max_item->sum_func() == Item_sum::MIN_FUNC))
         min_functions->push_back(min_max_item);
@@ -151,23 +133,14 @@
     }
 
     if (have_min)
-    {
-      if (! (min_functions_it= new List<Item_sum>::iterator(min_functions->begin())))
-        return 1;
-    }
-
+      min_functions_it= new List<Item_sum>::iterator(min_functions->begin());
     if (have_max)
-    {
-      if (! (max_functions_it= new List<Item_sum>::iterator(max_functions->begin())))
-        return 1;
-    }
+      max_functions_it= new List<Item_sum>::iterator(max_functions->begin());
   }
-
   return 0;
 }
 
-
-optimizer::QuickGroupMinMaxSelect::~QuickGroupMinMaxSelect()
+QuickGroupMinMaxSelect::~QuickGroupMinMaxSelect()
 {
   if (cursor->inited != Cursor::NONE)
   {
@@ -187,9 +160,9 @@
 }
 
 
-bool optimizer::QuickGroupMinMaxSelect::add_range(optimizer::SEL_ARG *sel_range)
+bool QuickGroupMinMaxSelect::add_range(SEL_ARG *sel_range)
 {
-  optimizer::QuickRange *range= NULL;
+  QuickRange *range= NULL;
   uint32_t range_flag= sel_range->min_flag | sel_range->max_flag;
 
   /* Skip (-inf,+inf) ranges, e.g. (x < 5 or x > 4). */
@@ -206,7 +179,7 @@
                     min_max_arg_len) == 0)
       range_flag|= EQ_RANGE;  /* equality condition */
   }
-  range= new optimizer::QuickRange(sel_range->min_value,
+  range= new QuickRange(sel_range->min_value,
                                    min_max_arg_len,
                                    make_keypart_map(sel_range->part),
                                    sel_range->max_value,
@@ -220,24 +193,24 @@
 }
 
 
-void optimizer::QuickGroupMinMaxSelect::adjust_prefix_ranges()
+void QuickGroupMinMaxSelect::adjust_prefix_ranges()
 {
   if (quick_prefix_select &&
       group_prefix_len < quick_prefix_select->max_used_key_length)
   {
     DYNAMIC_ARRAY& arr= quick_prefix_select->ranges;
     for (size_t inx= 0; inx < arr.size(); inx++)
-      reinterpret_cast<optimizer::QuickRange**>(arr.buffer)[inx]->flag &= ~(NEAR_MIN | NEAR_MAX);
+      reinterpret_cast<QuickRange**>(arr.buffer)[inx]->flag &= ~(NEAR_MIN | NEAR_MAX);
   }
 }
 
 
-void optimizer::QuickGroupMinMaxSelect::update_key_stat()
+void QuickGroupMinMaxSelect::update_key_stat()
 {
   max_used_key_length= real_prefix_len;
   if (! min_max_ranges.empty())
   {
-    optimizer::QuickRange *cur_range= NULL;
+    QuickRange *cur_range= NULL;
     if (have_min)
     { /* Check if the right-most range has a lower boundary. */
       cur_range= min_max_ranges.back();
@@ -276,7 +249,7 @@
 }
 
 
-int optimizer::QuickGroupMinMaxSelect::reset(void)
+int QuickGroupMinMaxSelect::reset(void)
 {
   int result;
 
@@ -295,7 +268,7 @@
 }
 
 
-int optimizer::QuickGroupMinMaxSelect::get_next()
+int QuickGroupMinMaxSelect::get_next()
 {
   int min_res= 0;
   int max_res= 0;
@@ -375,7 +348,7 @@
 }
 
 
-int optimizer::QuickGroupMinMaxSelect::next_min()
+int QuickGroupMinMaxSelect::next_min()
 {
   int result= 0;
 
@@ -440,23 +413,16 @@
 }
 
 
-int optimizer::QuickGroupMinMaxSelect::next_max()
+int QuickGroupMinMaxSelect::next_max()
 {
-  int result= 0;
-
   /* Get the last key in the (possibly extended) group. */
-  if (! min_max_ranges.empty())
-    result= next_max_in_range();
-  else
-    result= cursor->index_read_map(record,
-                                   group_prefix,
-                                   make_prev_keypart_map(real_key_parts),
-                                   HA_READ_PREFIX_LAST);
-  return result;
+  return min_max_ranges.empty()
+    ? cursor->index_read_map(record, group_prefix, make_prev_keypart_map(real_key_parts), HA_READ_PREFIX_LAST)
+    : next_max_in_range();
 }
 
 
-int optimizer::QuickGroupMinMaxSelect::next_prefix()
+int QuickGroupMinMaxSelect::next_prefix()
 {
   int result= 0;
 
@@ -502,11 +468,11 @@
 }
 
 
-int optimizer::QuickGroupMinMaxSelect::next_min_in_range()
+int QuickGroupMinMaxSelect::next_min_in_range()
 {
   ha_rkey_function find_flag;
   key_part_map keypart_map;
-  optimizer::QuickRange *cur_range= NULL;
+  QuickRange *cur_range= NULL;
   bool found_null= false;
   int result= HA_ERR_KEY_NOT_FOUND;
   basic_string<unsigned char> max_key;
@@ -515,9 +481,7 @@
 
   assert(! min_max_ranges.empty());
 
-  for (vector<optimizer::QuickRange *>::iterator it= min_max_ranges.begin();
-       it != min_max_ranges.end();
-       ++it)
+  for (vector<QuickRange *>::iterator it= min_max_ranges.begin(); it != min_max_ranges.end(); ++it)
   { /* Search from the left-most range to the right. */
     cur_range= *it;
 
@@ -622,18 +586,18 @@
 }
 
 
-int optimizer::QuickGroupMinMaxSelect::next_max_in_range()
+int QuickGroupMinMaxSelect::next_max_in_range()
 {
   ha_rkey_function find_flag;
   key_part_map keypart_map;
-  optimizer::QuickRange *cur_range= NULL;
+  QuickRange *cur_range= NULL;
   int result= 0;
   basic_string<unsigned char> min_key;
   min_key.reserve(real_prefix_len + min_max_arg_len);
 
   assert(! min_max_ranges.empty());
 
-  for (vector<optimizer::QuickRange *>::reverse_iterator rit= min_max_ranges.rbegin();
+  for (vector<QuickRange *>::reverse_iterator rit= min_max_ranges.rbegin();
        rit != min_max_ranges.rend();
        ++rit)
   { /* Search from the right-most range to the left. */
@@ -712,7 +676,7 @@
 }
 
 
-void optimizer::QuickGroupMinMaxSelect::update_min_result()
+void QuickGroupMinMaxSelect::update_min_result()
 {
   *min_functions_it= min_functions->begin();
   for (Item_sum *min_func; (min_func= (*min_functions_it)++); )
@@ -720,7 +684,7 @@
 }
 
 
-void optimizer::QuickGroupMinMaxSelect::update_max_result()
+void QuickGroupMinMaxSelect::update_max_result()
 {
   *max_functions_it= max_functions->begin();
   for (Item_sum *max_func; (max_func= (*max_functions_it)++); )
@@ -728,7 +692,7 @@
 }
 
 
-void optimizer::QuickGroupMinMaxSelect::add_keys_and_lengths(string *key_names,
+void QuickGroupMinMaxSelect::add_keys_and_lengths(string *key_names,
                                                              string *used_lengths)
 {
   char buf[64];
@@ -737,4 +701,5 @@
   used_lengths->append(buf, length);
 }
 
+}
 } /* namespace drizzled */

=== modified file 'drizzled/optimizer/quick_index_merge_select.cc'
--- drizzled/optimizer/quick_index_merge_select.cc	2011-03-21 18:32:26 +0000
+++ drizzled/optimizer/quick_index_merge_select.cc	2011-06-22 19:18:51 +0000
@@ -50,8 +50,7 @@
   index= MAX_KEY;
   head= table;
   memset(&read_record, 0, sizeof(read_record));
-  memory::init_sql_alloc(&alloc, session->variables.range_alloc_block_size, 0);
-  return;
+  alloc.init(session->variables.range_alloc_block_size);
 }
 
 int optimizer::QuickIndexMergeSelect::init()
@@ -64,8 +63,7 @@
   return (read_keys_and_merge());
 }
 
-bool
-optimizer::QuickIndexMergeSelect::push_quick_back(optimizer::QuickRangeSelect *quick_sel_range)
+void optimizer::QuickIndexMergeSelect::push_quick_back(optimizer::QuickRangeSelect *quick_sel_range)
 {
   /*
     Save quick_select that does scan on clustered primary key as it will be
@@ -80,24 +78,16 @@
   {
     quick_selects.push_back(quick_sel_range);
   }
-  return false;
 }
 
 optimizer::QuickIndexMergeSelect::~QuickIndexMergeSelect()
 {
-  for (vector<optimizer::QuickRangeSelect *>::iterator it= quick_selects.begin();
-       it != quick_selects.end();
-       ++it)
-  {
-    (*it)->cursor= NULL;
-  }
-  for_each(quick_selects.begin(),
-           quick_selects.end(),
-           DeletePtr());
+  BOOST_FOREACH(QuickRangeSelect* it, quick_selects)
+    it->cursor= NULL;
+  for_each(quick_selects.begin(), quick_selects.end(), DeletePtr());
   quick_selects.clear();
   delete pk_quick_select;
   alloc.free_root(MYF(0));
-  return;
 }
 
 

=== modified file 'drizzled/optimizer/quick_index_merge_select.h'
--- drizzled/optimizer/quick_index_merge_select.h	2011-03-14 05:40:28 +0000
+++ drizzled/optimizer/quick_index_merge_select.h	2011-06-22 19:18:51 +0000
@@ -129,7 +129,7 @@
   void add_info_string(std::string *str);
   bool is_keys_used(const boost::dynamic_bitset<>& fields);
 
-  bool push_quick_back(QuickRangeSelect *quick_sel_range);
+  void push_quick_back(QuickRangeSelect *quick_sel_range);
 
   /* range quick selects this index_merge read consists of */
   std::vector<QuickRangeSelect *> quick_selects;

=== modified file 'drizzled/optimizer/quick_range_select.cc'
--- drizzled/optimizer/quick_range_select.cc	2011-03-21 18:32:26 +0000
+++ drizzled/optimizer/quick_range_select.cc	2011-06-21 15:17:07 +0000
@@ -70,7 +70,7 @@
   if (! no_alloc && ! parent_alloc)
   {
     // Allocates everything through the internal memroot
-    memory::init_sql_alloc(&alloc, session->variables.range_alloc_block_size, 0);
+    alloc.init(session->variables.range_alloc_block_size);
     session->mem_root= &alloc;
   }
   else

=== modified file 'drizzled/optimizer/quick_ror_intersect_select.cc'
--- drizzled/optimizer/quick_ror_intersect_select.cc	2011-03-21 18:32:26 +0000
+++ drizzled/optimizer/quick_ror_intersect_select.cc	2011-06-22 19:18:51 +0000
@@ -49,21 +49,16 @@
   record= head->record[0];
   if (! parent_alloc)
   {
-    memory::init_sql_alloc(&alloc, session->variables.range_alloc_block_size, 0);
+    alloc.init(session->variables.range_alloc_block_size);
   }
   else
   {
     memset(&alloc, 0, sizeof(memory::Root));
   }
 
-  if (parent_alloc)
-  {
-    last_rowid= (unsigned char*) parent_alloc->alloc_root(head->cursor->ref_length);
-  }
-  else
-  {
-    last_rowid= (unsigned char*) alloc.alloc_root(head->cursor->ref_length);
-  }
+  last_rowid= parent_alloc
+    ? parent_alloc->alloc(head->cursor->ref_length)
+    : alloc.alloc(head->cursor->ref_length);
 }
 
 
@@ -145,24 +140,18 @@
 }
 
 
-bool
-optimizer::QuickRorIntersectSelect::push_quick_back(optimizer::QuickRangeSelect *quick)
+void optimizer::QuickRorIntersectSelect::push_quick_back(optimizer::QuickRangeSelect *quick)
 {
   quick_selects.push_back(quick);
-  return false;
 }
 
 
 bool optimizer::QuickRorIntersectSelect::is_keys_used(const boost::dynamic_bitset<>& fields)
 {
-  for (vector<optimizer::QuickRangeSelect *>::iterator it= quick_selects.begin();
-       it != quick_selects.end();
-       ++it)
+  BOOST_FOREACH(QuickRangeSelect* it, quick_selects)
   {
-    if (is_key_used(head, (*it)->index, fields))
-    {
+    if (is_key_used(head, it->index, fields))
       return 1;
-    }
   }
   return 0;
 }

=== modified file 'drizzled/optimizer/quick_ror_intersect_select.h'
--- drizzled/optimizer/quick_ror_intersect_select.h	2011-03-14 05:40:28 +0000
+++ drizzled/optimizer/quick_ror_intersect_select.h	2011-06-22 19:18:51 +0000
@@ -145,13 +145,13 @@
    * @retval false OK
    * @retval true  Out of memory.
    */
-  bool push_quick_back(QuickRangeSelect *quick_sel_range);
+  void push_quick_back(QuickRangeSelect *quick_sel_range);
 
   /**
    * Range quick selects this intersection consists of, not including
    * cpk_quick.
    */
-  std::vector<QuickRangeSelect *> quick_selects;
+  std::vector<QuickRangeSelect*> quick_selects;
 
   /**
    * Merged quick select that uses Clustered PK, if there is one. This quick

=== modified file 'drizzled/optimizer/quick_ror_union_select.cc'
--- drizzled/optimizer/quick_ror_union_select.cc	2011-03-21 18:32:26 +0000
+++ drizzled/optimizer/quick_ror_union_select.cc	2011-06-22 19:18:51 +0000
@@ -43,7 +43,7 @@
   head= table;
   rowid_length= table->cursor->ref_length;
   record= head->record[0];
-  memory::init_sql_alloc(&alloc, session->variables.range_alloc_block_size, 0);
+  alloc.init(session->variables.range_alloc_block_size);
   session_param->mem_root= &alloc;
 }
 
@@ -69,14 +69,8 @@
 
 int optimizer::QuickRorUnionSelect::init()
 {
-  queue=
-    new priority_queue<optimizer::QuickSelectInterface *,
-                       vector<optimizer::QuickSelectInterface *>,
-                       optimizer::compare_functor >(optimizer::compare_functor(this));
-  if (! (cur_rowid= (unsigned char*) alloc.alloc_root(2 * head->cursor->ref_length)))
-  {
-    return 0;
-  }
+  queue= new priority_queue<QuickSelectInterface*, vector<QuickSelectInterface*>, compare_functor>(compare_functor(this));
+  cur_rowid= alloc.alloc(2 * head->cursor->ref_length);
   prev_rowid= cur_rowid + head->cursor->ref_length;
   return 0;
 }
@@ -84,7 +78,6 @@
 
 int optimizer::QuickRorUnionSelect::reset()
 {
-  int error;
   have_prev_rowid= false;
   if (! scans_inited)
   {
@@ -116,7 +109,7 @@
       return 0;
     }
     
-    error= (*it)->get_next();
+    int error= (*it)->get_next();
     if (error)
     {
       if (error == HA_ERR_END_OF_FILE)
@@ -137,11 +130,9 @@
 }
 
 
-bool
-optimizer::QuickRorUnionSelect::push_quick_back(QuickSelectInterface *quick_sel_range)
+void optimizer::QuickRorUnionSelect::push_quick_back(QuickSelectInterface *quick_sel_range)
 {
   quick_selects.push_back(quick_sel_range);
-  return false;
 }
 
 

=== modified file 'drizzled/optimizer/quick_ror_union_select.h'
--- drizzled/optimizer/quick_ror_union_select.h	2011-03-29 10:48:07 +0000
+++ drizzled/optimizer/quick_ror_union_select.h	2011-06-22 19:18:51 +0000
@@ -101,7 +101,7 @@
   void add_info_string(std::string *str);
   bool is_keys_used(const boost::dynamic_bitset<>& fields);
 
-  bool push_quick_back(QuickSelectInterface *quick_sel_range);
+  void push_quick_back(QuickSelectInterface *quick_sel_range);
 
   std::vector<QuickSelectInterface *> quick_selects; /**< Merged quick selects */
 

=== modified file 'drizzled/optimizer/range.cc'
--- drizzled/optimizer/range.cc	2011-04-29 00:19:38 +0000
+++ drizzled/optimizer/range.cc	2011-06-22 19:30:12 +0000
@@ -695,9 +695,9 @@
     param.force_default_mrr= ordered_output;
 
     session->no_errors=1;				// Don't warn about NULL
-    memory::init_sql_alloc(&alloc, session->variables.range_alloc_block_size, 0);
-    if (!(param.key_parts= (KEY_PART*) alloc.alloc_root( sizeof(KEY_PART) * head->getShare()->key_parts)) ||
-        fill_used_fields_bitmap(&param))
+    alloc.init(session->variables.range_alloc_block_size);
+    param.key_parts= (KEY_PART*) alloc.alloc( sizeof(KEY_PART) * head->getShare()->key_parts);
+    if (fill_used_fields_bitmap(&param))
     {
       session->no_errors=0;
       alloc.free_root(MYF(0));			// Return memory & allocator
@@ -979,19 +979,14 @@
   ha_rows roru_total_records;
   double roru_intersect_part= 1.0;
 
-  if (! (range_scans= (optimizer::RangeReadPlan**)param->mem_root->alloc_root(sizeof(optimizer::RangeReadPlan*)* n_child_scans)))
-  {
-    return NULL;
-  }
+  range_scans= (optimizer::RangeReadPlan**)param->mem_root->alloc(sizeof(optimizer::RangeReadPlan*)* n_child_scans);
 
   /*
     Collect best 'range' scan for each of disjuncts, and, while doing so,
     analyze possibility of ROR scans. Also calculate some values needed by
     other parts of the code.
   */
-  for (ptree= imerge->trees, cur_child= range_scans;
-       ptree != imerge->trees_next;
-       ptree++, cur_child++)
+  for (ptree= imerge->trees, cur_child= range_scans; ptree != imerge->trees_next; ptree++, cur_child++)
   {
     if (!(*cur_child= get_key_scans_params(session, param, *ptree, true, false, read_time)))
     {
@@ -1062,11 +1057,7 @@
                                     param->session->variables.sortbuff_size);
   if (param->imerge_cost_buff_size < unique_calc_buff_size)
   {
-    if (!(param->imerge_cost_buff= (uint*)param->mem_root->alloc_root(unique_calc_buff_size)))
-    {
-      return NULL;
-    }
-
+    param->imerge_cost_buff= (uint*)param->mem_root->alloc(unique_calc_buff_size);
     param->imerge_cost_buff_size= unique_calc_buff_size;
   }
 
@@ -1094,11 +1085,7 @@
 
   /* Ok, it is possible to build a ROR-union, try it. */
   bool dummy;
-  if (! (roru_read_plans=
-          (optimizer::TableReadPlan **) param->mem_root->alloc_root(sizeof(optimizer::TableReadPlan*) * n_child_scans)))
-  {
-    return imerge_trp;
-  }
+  roru_read_plans= (optimizer::TableReadPlan **) param->mem_root->alloc(sizeof(optimizer::TableReadPlan*) * n_child_scans);
 skip_to_ror_scan:
   roru_index_costs= 0.0;
   roru_total_records= 0;
@@ -1209,12 +1196,8 @@
 static
 optimizer::RorScanInfo *make_ror_scan(const optimizer::Parameter *param, int idx, optimizer::SEL_ARG *sel_arg)
 {
-  optimizer::RorScanInfo *ror_scan= NULL;
-
   uint32_t keynr;
-
-  if (!(ror_scan= (optimizer::RorScanInfo*)param->mem_root->alloc_root(sizeof(optimizer::RorScanInfo))))
-    return NULL;
+  optimizer::RorScanInfo* ror_scan= (optimizer::RorScanInfo*)param->mem_root->alloc(sizeof(optimizer::RorScanInfo));
 
   ror_scan->idx= idx;
   ror_scan->keynr= keynr= param->real_keynr[idx];
@@ -1711,15 +1694,10 @@
   if (total_cost > read_time)
     return NULL;
 
-  optimizer::RorIntersectReadPlan *trp= NULL;
-  if (! (trp= new (param->mem_root) optimizer::RorIntersectReadPlan))
-  {
-    return trp;
-  }
+  optimizer::RorIntersectReadPlan* trp= new (param->mem_root) optimizer::RorIntersectReadPlan;
 
   uint32_t best_num= (ror_scan_mark - tree->ror_scans);
-  if (!(trp->first_scan= (optimizer::RorScanInfo**)param->mem_root->alloc_root(sizeof(optimizer::RorScanInfo*)* best_num)))
-    return NULL;
+  trp->first_scan= (optimizer::RorScanInfo**)param->mem_root->alloc(sizeof(optimizer::RorScanInfo*)* best_num);
   memcpy(trp->first_scan, tree->ror_scans, best_num*sizeof(optimizer::RorScanInfo*));
   trp->last_scan=  trp->first_scan + best_num;
   trp->is_covering= true;
@@ -1817,12 +1795,8 @@
   uint32_t cpk_no= 0;
   bool cpk_scan_used= false;
 
-  if (! (tree->ror_scans= (optimizer::RorScanInfo**)param->mem_root->alloc_root(sizeof(optimizer::RorScanInfo*)* param->keys)))
-  {
-    return NULL;
-  }
-  cpk_no= ((param->table->cursor->primary_key_is_clustered()) ?
-           param->table->getShare()->getPrimaryKey() : MAX_KEY);
+  tree->ror_scans= (optimizer::RorScanInfo**)param->mem_root->alloc(sizeof(optimizer::RorScanInfo*)* param->keys);
+  cpk_no= ((param->table->cursor->primary_key_is_clustered()) ? param->table->getShare()->getPrimaryKey() : MAX_KEY);
 
   for (idx= 0, cur_ror_scan= tree->ror_scans; idx < param->keys; idx++)
   {
@@ -1850,9 +1824,8 @@
                      (qsort_cmp)cmp_ror_scan_info);
 
   optimizer::RorScanInfo **intersect_scans= NULL; /* ROR scans used in index intersection */
-  optimizer::RorScanInfo **intersect_scans_end= NULL;
-  if (! (intersect_scans= (optimizer::RorScanInfo**)param->mem_root->alloc_root(sizeof(optimizer::RorScanInfo*) * tree->n_ror_scans)))
-    return NULL;
+  optimizer::RorScanInfo **intersect_scans_end= intersect_scans= 
+    (optimizer::RorScanInfo**)param->mem_root->alloc(sizeof(optimizer::RorScanInfo*) * tree->n_ror_scans);
   intersect_scans_end= intersect_scans;
 
   /* Create and incrementally update ROR intersection. */
@@ -1911,12 +1884,8 @@
   optimizer::RorIntersectReadPlan *trp= NULL;
   if (min_cost < read_time && (cpk_scan_used || best_num > 1))
   {
-    if (! (trp= new (param->mem_root) optimizer::RorIntersectReadPlan))
-      return trp;
-
-    if (! (trp->first_scan=
-           (optimizer::RorScanInfo**)param->mem_root->alloc_root(sizeof(optimizer::RorScanInfo*)*best_num)))
-      return NULL;
+    trp= new (param->mem_root) optimizer::RorIntersectReadPlan;
+    trp->first_scan= (optimizer::RorScanInfo**)param->mem_root->alloc(sizeof(optimizer::RorScanInfo*)*best_num);
     memcpy(trp->first_scan, intersect_scans, best_num*sizeof(optimizer::RorScanInfo*));
     trp->last_scan=  trp->first_scan + best_num;
     trp->is_covering= intersect_best.is_covering;
@@ -2038,28 +2007,20 @@
 
 optimizer::QuickSelectInterface *optimizer::IndexMergeReadPlan::make_quick(optimizer::Parameter *param, bool, memory::Root *)
 {
-  optimizer::QuickIndexMergeSelect *quick_imerge;
-  optimizer::QuickRangeSelect *quick= NULL;
   /* index_merge always retrieves full rows, ignore retrieve_full_rows */
-  if (! (quick_imerge= new optimizer::QuickIndexMergeSelect(param->session, param->table)))
-  {
-    return NULL;
-  }
-
+  optimizer::QuickIndexMergeSelect* quick_imerge= new optimizer::QuickIndexMergeSelect(param->session, param->table);
   quick_imerge->records= records;
   quick_imerge->read_time= read_cost;
-  for (optimizer::RangeReadPlan **range_scan= range_scans; 
-       range_scan != range_scans_end;
-       range_scan++)
+  for (optimizer::RangeReadPlan **range_scan= range_scans; range_scan != range_scans_end; range_scan++)
   {
-    if (! (quick= (optimizer::QuickRangeSelect*)
-          ((*range_scan)->make_quick(param, false, &quick_imerge->alloc))) ||
-        quick_imerge->push_quick_back(quick))
+    optimizer::QuickRangeSelect* quick= (optimizer::QuickRangeSelect*)((*range_scan)->make_quick(param, false, &quick_imerge->alloc));
+    if (not quick)
     {
       delete quick;
       delete quick_imerge;
       return NULL;
     }
+    quick_imerge->push_quick_back(quick);
   }
   return quick_imerge;
 }
@@ -2086,12 +2047,12 @@
                                                 (*first_scan)->sel_arg,
                                                 HA_MRR_USE_DEFAULT_IMPL | HA_MRR_SORTED,
                                                 0,
-                                                alloc)) ||
-          quick_intersect->push_quick_back(quick))
+                                                alloc)))
       {
         delete quick_intersect;
         return NULL;
       }
+      quick_intersect->push_quick_back(quick);
     }
     if (cpk_scan)
     {
@@ -2117,26 +2078,20 @@
 
 optimizer::QuickSelectInterface *optimizer::RorUnionReadPlan::make_quick(optimizer::Parameter *param, bool, memory::Root *)
 {
-  optimizer::QuickRorUnionSelect *quick_roru= NULL;
-  optimizer::TableReadPlan **scan= NULL;
-  optimizer::QuickSelectInterface *quick= NULL;
   /*
     It is impossible to construct a ROR-union that will not retrieve full
     rows, ignore retrieve_full_rows parameter.
   */
-  if ((quick_roru= new optimizer::QuickRorUnionSelect(param->session, param->table)))
+  optimizer::QuickRorUnionSelect* quick_roru= new optimizer::QuickRorUnionSelect(param->session, param->table);
+  for (optimizer::TableReadPlan** scan= first_ror; scan != last_ror; scan++)
   {
-    for (scan= first_ror; scan != last_ror; scan++)
-    {
-      if (! (quick= (*scan)->make_quick(param, false, &quick_roru->alloc)) ||
-          quick_roru->push_quick_back(quick))
-      {
-        return NULL;
-      }
-    }
-    quick_roru->records= records;
-    quick_roru->read_time= read_cost;
+    optimizer::QuickSelectInterface* quick= (*scan)->make_quick(param, false, &quick_roru->alloc);
+    if (not quick)
+      return NULL;
+    quick_roru->push_quick_back(quick);
   }
+  quick_roru->records= records;
+  quick_roru->read_time= read_cost;
   return quick_roru;
 }
 
@@ -2902,11 +2857,7 @@
         field_length= length;
     }
     length+=offset;
-    if (!(min_str= (unsigned char*) alloc->alloc_root(length*2)))
-    {
-      goto end;
-    }
-
+    min_str= alloc->alloc(length*2);
     max_str=min_str+length;
     if (maybe_null)
       max_str[0]= min_str[0]=0;
@@ -3142,14 +3093,11 @@
     goto end;
   }
 
-  str= (unsigned char*) alloc->alloc_root(key_part->store_length+1);
-  if (!str)
-    goto end;
+  str= alloc->alloc(key_part->store_length+1);
   if (maybe_null)
-    *str= (unsigned char) field->is_real_null();        // Set to 1 if null
+    *str= field->is_real_null();        // Set to 1 if null
   field->get_key_image(str+maybe_null, key_part->length);
-  if (! (tree= new (alloc) optimizer::SEL_ARG(field, str, str)))
-    goto end; // out of memory
+  tree= new (alloc) optimizer::SEL_ARG(field, str, str);
 
   /*
     Check if we are comparing an UNSIGNED integer with a negative constant.
@@ -4013,16 +3961,9 @@
     {
       quick->mrr_flags= mrr_flags;
       quick->mrr_buf_size= mrr_buf_size;
-      if (parent_alloc)
-      {
-        quick->key_parts=(KEY_PART*)
-          parent_alloc->memdup_root( (char*) param->key[idx], sizeof(KEY_PART)* param->table->key_info[param->real_keynr[idx]].key_parts);
-      }
-      else
-      {
-        quick->key_parts=(KEY_PART*)
-          quick->alloc.memdup_root((char*) param->key[idx], sizeof(KEY_PART)* param->table->key_info[param->real_keynr[idx]].key_parts);
-      }
+      quick->key_parts= parent_alloc
+        ? (KEY_PART*)parent_alloc->memdup(param->key[idx], sizeof(KEY_PART)* param->table->key_info[param->real_keynr[idx]].key_parts)
+        : (KEY_PART*)quick->alloc.memdup(param->key[idx], sizeof(KEY_PART)* param->table->key_info[param->real_keynr[idx]].key_parts);
     }
   }
   return quick;
@@ -4278,13 +4219,9 @@
   range->min_length= range->max_length= ref->key_length;
   range->min_keypart_map= range->max_keypart_map=
     make_prev_keypart_map(ref->key_parts);
-  range->flag= ((ref->key_length == key_info->key_length &&
-                 (key_info->flags & HA_END_SPACE_KEY) == 0) ? EQ_RANGE : 0);
-
-
-  if (!(quick->key_parts=key_part=(KEY_PART *)
-        quick->alloc.alloc_root(sizeof(KEY_PART)*ref->key_parts)))
-    goto err;
+  range->flag= (ref->key_length == key_info->key_length && (key_info->flags & HA_END_SPACE_KEY) == 0) ? EQ_RANGE : 0;
+
+  quick->key_parts=key_part=(KEY_PART *)quick->alloc.alloc(sizeof(KEY_PART)*ref->key_parts);
 
   for (part=0 ; part < ref->key_parts ;part++,key_part++)
   {
@@ -5470,9 +5407,7 @@
 optimizer::QuickSelectInterface *
 optimizer::GroupMinMaxReadPlan::make_quick(optimizer::Parameter *param, bool, memory::Root *parent_alloc)
 {
-  optimizer::QuickGroupMinMaxSelect *quick= NULL;
-
-  quick= new optimizer::QuickGroupMinMaxSelect(param->table,
+  optimizer::QuickGroupMinMaxSelect *quick= new optimizer::QuickGroupMinMaxSelect(param->table,
                                                param->session->lex().current_select->join,
                                                have_min,
                                                have_max,
@@ -5487,11 +5422,6 @@
                                                key_infix_len,
                                                key_infix,
                                                parent_alloc);
-  if (! quick)
-  {
-    return NULL;
-  }
-
   if (quick->init())
   {
     delete quick;

=== modified file 'drizzled/optimizer/sel_imerge.cc'
--- drizzled/optimizer/sel_imerge.cc	2011-02-17 00:14:13 +0000
+++ drizzled/optimizer/sel_imerge.cc	2011-06-22 18:33:05 +0000
@@ -39,7 +39,7 @@
 {}
 
 
-int optimizer::SEL_IMERGE::or_sel_tree(optimizer::RangeParameter *param, optimizer::SEL_TREE *tree)
+void optimizer::SEL_IMERGE::or_sel_tree(optimizer::RangeParameter *param, optimizer::SEL_TREE *tree)
 {
   if (trees_next == trees_end)
   {
@@ -47,32 +47,27 @@
     uint32_t old_elements= (trees_end - trees);
     uint32_t old_size= sizeof(optimizer::SEL_TREE**) * old_elements;
     uint32_t new_size= old_size * realloc_ratio;
-    optimizer::SEL_TREE **new_trees= NULL;
-    if (! (new_trees= (optimizer::SEL_TREE**) param->mem_root->alloc_root(new_size)))
-      return -1;
+    optimizer::SEL_TREE** new_trees= (optimizer::SEL_TREE**) param->mem_root->alloc(new_size);
     memcpy(new_trees, trees, old_size);
     trees= new_trees;
     trees_next= trees + old_elements;
     trees_end= trees + old_elements * realloc_ratio;
   }
   *(trees_next++)= tree;
-  return 0;
 }
 
 
-int optimizer::SEL_IMERGE::or_sel_tree_with_checks(optimizer::RangeParameter *param, optimizer::SEL_TREE *new_tree)
+int optimizer::SEL_IMERGE::or_sel_tree_with_checks(optimizer::RangeParameter& param, optimizer::SEL_TREE& new_tree)
 {
-  for (optimizer::SEL_TREE** tree = trees;
-       tree != trees_next;
-       tree++)
+  for (optimizer::SEL_TREE** tree = trees; tree != trees_next; tree++)
   {
-    if (sel_trees_can_be_ored(*tree, new_tree, param))
+    if (sel_trees_can_be_ored(**tree, new_tree, param))
     {
-      *tree = tree_or(param, *tree, new_tree);
+      *tree = tree_or(&param, *tree, &new_tree);
       if (!*tree)
         return 1;
-      if (((*tree)->type == optimizer::SEL_TREE::MAYBE) ||
-          ((*tree)->type == optimizer::SEL_TREE::ALWAYS))
+      if (((*tree)->type == SEL_TREE::MAYBE) ||
+          ((*tree)->type == SEL_TREE::ALWAYS))
         return 1;
       /* optimizer::SEL_TREE::IMPOSSIBLE is impossible here */
       return 0;
@@ -80,17 +75,16 @@
   }
 
   /* New tree cannot be combined with any of existing trees. */
-  return or_sel_tree(param, new_tree);
+  or_sel_tree(&param, &new_tree);
+  return 0;
 }
 
 
-int optimizer::SEL_IMERGE::or_sel_imerge_with_checks(optimizer::RangeParameter *param, optimizer::SEL_IMERGE* imerge)
+int optimizer::SEL_IMERGE::or_sel_imerge_with_checks(RangeParameter& param, SEL_IMERGE& imerge)
 {
-  for (optimizer::SEL_TREE** tree= imerge->trees;
-       tree != imerge->trees_next;
-       tree++)
+  for (SEL_TREE** tree= imerge.trees; tree != imerge.trees_next; tree++)
   {
-    if (or_sel_tree_with_checks(param, *tree))
+    if (or_sel_tree_with_checks(param, **tree))
       return 1;
   }
   return 0;

=== modified file 'drizzled/optimizer/sel_imerge.h'
--- drizzled/optimizer/sel_imerge.h	2011-03-29 12:45:08 +0000
+++ drizzled/optimizer/sel_imerge.h	2011-06-22 18:33:05 +0000
@@ -60,7 +60,7 @@
      0 - OK
      -1 - Out of memory.
    */
-  int or_sel_tree(RangeParameter *param, SEL_TREE *tree);
+  void or_sel_tree(RangeParameter *param, SEL_TREE *tree);
 
   /*
      Perform OR operation on this SEL_IMERGE and supplied optimizer::SEL_TREE new_tree,
@@ -91,7 +91,7 @@
      and (*this) should be discarded.
      -1  An error occurred.
    */
-  int or_sel_tree_with_checks(optimizer::RangeParameter *param, optimizer::SEL_TREE *new_tree);
+  int or_sel_tree_with_checks(RangeParameter&, SEL_TREE&);
 
   /*
      Perform OR operation on this index_merge and supplied index_merge list.
@@ -102,7 +102,7 @@
      should be discarded.
      -1 - An error occurred
    */
-  int or_sel_imerge_with_checks(optimizer::RangeParameter *param, SEL_IMERGE* imerge);
+  int or_sel_imerge_with_checks(RangeParameter&, SEL_IMERGE&);
 
 };
 

=== modified file 'drizzled/optimizer/sel_tree.cc'
--- drizzled/optimizer/sel_tree.cc	2011-03-18 17:31:28 +0000
+++ drizzled/optimizer/sel_tree.cc	2011-06-22 19:03:13 +0000
@@ -34,31 +34,19 @@
 static optimizer::SEL_ARG *key_or(optimizer::RangeParameter *param, optimizer::SEL_ARG *key1, optimizer::SEL_ARG *key2);
 static bool eq_tree(optimizer::SEL_ARG* a, optimizer::SEL_ARG *b);
 
-bool optimizer::sel_trees_can_be_ored(optimizer::SEL_TREE *tree1, 
-                                      optimizer::SEL_TREE *tree2,
-                                      optimizer::RangeParameter* param)
+bool optimizer::sel_trees_can_be_ored(const SEL_TREE& tree1, const SEL_TREE& tree2, const RangeParameter& param)
 {
-  key_map common_keys= tree1->keys_map;
-  common_keys&= tree2->keys_map;
+  key_map common_keys= tree1.keys_map;
+  common_keys&= tree2.keys_map;
 
   if (common_keys.none())
-  {
     return false;
-  }
 
   /* trees have a common key, check if they refer to same key part */
-  optimizer::SEL_ARG **key1,**key2;
-  for (uint32_t key_no=0; key_no < param->keys; key_no++)
+  for (uint32_t key_no= 0; key_no < param.keys; key_no++)
   {
-    if (common_keys.test(key_no))
-    {
-      key1= tree1->keys + key_no;
-      key2= tree2->keys + key_no;
-      if ((*key1)->part == (*key2)->part)
-      {
-        return true;
-      }
-    }
+    if (common_keys.test(key_no) && tree1.keys[key_no]->part == tree2.keys[key_no]->part)
+      return true;
   }
   return false;
 }
@@ -87,15 +75,13 @@
     other Error, both passed lists are unusable
 */
 
-static int imerge_list_or_list(optimizer::RangeParameter *param,
-                               List<optimizer::SEL_IMERGE> *im1,
-                               List<optimizer::SEL_IMERGE> *im2)
+static int imerge_list_or_list(optimizer::RangeParameter *param, List<optimizer::SEL_IMERGE> *im1, List<optimizer::SEL_IMERGE> *im2)
 {
   optimizer::SEL_IMERGE *imerge= &im1->front();
   im1->clear();
   im1->push_back(imerge);
 
-  return imerge->or_sel_imerge_with_checks(param, &im2->front());
+  return imerge->or_sel_imerge_with_checks(*param, im2->front());
 }
 
 
@@ -107,63 +93,45 @@
      other Error
  */
 
-static int imerge_list_or_tree(optimizer::RangeParameter *param,
-                               List<optimizer::SEL_IMERGE> *im1,
-                               optimizer::SEL_TREE *tree)
+static int imerge_list_or_tree(optimizer::RangeParameter& param, List<optimizer::SEL_IMERGE>& im1, optimizer::SEL_TREE& tree)
 {
-  optimizer::SEL_IMERGE *imerge= NULL;
-  List_iterator<optimizer::SEL_IMERGE> it(im1->begin());
-  while ((imerge= it++))
+  List_iterator<optimizer::SEL_IMERGE> it(im1.begin());
+  while (optimizer::SEL_IMERGE* imerge= it++)
   {
     if (imerge->or_sel_tree_with_checks(param, tree))
       it.remove();
   }
-  return im1->is_empty();
+  return im1.is_empty();
 }
 
 
-optimizer::SEL_TREE *
-optimizer::tree_or(optimizer::RangeParameter *param,
-                   optimizer::SEL_TREE *tree1,
-                   optimizer::SEL_TREE *tree2)
+optimizer::SEL_TREE* optimizer::tree_or(optimizer::RangeParameter *param, optimizer::SEL_TREE *tree1, optimizer::SEL_TREE *tree2)
 {
   if (! tree1 || ! tree2)
-  {
     return 0;
-  }
 
-  if (tree1->type == optimizer::SEL_TREE::IMPOSSIBLE || tree2->type == optimizer::SEL_TREE::ALWAYS)
-  {
+  if (tree1->type == SEL_TREE::IMPOSSIBLE || tree2->type == SEL_TREE::ALWAYS)
     return tree2;
-  }
 
-  if (tree2->type == optimizer::SEL_TREE::IMPOSSIBLE || tree1->type == optimizer::SEL_TREE::ALWAYS)
-  {
+  if (tree2->type == SEL_TREE::IMPOSSIBLE || tree1->type == SEL_TREE::ALWAYS)
     return tree1;
-  }
 
-  if (tree1->type == optimizer::SEL_TREE::MAYBE)
-  {
+  if (tree1->type == SEL_TREE::MAYBE)
     return tree1; // Can't use this
-  }
 
-  if (tree2->type == optimizer::SEL_TREE::MAYBE)
-  {
+  if (tree2->type == SEL_TREE::MAYBE)
     return tree2;
-  }
 
-  optimizer::SEL_TREE *result= NULL;
+  SEL_TREE *result= NULL;
   key_map  result_keys;
   result_keys.reset();
-  if (sel_trees_can_be_ored(tree1, tree2, param))
+  if (sel_trees_can_be_ored(*tree1, *tree2, *param))
   {
     /* Join the trees key per key */
-    optimizer::SEL_ARG **key1= NULL;
-    optimizer::SEL_ARG **key2= NULL;
-    optimizer::SEL_ARG **end= NULL;
-    for (key1= tree1->keys,key2= tree2->keys,end= key1+param->keys;
-         key1 != end; 
-         key1++, key2++)
+    SEL_ARG** key1= tree1->keys;
+    SEL_ARG** key2= tree2->keys;
+    SEL_ARG** end= key1+param->keys;
+    for (; key1 != end;  key1++, key2++)
     {
       *key1= key_or(param, *key1, *key2);
       if (*key1)
@@ -180,35 +148,21 @@
     /* ok, two trees have KEY type but cannot be used without index merge */
     if (tree1->merges.is_empty() && tree2->merges.is_empty())
     {
-      if (param->remove_jump_scans)
-      {
-        bool no_trees= optimizer::remove_nonrange_trees(param, tree1);
-        no_trees= no_trees || optimizer::remove_nonrange_trees(param, tree2);
-        if (no_trees)
-        {
-          return (new optimizer::SEL_TREE(optimizer::SEL_TREE::ALWAYS));
-        }
-      }
-      optimizer::SEL_IMERGE *merge= NULL;
+      if (param->remove_jump_scans && (remove_nonrange_trees(param, tree1) || remove_nonrange_trees(param, tree2)))
+        return new SEL_TREE(SEL_TREE::ALWAYS);
       /* both trees are "range" trees, produce new index merge structure */
-			result= new optimizer::SEL_TREE();
-			merge= new optimizer::SEL_IMERGE();
+			result= new SEL_TREE();
+			SEL_IMERGE* merge= new SEL_IMERGE();
 			result->merges.push_back(merge);
-      if (merge->or_sel_tree(param, tree1) || merge->or_sel_tree(param, tree2))
-      {
-        result= NULL;
-      }
-      else
-      {
-        result->type= tree1->type;
-      }
+      merge->or_sel_tree(param, tree1);
+      merge->or_sel_tree(param, tree2);
+      result->type= tree1->type;
     }
     else if (!tree1->merges.is_empty() && !tree2->merges.is_empty())
     {
-      if (imerge_list_or_list(param, &tree1->merges, &tree2->merges))
-        result= new optimizer::SEL_TREE(optimizer::SEL_TREE::ALWAYS);
-      else
-        result= tree1;
+      result= imerge_list_or_list(param, &tree1->merges, &tree2->merges)
+        ? new SEL_TREE(SEL_TREE::ALWAYS)
+        : tree1;
     }
     else
     {
@@ -216,13 +170,12 @@
       if (tree1->merges.is_empty())
         std::swap(tree1, tree2);
 
-      if (param->remove_jump_scans && optimizer::remove_nonrange_trees(param, tree2))
-         return(new optimizer::SEL_TREE(optimizer::SEL_TREE::ALWAYS));
+      if (param->remove_jump_scans && remove_nonrange_trees(param, tree2))
+         return new SEL_TREE(SEL_TREE::ALWAYS);
       /* add tree2 to tree1->merges, checking if it collapses to ALWAYS */
-      if (imerge_list_or_tree(param, &tree1->merges, tree2))
-        result= new optimizer::SEL_TREE(optimizer::SEL_TREE::ALWAYS);
-      else
-        result= tree1;
+      result= imerge_list_or_tree(*param, tree1->merges, *tree2)
+        ? new SEL_TREE(SEL_TREE::ALWAYS)
+        : tree1;
     }
   }
   return result;
@@ -537,7 +490,7 @@
 */
 bool optimizer::remove_nonrange_trees(optimizer::RangeParameter *param, optimizer::SEL_TREE *tree)
 {
-  bool res= false;
+  bool res= true;
   for (uint32_t i= 0; i < param->keys; i++)
   {
     if (tree->keys[i])
@@ -548,10 +501,10 @@
         tree->keys_map.reset(i);
       }
       else
-        res= true;
+        res= false;
     }
   }
-  return ! res;
+  return res;
 }
 
 
@@ -559,9 +512,7 @@
 static bool eq_tree(optimizer::SEL_ARG *a, optimizer::SEL_ARG *b)
 {
   if (a == b)
-  {
     return true;
-  }
 
   if (! a || ! b || ! a->is_same(b))
   {

=== modified file 'drizzled/optimizer/sel_tree.h'
--- drizzled/optimizer/sel_tree.h	2011-03-29 12:45:08 +0000
+++ drizzled/optimizer/sel_tree.h	2011-06-22 18:24:12 +0000
@@ -77,9 +77,7 @@
   read can be constructed for "cond_of_tree1 OR cond_of_tree2" ) without
   using index_merge.
 */
-bool sel_trees_can_be_ored(SEL_TREE *tree1, 
-                           SEL_TREE *tree2,
-                           RangeParameter* param);
+bool sel_trees_can_be_ored(const SEL_TREE&, const SEL_TREE&, const RangeParameter&);
 
 SEL_TREE *
 tree_or(RangeParameter *param, SEL_TREE *tree1, SEL_TREE *tree2);

=== modified file 'drizzled/optimizer/table_read_plan.h'
--- drizzled/optimizer/table_read_plan.h	2011-03-29 12:45:08 +0000
+++ drizzled/optimizer/table_read_plan.h	2011-06-22 17:45:22 +0000
@@ -67,8 +67,8 @@
 
   /* Table read plans are allocated on memory::Root and are never deleted */
   static void *operator new(size_t size, memory::Root *mem_root)
-  { 
-    return (void*) mem_root->alloc_root((uint32_t) size); 
+  {
+    return mem_root->alloc(size);
   }
 
   static void operator delete(void *, size_t)
@@ -90,9 +90,7 @@
 */
 class RangeReadPlan : public TableReadPlan
 {
-
 public:
-
   SEL_ARG *key; /* set of intervals to be used in "range" method retrieval */
   uint32_t     key_idx; /* key number in Parameter::key */
   uint32_t     mrr_flags;
@@ -104,10 +102,8 @@
       key_idx(idx_arg),
       mrr_flags(mrr_flags_arg)
   {}
-  virtual ~RangeReadPlan() {}                     /* Remove gcc warning */
 
   QuickSelectInterface *make_quick(Parameter *param, bool, memory::Root *parent_alloc);
-
 };
 
 
@@ -115,10 +111,6 @@
 class RorIntersectReadPlan : public TableReadPlan
 {
 public:
-
-  RorIntersectReadPlan() {}                      /* Remove gcc warning */
-  virtual ~RorIntersectReadPlan() {}             /* Remove gcc warning */
-
   QuickSelectInterface *make_quick(Parameter *param,
                                    bool retrieve_full_rows,
                                    memory::Root *parent_alloc);
@@ -143,8 +135,6 @@
 class RorUnionReadPlan : public TableReadPlan
 {
 public:
-  RorUnionReadPlan() {}                          /* Remove gcc warning */
-  virtual ~RorUnionReadPlan() {}                 /* Remove gcc warning */
   QuickSelectInterface *make_quick(Parameter *param,
                                    bool retrieve_full_rows,
                                    memory::Root *parent_alloc);
@@ -162,8 +152,6 @@
 class IndexMergeReadPlan : public TableReadPlan
 {
 public:
-  IndexMergeReadPlan() {}                        /* Remove gcc warning */
-  virtual ~IndexMergeReadPlan() {}               /* Remove gcc warning */
   QuickSelectInterface *make_quick(Parameter *param,
                                    bool retrieve_full_rows,
                                    memory::Root *parent_alloc);
@@ -197,19 +185,19 @@
   ha_rows quick_prefix_records;
 
 public:
-  GroupMinMaxReadPlan(bool have_min_arg, 
+  GroupMinMaxReadPlan(bool have_min_arg,
                       bool have_max_arg,
                       KeyPartInfo *min_max_arg_part_arg,
-                      uint32_t group_prefix_len_arg, 
+                      uint32_t group_prefix_len_arg,
                       uint32_t used_key_parts_arg,
-                      uint32_t group_key_parts_arg, 
+                      uint32_t group_key_parts_arg,
                       KeyInfo *index_info_arg,
-                      uint32_t index_arg, 
+                      uint32_t index_arg,
                       uint32_t key_infix_len_arg,
                       unsigned char *key_infix_arg,
-                      SEL_TREE *tree_arg, 
+                      SEL_TREE *tree_arg,
                       SEL_ARG *index_tree_arg,
-                      uint32_t param_idx_arg, 
+                      uint32_t param_idx_arg,
                       ha_rows quick_prefix_records_arg)
     :
       have_min(have_min_arg),
@@ -229,7 +217,6 @@
       if (key_infix_len)
         memcpy(this->key_infix, key_infix_arg, key_infix_len);
     }
-  virtual ~GroupMinMaxReadPlan() {}             /* Remove gcc warning */
 
   QuickSelectInterface *make_quick(Parameter *param,
                                    bool retrieve_full_rows,

=== modified file 'drizzled/plugin/scheduler.h'
--- drizzled/plugin/scheduler.h	2011-03-29 11:04:10 +0000
+++ drizzled/plugin/scheduler.h	2011-06-22 16:36:40 +0000
@@ -42,28 +42,27 @@
   explicit Scheduler(std::string name_arg)
     : Plugin(name_arg, "Scheduler")
   {}
-  virtual ~Scheduler() {}
 
   /**
    * Add a session to the scheduler. When the scheduler is ready to run the
    * session, it should call session->run().
    */
-  virtual bool addSession(Session::shared_ptr &session)= 0;
+  virtual bool addSession(const Session::shared_ptr&)= 0;
 
   /**
    * Notify the scheduler that it should be killed gracefully.
    */
-  virtual void killSession(Session *) {}
+  virtual void killSession(Session*) {}
 
   /**
    * This is called when a scheduler should kill the session immedaitely.
    */
-  virtual void killSessionNow(Session::shared_ptr&) {}
+  virtual void killSessionNow(const Session::shared_ptr&) {}
 
-  static bool addPlugin(plugin::Scheduler *sced);
-  static void removePlugin(plugin::Scheduler *sced);
+  static bool addPlugin(plugin::Scheduler*);
+  static void removePlugin(plugin::Scheduler*);
   static bool setPlugin(const std::string& name);
-  static Scheduler *getScheduler();
+  static Scheduler* getScheduler();
 };
 
 } /* namespace plugin */

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-06-05 23:06:29 +0000
+++ drizzled/session.cc	2011-06-22 16:36:40 +0000
@@ -103,7 +103,7 @@
 char internal_table_name[2]= "*";
 char empty_c_string[1]= {0};    /* used for not defined db */
 
-const char * const Session::DEFAULT_WHERE= "field list";
+const char* const Session::DEFAULT_WHERE= "field list";
 
 uint64_t g_refresh_version = 1;
 
@@ -192,10 +192,10 @@
 
 Session::Session(plugin::Client *client_arg, catalog::Instance::shared_ptr catalog_arg) :
   impl_(new impl_c(*this)),
+  mem(impl_->mem_root),
   mem_root(&impl_->mem_root),
   query(new std::string),
   scheduler(NULL),
-  scheduler_arg(NULL),
   variables(impl_->variables),
   status_var(impl_->status_var),
   lock_id(&main_lock_id),
@@ -246,11 +246,11 @@
   client->setSession(this);
 
   /*
-    Pass nominal parameters to init_alloc_root only to ensure that
+    Pass nominal parameters to init only to ensure that
     the destructor works OK in case of an error. The main_mem_root
     will be re-initialized in init_for_queries().
   */
-  memory::init_sql_alloc(mem_root, memory::ROOT_MIN_BLOCK_SIZE, 0);
+  mem.init(memory::ROOT_MIN_BLOCK_SIZE);
   cuted_fields= sent_row_count= row_count= 0L;
   // Must be reset to handle error with Session's created for init of mysqld
   lex().current_select= 0;
@@ -288,7 +288,7 @@
   memset(&status_var, 0, sizeof(status_var));
 
   /* Initialize sub structures */
-  memory::init_sql_alloc(&warn_root, WARN_ALLOC_BLOCK_SIZE, WARN_ALLOC_PREALLOC_SIZE);
+  warn_root.init(WARN_ALLOC_BLOCK_SIZE);
 
   substitute_null_with_insert_id = false;
   lock_info.init(); /* safety: will be reset after start */
@@ -337,32 +337,30 @@
 	return session().transaction;
 }
 
-bool Session::add_item_to_list(Item *item)
+void Session::add_item_to_list(Item *item)
 {
-  return lex().current_select->add_item_to_list(this, item);
+  lex().current_select->add_item_to_list(this, item);
 }
 
-bool Session::add_value_to_list(Item *value)
+void Session::add_value_to_list(Item *value)
 {
 	lex().value_list.push_back(value);
-  return false;
-}
-
-bool Session::add_order_to_list(Item *item, bool asc)
-{
-  return lex().current_select->add_order_to_list(this, item, asc);
-}
-
-bool Session::add_group_to_list(Item *item, bool asc)
-{
-  return lex().current_select->add_group_to_list(this, item, asc);
+}
+
+void Session::add_order_to_list(Item *item, bool asc)
+{
+  lex().current_select->add_order_to_list(this, item, asc);
+}
+
+void Session::add_group_to_list(Item *item, bool asc)
+{
+  lex().current_select->add_group_to_list(this, item, asc);
 }
 
 void Session::free_items()
 {
-  Item *next;
   /* This works because items are allocated with memory::sql_alloc() */
-  for (; free_list; free_list= next)
+  for (Item* next; free_list; free_list= next)
   {
     next= free_list->next;
     free_list->delete_self();
@@ -458,8 +456,8 @@
   mysys_var=0;					// Safety (shouldn't be needed)
 
   impl_->mem_root.free_root(MYF(0));
-  currentMemRoot().release();
-  currentSession().release();
+  setCurrentMemRoot(NULL);
+  setCurrentSession(NULL);
 
   plugin::Logging::postEndDo(this);
   plugin::EventObserver::deregisterSessionEvents(session_event_observers); 
@@ -530,8 +528,8 @@
     to track stack overrun.
   */
   assert(thread_stack);
-  currentSession().reset(this);
-  currentMemRoot().reset(&mem_root);
+  setCurrentSession(this);
+  setCurrentMemRoot(&mem);
 
   mysys_var= my_thread_var;
 
@@ -564,8 +562,7 @@
   command= COM_SLEEP;
   times.set_time();
 
-  mem_root->reset_root_defaults(variables.query_alloc_block_size,
-                                variables.query_prealloc_size);
+  mem.reset_defaults(variables.query_alloc_block_size, variables.query_prealloc_size);
   transaction.xid_state.xid.set_null();
   transaction.xid_state.in_session=1;
   if (use_usage)
@@ -589,7 +586,7 @@
   disconnect();
 }
 
-bool Session::schedule(Session::shared_ptr &arg)
+bool Session::schedule(const shared_ptr& arg)
 {
   arg->scheduler= plugin::Scheduler::getScheduler();
   assert(arg->scheduler);
@@ -624,13 +621,10 @@
 
     /* Can't use my_error() since store_globals has not been called. */
     /* TODO replace will better error message */
-    snprintf(error_message_buff, sizeof(error_message_buff),
-             ER(ER_CANT_CREATE_THREAD), 1);
+    snprintf(error_message_buff, sizeof(error_message_buff), ER(ER_CANT_CREATE_THREAD), 1);
     arg->client->sendError(ER_CANT_CREATE_THREAD, error_message_buff);
-
     return true;
   }
-
   return false;
 }
 
@@ -889,8 +883,8 @@
                                      bool allocate_lex_string)
 {
   if (allocate_lex_string)
-    lex_str= (LEX_STRING *)getMemRoot()->allocate(sizeof(LEX_STRING));
-  lex_str->str= mem_root->strmake_root(str, length);
+    lex_str= (LEX_STRING *)mem.alloc(sizeof(LEX_STRING));
+  lex_str->str= mem_root->strmake(str, length);
   lex_str->length= length;
   return lex_str;
 }
@@ -1026,30 +1020,24 @@
 */
 
 
-static int create_file(Session *session,
+static int create_file(Session& session,
                        fs::path &target_path,
                        file_exchange *exchange,
                        internal::io_cache_st *cache)
 {
   fs::path to_file(exchange->file_name);
-  int file;
 
   if (not to_file.has_root_directory())
   {
     target_path= fs::system_complete(getDataHomeCatalog());
-    util::string::ptr schema(session->schema());
+    util::string::ptr schema(session.schema());
     if (not schema->empty())
     {
       int count_elements= 0;
-      for (fs::path::iterator iter= to_file.begin();
-           iter != to_file.end();
-           ++iter, ++count_elements)
-      { }
-
+      for (fs::path::iterator it= to_file.begin(); it != to_file.end(); it++)
+        count_elements++;
       if (count_elements == 1)
-      {
         target_path /= *schema;
-      }
     }
     target_path /= to_file;
   }
@@ -1074,10 +1062,11 @@
     return -1;
   }
   /* Create the file world readable */
-  if ((file= internal::my_create(target_path.file_string().c_str(), 0666, O_WRONLY|O_EXCL, MYF(MY_WME))) < 0)
+  int file= internal::my_create(target_path.file_string().c_str(), 0666, O_WRONLY|O_EXCL, MYF(MY_WME));
+  if (file < 0)
     return file;
   (void) fchmod(file, 0666);			// Because of umask()
-  if (cache->init_io_cache(file, 0L, internal::WRITE_CACHE, 0L, 1, MYF(MY_WME)))
+  if (cache->init_io_cache(file, 0, internal::WRITE_CACHE, 0L, 1, MYF(MY_WME)))
   {
     internal::my_close(file, MYF(0));
     internal::my_delete(target_path.file_string().c_str(), MYF(0));  // Delete file on error, it was just created
@@ -1144,7 +1133,7 @@
     return 1;
   }
 
-  if ((file= create_file(session, path, exchange, cache)) < 0)
+  if ((file= create_file(*session, path, exchange, cache)) < 0)
     return 1;
 
   return 0;
@@ -1348,7 +1337,7 @@
 select_dump::prepare(List<Item> &, Select_Lex_Unit *u)
 {
   unit= u;
-  return (int) ((file= create_file(session, path, exchange, cache)) < 0);
+  return (file= create_file(*session, path, exchange, cache)) < 0;
 }
 
 
@@ -1557,7 +1546,7 @@
     my_message(ER_NO_DB_ERROR, ER(ER_NO_DB_ERROR), MYF(0));
     return true;
   }
-  *p_db= strmake(impl_->schema->c_str(), impl_->schema->size());
+  *p_db= mem.strmake(*impl_->schema);
   *p_db_length= impl_->schema->size();
   return false;
 }

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2011-06-05 23:06:29 +0000
+++ drizzled/session.h	2011-06-22 16:36:40 +0000
@@ -108,25 +108,7 @@
                         and update_row.
   */
   enum_mark_columns mark_used_columns;
-  inline void* calloc(size_t size)
-  {
-    void *ptr= mem_root->alloc_root(size);
-    if (ptr)
-      memset(ptr, 0, size);
-    return ptr;
-  }
-  inline char *strmake(const char *str, size_t size)
-  {
-    return mem_root->strmake_root(str,size);
-  }
 
-  inline void *memdup_w_gap(const void *str, size_t size, uint32_t gap)
-  {
-    void *ptr= mem_root->alloc_root(size + gap);
-    if (ptr)
-      memcpy(ptr, str, size);
-    return ptr;
-  }
   /** Frees all items attached to this Statement */
   void free_items();
 
@@ -135,12 +117,8 @@
    * itself to the list on creation (see Item::Item() for details))
    */
   Item *free_list;
-  memory::Root *mem_root; /**< Pointer to current memroot */
-
-  memory::Root *getMemRoot()
-  {
-    return mem_root;
-  }
+  memory::Root& mem;
+  memory::Root* mem_root; /**< Pointer to current memroot */
 
   uint64_t getXaId()
   {
@@ -185,7 +163,7 @@
       return NULL;
     }
     length= tmp_string->length();
-    return strmake(tmp_string->c_str(), tmp_string->length());
+    return mem.strmake(*tmp_string);
   }
 
   util::string::ptr schema() const;
@@ -198,7 +176,7 @@
     It's needed because we do not save/restore Session::where normally during
     primary (non subselect) query execution.
   */
-  static const char * const DEFAULT_WHERE;
+  static const char* const DEFAULT_WHERE;
 
   memory::Root warn_root; /**< Allocation area for warnings and errors */
 public:
@@ -209,10 +187,9 @@
     return client;
   }
 
-  plugin::Scheduler *scheduler; /**< Pointer to scheduler object */
-  void *scheduler_arg; /**< Pointer to the optional scheduler argument */
+  plugin::Scheduler* scheduler; /**< Pointer to scheduler object */
 
-  typedef boost::unordered_map< std::string, user_var_entry *, util::insensitive_hash, util::insensitive_equal_to> UserVars;
+  typedef boost::unordered_map<std::string, user_var_entry*, util::insensitive_hash, util::insensitive_equal_to> UserVars;
 
 private:
   typedef std::pair< UserVars::iterator, UserVars::iterator > UserVarsRange;
@@ -747,8 +724,8 @@
     return first_successful_insert_id_in_prev_stmt;
   }
 
-  Session(plugin::Client *client_arg, boost::shared_ptr<catalog::Instance> catalog);
-  virtual ~Session();
+  Session(plugin::Client*, boost::shared_ptr<catalog::Instance>);
+  ~Session();
 
   void cleanup();
   /**
@@ -829,9 +806,9 @@
    */
   bool authenticate();
   void run();
-  static bool schedule(Session::shared_ptr&);
+  static bool schedule(const Session::shared_ptr&);
   static void unlink(session_id_t&);
-  static void unlink(Session::shared_ptr&);
+  static void unlink(const Session::shared_ptr&);
 
   /*
     For enter_cond() / exit_cond() to work the mutex must be got before
@@ -1049,10 +1026,10 @@
 public:
   void my_ok(ha_rows affected_rows= 0, ha_rows found_rows_arg= 0, uint64_t passed_id= 0, const char *message= NULL);
   void my_eof();
-  bool add_item_to_list(Item *item);
-  bool add_value_to_list(Item *value);
-  bool add_order_to_list(Item *item, bool asc);
-  bool add_group_to_list(Item *item, bool asc);
+  void add_item_to_list(Item *item);
+  void add_value_to_list(Item *value);
+  void add_order_to_list(Item *item, bool asc);
+  void add_group_to_list(Item *item, bool asc);
 
   void refresh_status();
   user_var_entry *getVariable(LEX_STRING &name, bool create_if_not_exists);

=== modified file 'drizzled/session/cache.cc'
--- drizzled/session/cache.cc	2011-06-17 07:07:02 +0000
+++ drizzled/session/cache.cc	2011-06-22 16:36:40 +0000
@@ -34,7 +34,7 @@
 boost::mutex Cache::_mutex;
 boost::condition_variable Cache::_end;
 
-Cache::session_shared_ptr Cache::find(const session_id_t &id)
+Cache::session_ptr Cache::find(const session_id_t &id)
 {
   boost::mutex::scoped_lock scopedLock(_mutex);
   BOOST_FOREACH(list::const_reference it, cache)
@@ -42,7 +42,7 @@
     if (it->thread_id == id)
       return it;
   }
-  return session_shared_ptr();
+  return session_ptr();
 }
 
 void Cache::shutdownFirst()
@@ -72,13 +72,13 @@
   return cache.size();
 }
 
-void Cache::insert(session_shared_ptr &arg)
+void Cache::insert(const session_ptr& arg)
 {
   boost::mutex::scoped_lock scopedLock(_mutex);
   cache.push_back(arg);
 }
 
-void Cache::erase(session_shared_ptr &arg)
+void Cache::erase(const session_ptr& arg)
 {
   list::iterator iter= std::find(cache.begin(), cache.end(), arg);
   assert(iter != cache.end());

=== modified file 'drizzled/session/cache.h'
--- drizzled/session/cache.h	2011-04-20 09:27:49 +0000
+++ drizzled/session/cache.h	2011-06-22 16:36:40 +0000
@@ -29,9 +29,9 @@
 
 class DRIZZLED_API Cache 
 {
-  typedef boost::shared_ptr<drizzled::Session> session_shared_ptr;
+  typedef boost::shared_ptr<drizzled::Session> session_ptr;
 public:
-  typedef std::list<session_shared_ptr> list;
+  typedef std::list<session_ptr> list;
 
   static list &getCache()
   {
@@ -51,11 +51,11 @@
   static void shutdownFirst();
   static void shutdownSecond();
 
-  static void erase(session_shared_ptr&);
+  static void erase(const session_ptr&);
   static size_t count();
-  static void insert(session_shared_ptr &arg);
+  static void insert(const session_ptr&);
 
-  static session_shared_ptr find(const session_id_t &id);
+  static session_ptr find(const session_id_t&);
 
 private:
   static bool volatile _ready_to_exit;

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2011-04-08 14:46:29 +0000
+++ drizzled/show.cc	2011-06-21 19:11:23 +0000
@@ -45,11 +45,9 @@
 
 using namespace std;
 
-namespace drizzled
-{
+namespace drizzled {
 
-inline const char *
-str_or_nil(const char *str)
+inline const char* str_or_nil(const char *str)
 {
   return str ? str : "<nil>";
 }
@@ -139,7 +137,7 @@
 
 namespace show {
 
-bool buildScemas(Session *session)
+bool buildSchemas(Session *session)
 {
   session->lex().sql_command= SQLCOM_SELECT;
   session->lex().statement= new statement::Show(session);
@@ -167,12 +165,8 @@
   my_field->is_autogenerated_name= false;
   my_field->set_name(column_name.c_str(), column_name.length(), system_charset_info);
 
-  if (session->add_item_to_list(my_field))
-    return false;
-
-  if (session->add_order_to_list(my_field, true))
-    return false;
-
+  session->add_item_to_list(my_field);
+  session->add_order_to_list(my_field, true);
   return true;
 }
 
@@ -223,30 +217,21 @@
   my_field->is_autogenerated_name= false;
   my_field->set_name(column_name.c_str(), column_name.length(), system_charset_info);
 
-  if (session->add_item_to_list(my_field))
-    return false;
-
-  if (session->add_order_to_list(my_field, true))
-    return false;
-
+  session->add_item_to_list(my_field);
+  session->add_order_to_list(my_field, true);
   return true;
 }
 
 bool buildTemporaryTables(Session *session)
 {
   session->lex().sql_command= SQLCOM_SELECT;
-
   session->lex().statement= new statement::Show(session);
 
-
   if (prepare_new_schema_table(session, session->lex(), "SHOW_TEMPORARY_TABLES"))
     return false;
 
-  if (session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*")))
-    return false;
-
-  (session->lex().current_select->with_wild)++;
-
+  session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*"));
+  session->lex().current_select->with_wild++;
   return true;
 }
 
@@ -284,11 +269,8 @@
   if (prepare_new_schema_table(session, session->lex(), "SHOW_TABLE_STATUS"))
     return false;
 
-  if (session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*")))
-    return false;
-
-  (session->lex().current_select->with_wild)++;
-
+  session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*"));
+  session->lex().current_select->with_wild++;
   return true;
 }
 
@@ -339,11 +321,8 @@
   if (prepare_new_schema_table(session, session->lex(), "SHOW_COLUMNS"))
     return false;
 
-  if (session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*")))
-    return false;
-
-  (session->lex().current_select->with_wild)++;
-
+  session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*"));
+  session->lex().current_select->with_wild++;
   return true;
 }
 
@@ -405,11 +384,8 @@
   if (prepare_new_schema_table(session, session->lex(), "SHOW_INDEXES"))
     return false;
 
-  if (session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*")))
-    return false;
-
-  (session->lex().current_select->with_wild)++;
-
+  session->add_item_to_list(new Item_field(&session->lex().current_select->context, NULL, NULL, "*"));
+  session->lex().current_select->with_wild++;
   return true;
 }
 
@@ -435,17 +411,11 @@
   Item_field *my_field= new Item_field(&session->lex().current_select->context, NULL, NULL, "VARIABLE_NAME");
   my_field->is_autogenerated_name= false;
   my_field->set_name(key.c_str(), key.length(), system_charset_info);
-
-  if (session->add_item_to_list(my_field))
-    return false;
-
+  session->add_item_to_list(my_field);
   my_field= new Item_field(&session->lex().current_select->context, NULL, NULL, "VARIABLE_VALUE");
   my_field->is_autogenerated_name= false;
   my_field->set_name(value.c_str(), value.length(), system_charset_info);
-
-  if (session->add_item_to_list(my_field))
-    return false;
-
+  session->add_item_to_list(my_field);
   return true;
 }
 
@@ -482,17 +452,11 @@
   Item_field *my_field= new Item_field(&session->lex().current_select->context, NULL, NULL, "TABLE_NAME");
   my_field->is_autogenerated_name= false;
   my_field->set_name(key.c_str(), key.length(), system_charset_info);
-
-  if (session->add_item_to_list(my_field))
-    return false;
-
+  session->add_item_to_list(my_field);
   my_field= new Item_field(&session->lex().current_select->context, NULL, NULL, "TABLE_SQL_DEFINITION");
   my_field->is_autogenerated_name= false;
   my_field->set_name(value.c_str(), value.length(), system_charset_info);
-
-  if (session->add_item_to_list(my_field))
-    return false;
-
+  session->add_item_to_list(my_field);
   return true;
 }
 
@@ -504,11 +468,8 @@
   if (prepare_new_schema_table(session, session->lex(), "PROCESSLIST"))
     return false;
 
-  if (session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*")))
-    return false;
-
-  (session->lex().current_select->with_wild)++;
-
+  session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*"));
+  session->lex().current_select->with_wild++;
   return true;
 }
 
@@ -534,17 +495,12 @@
   Item_field *my_field= new Item_field(&session->lex().current_select->context, NULL, NULL, "VARIABLE_NAME");
   my_field->is_autogenerated_name= false;
   my_field->set_name(key.c_str(), key.length(), system_charset_info);
-
-  if (session->add_item_to_list(my_field))
-    return false;
-
+  session->add_item_to_list(my_field);
   my_field= new Item_field(&session->lex().current_select->context, NULL, NULL, "VARIABLE_VALUE");
   my_field->is_autogenerated_name= false;
   my_field->set_name(value.c_str(), value.length(), system_charset_info);
 
-  if (session->add_item_to_list(my_field))
-    return false;
-
+  session->add_item_to_list(my_field);
   return true;
 }
 
@@ -578,17 +534,12 @@
   Item_field *my_field= new Item_field(&session->lex().current_select->context, NULL, NULL, "SCHEMA_NAME");
   my_field->is_autogenerated_name= false;
   my_field->set_name(key.c_str(), key.length(), system_charset_info);
-
-  if (session->add_item_to_list(my_field))
-    return false;
-
+  session->add_item_to_list(my_field);
   my_field= new Item_field(&session->lex().current_select->context, NULL, NULL, "SCHEMA_SQL_DEFINITION");
   my_field->is_autogenerated_name= false;
   my_field->set_name(value.c_str(), value.length(), system_charset_info);
 
-  if (session->add_item_to_list(my_field))
-    return false;
-
+  session->add_item_to_list(my_field);
   return true;
 }
 
@@ -629,17 +580,10 @@
   {
     return false;
   }
-
-  if (session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*")))
-  {
-    return false;
-  }
-
-  (session->lex().current_select->with_wild)++;
-
+  session->add_item_to_list( new Item_field(&session->lex().current_select->context, NULL, NULL, "*"));
+  session->lex().current_select->with_wild++;
   return true;
 }
 
-} /* namespace drizzled */
-
+}
 } /* namespace drizzled */

=== modified file 'drizzled/show.h'
--- drizzled/show.h	2011-03-28 23:02:08 +0000
+++ drizzled/show.h	2011-06-21 19:11:23 +0000
@@ -46,7 +46,7 @@
 bool buildDescribe(Session *session, Table_ident *ident);
 bool buildIndex(Session *session, const char *schema_ident, Table_ident *table_ident);
 bool buildProcesslist(Session *session);
-bool buildScemas(Session *session);
+bool buildSchemas(Session*);
 bool buildStatus(Session *session, const drizzled::sql_var_t is_global);
 bool buildEngineStatus(Session *session, LEX_STRING);
 bool buildTableStatus(Session *session, const char *ident);

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2011-06-17 13:13:07 +0000
+++ drizzled/sql_base.cc	2011-06-22 20:05:58 +0000
@@ -446,7 +446,7 @@
     */
     table_list= res->next_global;
   }
-  return(res);
+  return res;
 }
 
 
@@ -1625,7 +1625,6 @@
 
 int Session::lock_tables(TableList *tables, uint32_t count, bool *need_reopen)
 {
-  TableList *table;
   Session *session= this;
 
   /*
@@ -1638,23 +1637,19 @@
     return 0;
 
   assert(session->open_tables.lock == 0);	// You must lock everything at once
-  Table **start,**ptr;
   uint32_t lock_flag= DRIZZLE_LOCK_NOTIFY_IF_NEED_REOPEN;
 
-  if (!(ptr=start=(Table**) session->getMemRoot()->allocate(sizeof(Table*)*count)))
-    return -1;
-
-  for (table= tables; table; table= table->next_global)
+  Table** start;
+  Table** ptr=start=(Table**) session->mem.alloc(sizeof(Table*)*count);
+  for (TableList* table= tables; table; table= table->next_global)
   {
     if (!table->placeholder())
       *(ptr++)= table->table;
   }
-
   if (not (session->open_tables.lock= session->lockTables(start, (uint32_t) (ptr - start), lock_flag)))
   {
     return -1;
   }
-
   return 0;
 }
 

=== modified file 'drizzled/sql_delete.cc'
--- drizzled/sql_delete.cc	2011-04-29 00:19:38 +0000
+++ drizzled/sql_delete.cc	2011-06-22 20:05:58 +0000
@@ -55,8 +55,6 @@
   optimizer::SqlSelect *select= NULL;
   ReadRecord	info;
   bool          using_limit=limit != HA_POS_ERROR;
-  bool		transactional_table, const_cond;
-  bool          const_cond_result;
   ha_rows	deleted= 0;
   uint32_t usable_index= MAX_KEY;
   Select_Lex   *select_lex= &session->lex().select_lex;
@@ -90,27 +88,26 @@
     tables.table = table;
     tables.alias = table_list->alias;
 
-      if (select_lex->setup_ref_array(session, order->elements) ||
-	  setup_order(session, select_lex->ref_pointer_array, &tables,
-                    fields, all_fields, (Order*) order->first))
-      {
-        delete select;
-        free_underlaid_joins(session, &session->lex().select_lex);
-        DRIZZLE_DELETE_DONE(1, 0);
+    select_lex->setup_ref_array(session, order->elements);
+    if (setup_order(session, select_lex->ref_pointer_array, &tables, fields, all_fields, (Order*) order->first))
+    {
+      delete select;
+      free_underlaid_joins(session, &session->lex().select_lex);
+      DRIZZLE_DELETE_DONE(1, 0);
 
-        return true;
-      }
+      return true;
+    }
   }
 
-  const_cond= (!conds || conds->const_item());
+  bool const_cond= not conds || conds->const_item();
 
   select_lex->no_error= session->lex().ignore;
 
-  const_cond_result= const_cond && (!conds || conds->val_int());
+  bool const_cond_result= const_cond && (!conds || conds->val_int());
   if (session->is_error())
   {
     /* Error evaluating val_int(). */
-    return(true);
+    return true;
   }
 
   /*
@@ -201,10 +198,6 @@
 
   if (order && order->elements)
   {
-    uint32_t         length= 0;
-    SortField  *sortorder;
-    ha_rows examined_rows;
-
     if ((!select || table->quick_keys.none()) && limit != HA_POS_ERROR)
       usable_index= optimizer::get_index_for_order(table, (Order*)(order->first), limit);
 
@@ -212,12 +205,10 @@
     {
       FileSort filesort(*session);
       table->sort.io_cache= new internal::io_cache_st;
-
-
-      if (not (sortorder= make_unireg_sortorder((Order*) order->first, &length, NULL)) ||
-	  (table->sort.found_records = filesort.run(table, sortorder, length,
-						    select, HA_POS_ERROR, 1,
-						    examined_rows)) == HA_POS_ERROR)
+      uint32_t length= 0;
+      SortField* sortorder= make_unireg_sortorder((Order*) order->first, &length, NULL);
+      ha_rows examined_rows;
+      if ((table->sort.found_records= filesort.run(table, sortorder, length, select, HA_POS_ERROR, 1, examined_rows)) == HA_POS_ERROR)
       {
         delete select;
         free_underlaid_joins(session, &session->lex().select_lex);
@@ -327,7 +318,7 @@
   }
 
   delete select;
-  transactional_table= table->cursor->has_transactions();
+  bool transactional_table= table->cursor->has_transactions();
 
   if (!transactional_table && deleted > 0)
     session->transaction.stmt.markModifiedNonTransData();
@@ -374,30 +365,21 @@
 int prepare_delete(Session *session, TableList *table_list, Item **conds)
 {
   Select_Lex *select_lex= &session->lex().select_lex;
-
-  List<Item> all_fields;
-
   session->lex().allow_sum_func= 0;
-  if (setup_tables_and_check_access(session, &session->lex().select_lex.context,
-                                    &session->lex().select_lex.top_join_list,
-                                    table_list,
-                                    &select_lex->leaf_tables, false) ||
+  if (setup_tables_and_check_access(session, &session->lex().select_lex.context, &select_lex->top_join_list, 
+    table_list, &select_lex->leaf_tables, false) ||
       session->setup_conds(table_list, conds))
-    return(true);
+    return true;
+
+  if (unique_table(table_list, table_list->next_global))
   {
-    TableList *duplicate;
-    if ((duplicate= unique_table(table_list, table_list->next_global)))
-    {
-      my_error(ER_UPDATE_TABLE_USED, MYF(0), table_list->alias);
-      return(true);
-    }
+    my_error(ER_UPDATE_TABLE_USED, MYF(0), table_list->alias);
+    return true;
   }
-
-  if (select_lex->inner_refs_list.size() &&
-    fix_inner_refs(session, all_fields, select_lex, select_lex->ref_pointer_array))
-    return(true);
-
-  return(false);
+  List<Item> all_fields;
+  if (select_lex->inner_refs_list.size() && fix_inner_refs(session, all_fields, select_lex, select_lex->ref_pointer_array))
+    return true;
+  return false;
 }
 
 
@@ -412,22 +394,17 @@
 
 bool truncate(Session& session, TableList *table_list)
 {
-  bool error;
-  TransactionServices &transaction_services= TransactionServices::singleton();
-
   uint64_t save_options= session.options;
   table_list->lock_type= TL_WRITE;
   session.options&= ~(OPTION_BEGIN | OPTION_NOT_AUTOCOMMIT);
   init_select(&session.lex());
-  error= delete_query(&session, table_list, (COND*) 0, (SQL_LIST*) 0,
-                      HA_POS_ERROR, 0L, true);
+  int error= delete_query(&session, table_list, (COND*) 0, (SQL_LIST*) 0, HA_POS_ERROR, 0L, true);
   /*
     Safety, in case the engine ignored ha_enable_transaction(false)
     above. Also clears session->transaction.*.
   */
-  error= transaction_services.autocommitOrRollback(session, error);
+  error= TransactionServices::singleton().autocommitOrRollback(session, error);
   session.options= save_options;
-
   return error;
 }
 

=== modified file 'drizzled/sql_derived.cc'
--- drizzled/sql_derived.cc	2011-04-09 16:11:46 +0000
+++ drizzled/sql_derived.cc	2011-06-22 20:05:58 +0000
@@ -109,7 +109,7 @@
       sl->context.outer_context= 0;
 
     if (!(derived_result= new select_union))
-      return(true); // out of memory
+      return true; // out of memory
 
     // Select_Lex_Unit::prepare correctly work for single select
     if ((res= unit->prepare(session, derived_result, 0)))
@@ -164,7 +164,7 @@
     }
   }
 
-  return(res);
+  return res;
 }
 
 /*

=== modified file 'drizzled/sql_error.cc'
--- drizzled/sql_error.cc	2011-06-05 22:25:43 +0000
+++ drizzled/sql_error.cc	2011-06-22 20:05:58 +0000
@@ -67,7 +67,7 @@
 */
 void DRIZZLE_ERROR::set_msg(Session *session, const char *msg_arg)
 {
-  msg= session->warn_root.strdup_root(msg_arg);
+  msg= session->warn_root.strdup(msg_arg);
 }
 
 /*
@@ -235,10 +235,10 @@
     session->getClient()->store((uint32_t) err->code);
     session->getClient()->store(err->msg, strlen(err->msg));
     if (session->getClient()->flush())
-      return(true);
+      return true;
   }
   session->my_eof();
-  return(false);
+  return false;
 }
 
 } /* namespace drizzled */

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2011-04-13 10:38:28 +0000
+++ drizzled/sql_insert.cc	2011-06-22 20:05:58 +0000
@@ -554,9 +554,9 @@
                                     table_list,
                                     &session->lex().select_lex.leaf_tables,
                                     select_insert))
-    return(true);
+    return true;
 
-  return(false);
+  return false;
 }
 
 
@@ -633,11 +633,11 @@
   {
     /* it should be allocated before Item::fix_fields() */
     if (table_list->set_insert_values(session->mem_root))
-      return(true);
+      return true;
   }
 
   if (prepare_insert_check_table(session, table_list, fields, select_insert))
-    return(true);
+    return true;
 
 
   /* Prepare the fields in the statement. */
@@ -685,7 +685,7 @@
   }
 
   if (res)
-    return(res);
+    return res;
 
   if (not table)
     table= table_list->table;
@@ -1055,7 +1055,7 @@
                            lex->update_list, lex->value_list,
                            lex->duplicates,
                            &select_lex->where, true, false, false))
-    return(true);
+    return true;
 
   /*
     exclude first table from leaf tables list, because it belong to
@@ -1065,7 +1065,7 @@
   lex->leaf_tables_insert= select_lex->leaf_tables;
   /* skip all leaf tables belonged to view where we are insert */
   select_lex->leaf_tables= select_lex->leaf_tables->next_leaf;
-  return(false);
+  return false;
 }
 
 
@@ -1219,7 +1219,7 @@
   table->mark_columns_needed_for_insert();
 
 
-  return(res);
+  return res;
 }
 
 

=== modified file 'drizzled/sql_lex.cc'
--- drizzled/sql_lex.cc	2011-04-16 13:00:30 +0000
+++ drizzled/sql_lex.cc	2011-06-21 19:11:23 +0000
@@ -55,13 +55,9 @@
 /**
   save order by and tables in own lists.
 */
-static bool add_to_list(Session *session, SQL_LIST &list, Item *item, bool asc)
+static void add_to_list(Session *session, SQL_LIST &list, Item *item, bool asc)
 {
-  Order *order;
-
-  if (!(order = (Order *) session->getMemRoot()->allocate(sizeof(Order))))
-    return true;
-
+  Order* order = (Order *) session->mem.alloc(sizeof(Order));
   order->item_ptr= item;
   order->item= &order->item_ptr;
   order->asc = asc;
@@ -69,8 +65,6 @@
   order->used=0;
   order->counter_used= 0;
   list.link_in_list((unsigned char*) order, (unsigned char**) &order->next);
-
-  return false;
 }
 
 /**
@@ -104,7 +98,7 @@
   ignore_space(1),
   in_comment(NO_COMMENT)
 {
-  m_cpp_buf= (char*) session->getMemRoot()->allocate(length + 1);
+  m_cpp_buf= (char*) session->mem.alloc(length + 1);
   m_cpp_ptr= m_cpp_buf;
 }
 
@@ -309,7 +303,7 @@
   LEX_STRING tmp;
   lip->yyUnget();                       // ptr points now after last token char
   tmp.length=lip->yytoklen=length;
-  tmp.str= lip->m_session->strmake(lip->get_tok_start() + skip, tmp.length);
+  tmp.str= lip->m_session->mem.strmake(lip->get_tok_start() + skip, tmp.length);
 
   lip->m_cpp_text_start= lip->get_cpp_tok_start() + skip;
   lip->m_cpp_text_end= lip->m_cpp_text_start + tmp.length;
@@ -332,7 +326,7 @@
   char *to;
   lip->yyUnget();                       // ptr points now after last token char
   tmp.length= lip->yytoklen=length;
-  tmp.str=(char*) lip->m_session->getMemRoot()->allocate(tmp.length+1);
+  tmp.str=(char*) lip->m_session->mem.alloc(tmp.length+1);
   from= lip->get_tok_start() + skip;
   to= tmp.str;
   end= to+length;
@@ -398,18 +392,14 @@
         lip->yyUnget();
 
       /* Found end. Unescape and return string */
-      const char *str, *end;
-      char *start;
-
-      str= lip->get_tok_start();
-      end= lip->get_ptr();
+      const char* str= lip->get_tok_start();
+      const char* end= lip->get_ptr();
       /* Extract the text from the token */
       str+= pre_skip;
       end-= post_skip;
       assert(end >= str);
 
-      if (!(start= (char*) lip->m_session->getMemRoot()->allocate((uint32_t) (end-str)+1)))
-        return (char*) "";		// memory::SqlAlloc has set error flag
+      char* start= (char*) lip->m_session->mem.alloc((uint32_t) (end-str)+1);
 
       lip->m_cpp_text_start= lip->get_cpp_tok_start() + pre_skip;
       lip->m_cpp_text_end= lip->get_cpp_ptr() - post_skip;
@@ -1614,20 +1604,19 @@
   return (Select_Lex*) master;
 }
 
-bool Select_Lex::add_order_to_list(Session *session, Item *item, bool asc)
+void Select_Lex::add_order_to_list(Session *session, Item *item, bool asc)
 {
-  return add_to_list(session, order_list, item, asc);
+  add_to_list(session, order_list, item, asc);
 }
 
-bool Select_Lex::add_item_to_list(Session *, Item *item)
+void Select_Lex::add_item_to_list(Session *, Item *item)
 {
 	item_list.push_back(item);
-  return false;
 }
 
-bool Select_Lex::add_group_to_list(Session *session, Item *item, bool asc)
+void Select_Lex::add_group_to_list(Session *session, Item *item, bool asc)
 {
-  return add_to_list(session, group_list, item, asc);
+  add_to_list(session, group_list, item, asc);
 }
 
 Select_Lex_Unit* Select_Lex::master_unit()
@@ -1667,18 +1656,10 @@
   return &item_list;
 }
 
-
-bool Select_Lex::setup_ref_array(Session *session, uint32_t order_group_num)
+void Select_Lex::setup_ref_array(Session *session, uint32_t order_group_num)
 {
-  if (ref_pointer_array)
-    return false;
-
-  return (ref_pointer_array=
-          (Item **)session->getMemRoot()->allocate(sizeof(Item*) * (n_child_sum_items +
-                                                 item_list.size() +
-                                                 select_n_having_items +
-                                                 select_n_where_fields +
-                                                 order_group_num)*5)) == 0;
+  if (not ref_pointer_array)
+    ref_pointer_array= (Item **)session->mem.alloc(sizeof(Item*) * (n_child_sum_items + item_list.size() + select_n_having_items + select_n_where_fields + order_group_num)*5);
 }
 
 void Select_Lex_Unit::print(String *str)

=== modified file 'drizzled/sql_lex.h'
--- drizzled/sql_lex.h	2011-04-16 13:00:30 +0000
+++ drizzled/sql_lex.h	2011-06-22 14:35:11 +0000
@@ -234,10 +234,10 @@
     return memory::sql_alloc(size);
   }
   static void *operator new(size_t size, memory::Root *mem_root)
-  { return (void*) mem_root->alloc_root((uint32_t) size); }
-  static void operator delete(void *, size_t)
+  { return mem_root->alloc(size); }
+  static void operator delete(void*, size_t)
   {  }
-  static void operator delete(void *, memory::Root *)
+  static void operator delete(void*, memory::Root*)
   {}
   Select_Lex_Node(): linkage(UNSPECIFIED_TYPE) {}
   virtual ~Select_Lex_Node() {}
@@ -578,9 +578,9 @@
   bool inc_in_sum_expr();
   uint32_t get_in_sum_expr();
 
-  bool add_item_to_list(Session *session, Item *item);
-  bool add_group_to_list(Session *session, Item *item, bool asc);
-  bool add_order_to_list(Session *session, Item *item, bool asc);
+  void add_item_to_list(Session *session, Item *item);
+  void add_group_to_list(Session *session, Item *item, bool asc);
+  void add_order_to_list(Session *session, Item *item, bool asc);
   TableList* add_table_to_list(Session *session,
                                Table_ident *table,
                                LEX_STRING *alias,
@@ -589,7 +589,7 @@
                                List<Index_hint> *hints= 0,
                                LEX_STRING *option= 0);
   TableList* get_table_list();
-  bool init_nested_join(Session *session);
+  void init_nested_join(Session&);
   TableList *end_nested_join(Session *session);
   TableList *nest_last_join(Session *session);
   void add_joined_table(TableList *table);
@@ -620,7 +620,7 @@
     init_query();
     init_select();
   }
-  bool setup_ref_array(Session *session, uint32_t order_group_num);
+  void setup_ref_array(Session *session, uint32_t order_group_num);
   void print(Session *session, String *str);
   static void print_order(String *str, Order *order);
 

=== modified file 'drizzled/sql_load.cc'
--- drizzled/sql_load.cc	2011-04-29 00:19:38 +0000
+++ drizzled/sql_load.cc	2011-06-22 20:05:58 +0000
@@ -154,11 +154,11 @@
   if (escaped->length() > 4 || enclosed->length() > 4)
   {
     my_error(ER_WRONG_FIELD_TERMINATORS,MYF(0),enclosed->c_ptr(), enclosed->length());
-    return(true);
+    return true;
   }
 
   if (session->openTablesLock(table_list))
-    return(true);
+    return true;
 
   if (setup_tables_and_check_access(session, &session->lex().select_lex.context,
                                     &session->lex().select_lex.top_join_list,
@@ -177,7 +177,7 @@
   if (unique_table(table_list, table_list->next_global))
   {
     my_error(ER_UPDATE_TABLE_USED, MYF(0), table_list->getTableName());
-    return(true);
+    return true;
   }
 
   table= table_list->table;
@@ -196,7 +196,7 @@
     */
     if (setup_fields(session, 0, set_fields, MARK_COLUMNS_WRITE, 0, 0) ||
         setup_fields(session, 0, set_values, MARK_COLUMNS_READ, 0, 0))
-      return(true);
+      return true;
   }
   else
   {						// Part field list
@@ -204,7 +204,7 @@
     if (setup_fields(session, 0, fields_vars, MARK_COLUMNS_WRITE, 0, 0) ||
         setup_fields(session, 0, set_fields, MARK_COLUMNS_WRITE, 0, 0) ||
         check_that_all_fields_are_given_values(session, table, table_list))
-      return(true);
+      return true;
     /*
       Check whenever TIMESTAMP field with auto-set feature specified
       explicitly.
@@ -222,7 +222,7 @@
     }
     /* Fix the expressions in SET clause */
     if (setup_fields(session, 0, set_values, MARK_COLUMNS_READ, 0, 0))
-      return(true);
+      return true;
   }
 
   table->mark_columns_needed_for_insert();
@@ -254,12 +254,12 @@
   {
     my_message(ER_BLOBS_AND_NO_TERMINATED,ER(ER_BLOBS_AND_NO_TERMINATED),
 	       MYF(0));
-    return(true);
+    return true;
   }
   if (use_vars && !field_term->length() && !enclosed->length())
   {
     my_error(ER_LOAD_FROM_FIXED_SIZE_ROWS_TO_VAR, MYF(0));
-    return(true);
+    return true;
   }
 
   fs::path to_file(ex->file_name);
@@ -289,7 +289,7 @@
     {
       /* Read only allowed from within dir specified by secure_file_priv */
       my_error(ER_OPTION_PREVENTS_STATEMENT, MYF(0), "--secure-file-priv");
-      return(true);
+      return true;
     }
   }
 
@@ -297,7 +297,7 @@
   if (stat(target_path.file_string().c_str(), &stat_info))
   {
     my_error(ER_FILE_NOT_FOUND, MYF(0), target_path.file_string().c_str(), errno);
-    return(true);
+    return true;
   }
 
   // if we are not in slave thread, the cursor must be:
@@ -307,7 +307,7 @@
          (stat_info.st_mode & S_IFIFO) == S_IFIFO)))
   {
     my_error(ER_TEXTFILE_NOT_READABLE, MYF(0), target_path.file_string().c_str());
-    return(true);
+    return true;
   }
   if ((stat_info.st_mode & S_IFIFO) == S_IFIFO)
     is_fifo = 1;
@@ -316,7 +316,7 @@
   if ((file=internal::my_open(target_path.file_string().c_str(), O_RDONLY,MYF(MY_WME))) < 0)
   {
     my_error(ER_CANT_OPEN_FILE, MYF(0), target_path.file_string().c_str(), errno);
-    return(true);
+    return true;
   }
   CopyInfo info;
   memset(&info, 0, sizeof(info));
@@ -333,7 +333,7 @@
   {
     if	(file >= 0)
       internal::my_close(file,MYF(0));			// no files in net reading
-    return(true);				// Can't allocate buffers
+    return true;				// Can't allocate buffers
   }
 
   /*

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2011-06-05 23:06:29 +0000
+++ drizzled/sql_parse.cc	2011-06-22 20:05:58 +0000
@@ -400,8 +400,7 @@
     1                 out of memory or SHOW commands are not allowed
                       in this version of the server.
 */
-static bool _schema_select(Session *session, Select_Lex *sel,
-                           const string& schema_table_name)
+static bool _schema_select(Session& session, Select_Lex& sel, const string& schema_table_name)
 {
   LEX_STRING db, table;
   bitset<NUM_OF_TABLE_OPTIONS> table_options;
@@ -409,31 +408,18 @@
      We have to make non const db_name & table_name
      because of lower_case_table_names
   */
-  session->make_lex_string(&db, "data_dictionary", sizeof("data_dictionary"), false);
-  session->make_lex_string(&table, schema_table_name, false);
-
-  if (not sel->add_table_to_list(session, new Table_ident(db, table), NULL, table_options, TL_READ))
-  {
-    return true;
-  }
-  return false;
+  session.make_lex_string(&db, "data_dictionary", sizeof("data_dictionary"), false);
+  session.make_lex_string(&table, schema_table_name, false);
+  return not sel.add_table_to_list(&session, new Table_ident(db, table), NULL, table_options, TL_READ);
 }
 
-int prepare_new_schema_table(Session *session, LEX& lex,
-                             const string& schema_table_name)
+int prepare_new_schema_table(Session *session, LEX& lex0, const string& schema_table_name)
 {
-  Select_Lex *schema_select_lex= NULL;
-
-  Select_Lex *select_lex= lex.current_select;
-  assert(select_lex);
-  if (_schema_select(session, select_lex, schema_table_name))
-  {
-    return(1);
-  }
-  TableList *table_list= (TableList*) select_lex->table_list.first;
-  assert(table_list);
-  table_list->schema_select_lex= schema_select_lex;
-
+  Select_Lex& lex= *lex0.current_select;
+  if (_schema_select(*session, lex, schema_table_name))
+    return 1;
+  TableList *table_list= (TableList*)lex.table_list.first;
+  table_list->schema_select_lex= NULL;
   return 0;
 }
 
@@ -976,10 +962,9 @@
                  ER(ER_DERIVED_MUST_HAVE_ALIAS), MYF(0));
       return NULL;
     }
-    if (!(alias_str= (char*) session->getMemRoot()->duplicate(alias_str,table->table.length+1)))
-      return NULL;
+    alias_str= (char*) session->mem.memdup(alias_str,table->table.length+1);
   }
-  TableList *ptr = (TableList *) session->calloc(sizeof(TableList));
+  TableList *ptr = (TableList *) session->mem.calloc(sizeof(TableList));
 
   if (table->db.str)
   {
@@ -1073,16 +1058,11 @@
     1   otherwise
 */
 
-bool Select_Lex::init_nested_join(Session *session)
+void Select_Lex::init_nested_join(Session& session)
 {
-  TableList *ptr;
-  NestedJoin *nested_join;
-
-  if (!(ptr= (TableList*) session->calloc(ALIGN_SIZE(sizeof(TableList))+
-                                       sizeof(NestedJoin))))
-    return true;
+  TableList* ptr= (TableList*) session.mem.calloc(ALIGN_SIZE(sizeof(TableList)) + sizeof(NestedJoin));
   ptr->setNestedJoin(((NestedJoin*) ((unsigned char*) ptr + ALIGN_SIZE(sizeof(TableList)))));
-  nested_join= ptr->getNestedJoin();
+  NestedJoin* nested_join= ptr->getNestedJoin();
   join_list->push_front(ptr);
   ptr->setEmbedding(embedding);
   ptr->setJoinList(join_list);
@@ -1090,7 +1070,6 @@
   embedding= ptr;
   join_list= &nested_join->join_list;
   join_list->clear();
-  return false;
 }
 
 
@@ -1151,19 +1130,13 @@
 
 TableList *Select_Lex::nest_last_join(Session *session)
 {
-  TableList *ptr;
-  NestedJoin *nested_join;
-  List<TableList> *embedded_list;
-
-  if (!(ptr= (TableList*) session->calloc(ALIGN_SIZE(sizeof(TableList))+
-                                          sizeof(NestedJoin))))
-    return NULL;
+  TableList* ptr= (TableList*) session->mem.calloc(ALIGN_SIZE(sizeof(TableList)) + sizeof(NestedJoin));
   ptr->setNestedJoin(((NestedJoin*) ((unsigned char*) ptr + ALIGN_SIZE(sizeof(TableList)))));
-  nested_join= ptr->getNestedJoin();
+  NestedJoin* nested_join= ptr->getNestedJoin();
   ptr->setEmbedding(embedding);
   ptr->setJoinList(join_list);
   ptr->alias= (char*) "(nest_last_join)";
-  embedded_list= &nested_join->join_list;
+  List<TableList>* embedded_list= &nested_join->join_list;
   embedded_list->clear();
 
   for (uint32_t i=0; i < 2; i++)
@@ -1519,7 +1492,7 @@
   if (session->lex().select_lex.item_list.size() != session->lex().value_list.size())
   {
     my_message(ER_WRONG_VALUE_COUNT, ER(ER_WRONG_VALUE_COUNT), MYF(0));
-    return(true);
+    return true;
   }
 
   if (session->lex().select_lex.table_list.size() > 1)
@@ -1531,10 +1504,10 @@
     if (msg)
     {
       my_error(ER_WRONG_USAGE, MYF(0), "UPDATE", msg);
-      return(true);
+      return true;
     }
   }
-  return(false);
+  return false;
 }
 
 
@@ -1559,9 +1532,9 @@
   if (session->lex().update_list.size() != session->lex().value_list.size())
   {
     my_message(ER_WRONG_VALUE_COUNT, ER(ER_WRONG_VALUE_COUNT), MYF(0));
-    return(true);
+    return true;
   }
-  return(false);
+  return false;
 }
 
 

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2011-06-14 20:59:28 +0000
+++ drizzled/sql_select.cc	2011-06-22 20:05:58 +0000
@@ -387,7 +387,7 @@
         //here is EXPLAIN of subselect or derived table
         if (join->change_result(result))
         {
-          return(true);
+          return true;
         }
       }
       else
@@ -405,7 +405,7 @@
   else
   {
     if (!(join= new Join(session, fields, select_options, result)))
-      return(true);
+      return true;
     session->set_proc_info("init");
     session->used_tables=0;                         // Updated by setup_fields
     if ((err= join->prepare(rref_pointer_array, tables, wild_num,
@@ -574,7 +574,7 @@
   sz= sizeof(optimizer::KeyField) *
       (((session->lex().current_select->cond_count+1)*2 +
 	session->lex().current_select->between_count)*m+1);
-  key_fields= (optimizer::KeyField*) session->getMemRoot()->allocate(sz);
+  key_fields= (optimizer::KeyField*) session->mem.alloc(sz);
   and_level= 0;
   field= end= key_fields;
 
@@ -999,14 +999,10 @@
   j->ref.key_parts=keyparts;
   j->ref.key_length=length;
   j->ref.key=(int) key;
-  if (!(j->ref.key_buff= (unsigned char*) session->calloc(ALIGN_SIZE(length)*2)) ||
-      !(j->ref.key_copy= (StoredKey**) session->getMemRoot()->allocate((sizeof(StoredKey*) *
-               (keyparts+1)))) ||
-      !(j->ref.items=    (Item**) session->getMemRoot()->allocate(sizeof(Item*)*keyparts)) ||
-      !(j->ref.cond_guards= (bool**) session->getMemRoot()->allocate(sizeof(uint*)*keyparts)))
-  {
-    return(true);
-  }
+  j->ref.key_buff= (unsigned char*) session->mem.calloc(ALIGN_SIZE(length)*2);
+  j->ref.key_copy= (StoredKey**) session->mem.alloc((sizeof(StoredKey*) * (keyparts+1)));
+  j->ref.items=    (Item**) session->mem.alloc(sizeof(Item*)*keyparts);
+  j->ref.cond_guards= (bool**) session->mem.alloc(sizeof(uint*)*keyparts);
   j->ref.key_buff2=j->ref.key_buff+ALIGN_SIZE(length);
   j->ref.key_err=1;
   j->ref.null_rejecting= 0;
@@ -1036,7 +1032,7 @@
                            maybe_null ?  key_buff : 0,
                            keyinfo->key_part[i].length, keyuse->getVal());
         if (session->is_fatal_error)
-          return(true);
+          return true;
         tmp.copy();
       }
       else
@@ -4939,11 +4935,7 @@
     return(0);
   for (Order *ord= join->order; ord; ord= ord->next)
     length++;
-  if (!(join->sortorder= make_unireg_sortorder(order, &length, join->sortorder)))
-  {
-    return(-1);
-  }
-
+  join->sortorder= make_unireg_sortorder(order, &length, join->sortorder);
   table->sort.io_cache= new internal::io_cache_st;
   table->status=0;				// May be wrong if quick_select
 
@@ -5188,23 +5180,18 @@
   return 1;
 }
 
-SortField *make_unireg_sortorder(Order *order, uint32_t *length, SortField *sortorder)
+SortField* make_unireg_sortorder(Order* order, uint32_t* length, SortField* sortorder)
 {
-  uint32_t count;
   SortField *sort,*pos;
 
-  count=0;
+  uint32_t count= 0;
   for (Order *tmp = order; tmp; tmp=tmp->next)
     count++;
-  if (!sortorder)
-    sortorder= (SortField*) memory::sql_alloc(sizeof(SortField) *
-                                       (max(count, *length) + 1));
+  if (not sortorder)
+    sortorder= (SortField*) memory::sql_alloc(sizeof(SortField) * (max(count, *length) + 1));
   pos= sort= sortorder;
 
-  if (!pos)
-    return 0;
-
-  for (;order;order=order->next,pos++)
+  for (; order; order= order->next,pos++)
   {
     Item *item= order->item[0]->real_item();
     pos->field= 0; pos->item= 0;
@@ -5221,7 +5208,7 @@
     pos->reverse=! order->asc;
   }
   *length=count;
-  return(sort);
+  return sort;
 }
 
 /*
@@ -5340,8 +5327,7 @@
     uint32_t count= (uint32_t) order_item->val_int();
     if (!count || count > fields.size())
     {
-      my_error(ER_BAD_FIELD_ERROR, MYF(0),
-               order_item->full_name(), session->where());
+      my_error(ER_BAD_FIELD_ERROR, MYF(0), order_item->full_name(), session->where());
       return true;
     }
     order->item= ref_pointer_array + count - 1;
@@ -5351,8 +5337,7 @@
     return false;
   }
   /* Lookup the current GROUP/order_st field in the SELECT clause. */
-  select_item= find_item_in_list(session, order_item, fields, &counter,
-                                 REPORT_EXCEPT_NOT_FOUND, &resolution);
+  select_item= find_item_in_list(session, order_item, fields, &counter, REPORT_EXCEPT_NOT_FOUND, &resolution);
   if (!select_item)
     return true; /* The item is not unique, or some other error occured. */
 
@@ -5461,10 +5446,9 @@
                 Order *order)
 {
   session->setWhere("order clause");
-  for (; order; order=order->next)
+  for (; order; order= order->next)
   {
-    if (find_order_in_list(session, ref_pointer_array, tables, order, fields,
-			   all_fields, false))
+    if (find_order_in_list(session, ref_pointer_array, tables, order, fields, all_fields, false))
       return 1;
   }
   return 0;
@@ -5601,11 +5585,10 @@
                                 bool *all_order_by_fields_used)
 {
   List<Item>::iterator li(fields.begin());
-  Item *item;
   Order *order,*group,**prev;
 
   *all_order_by_fields_used= 1;
-  while ((item=li++))
+  while (Item* item=li++)
     item->marker=0;			/* Marker that field is not used */
 
   prev= &group;  group=0;
@@ -5613,9 +5596,7 @@
   {
     if (order->in_field_list)
     {
-      Order *ord=(Order*) session->getMemRoot()->duplicate((char*) order,sizeof(Order));
-      if (!ord)
-        return 0;
+      Order *ord=(Order*) session->mem.memdup(order,sizeof(Order));
       *prev=ord;
       prev= &ord->next;
       (*ord->item)->marker=1;
@@ -5625,7 +5606,7 @@
   }
 
   li= fields.begin();
-  while ((item=li++))
+  while (Item* item=li++)
   {
     if (!item->const_item() && !item->with_sum_func && !item->marker)
     {
@@ -5638,9 +5619,7 @@
         if ((*ord_iter->item)->eq(item, 1))
           goto next_item;
 
-      Order *ord=(Order*) session->calloc(sizeof(Order));
-      if (!ord)
-        return 0;
+      Order *ord=(Order*) session->mem.calloc(sizeof(Order));
 
       /*
         We have here only field_list (not all_field_list), so we can use
@@ -5957,7 +5936,7 @@
         else
           item_field= (Item*) new Item_field(field);
         if (!item_field)
-          return(true);                    // Fatal error
+          return true;                    // Fatal error
 
         if (item->real_item()->type() != Item::FIELD_ITEM)
           field->orig_table= 0;
@@ -5982,7 +5961,7 @@
   for (i= 0; i < border; i++)
     itr++;
   itr.sublist(res_selected_fields, elements);
-  return(false);
+  return false;
 }
 
 /**
@@ -6050,9 +6029,9 @@
   while ((func= *(func_ptr++)))
   {
     if (func->setup(session))
-      return(true);
+      return true;
   }
-  return(false);
+  return false;
 }
 
 void init_tmptable_sum_functions(Item_sum **func_ptr)
@@ -6261,10 +6240,7 @@
 {
   /* List is reversed => we should reverse it before using */
   List<TableList>::iterator ti(tables->begin());
-  TableList **table= (TableList **)session->getMemRoot()->allocate(sizeof(TableList*) *
-                                                tables->size());
-  if (table == 0)
-    return;  // out of memory
+  TableList **table= (TableList **)session->mem.alloc(sizeof(TableList*) * tables->size());
 
   for (TableList **t= table + (tables->size() - 1); t >= table; t--)
     *t= ti++;

=== modified file 'drizzled/sql_string.cc'
--- drizzled/sql_string.cc	2011-05-05 11:49:51 +0000
+++ drizzled/sql_string.cc	2011-06-22 14:19:44 +0000
@@ -92,7 +92,7 @@
 
 void *String::operator new(size_t size, memory::Root *mem_root)
 {
-  return mem_root->alloc_root(static_cast<size_t>(size));
+  return mem_root->alloc(size);
 }
 
 String::~String() { free(); }

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2011-06-17 13:02:19 +0000
+++ drizzled/sql_table.cc	2011-06-22 20:05:58 +0000
@@ -572,7 +572,7 @@
       tmp_pos+= strlen(tmp);
       strncpy(tmp_pos, STRING_WITH_LEN("_bin"));
       my_error(ER_UNKNOWN_COLLATION, MYF(0), tmp);
-      return(true);
+      return true;
     }
 
     /*
@@ -599,7 +599,7 @@
       {
         /* Could not convert */
         my_error(ER_INVALID_DEFAULT, MYF(0), sql_field->field_name);
-        return(true);
+        return true;
       }
     }
 
@@ -621,31 +621,26 @@
           occupied memory at the same time when we free this
           sql_field -- at the end of execution.
         */
-        interval= sql_field->interval= typelib(session->mem_root,
-                                               sql_field->interval_list);
+        interval= sql_field->interval= typelib(*session->mem_root, sql_field->interval_list);
 
         List<String>::iterator int_it(sql_field->interval_list.begin());
         String conv, *tmp;
         char comma_buf[4];
-        int comma_length= cs->cset->wc_mb(cs, ',', (unsigned char*) comma_buf,
-                                          (unsigned char*) comma_buf +
-                                          sizeof(comma_buf));
+        int comma_length= cs->cset->wc_mb(cs, ',', (unsigned char*) comma_buf, (unsigned char*) comma_buf + sizeof(comma_buf));
         assert(comma_length > 0);
 
         for (uint32_t i= 0; (tmp= int_it++); i++)
         {
           uint32_t lengthsp;
-          if (String::needs_conversion(tmp->length(), tmp->charset(),
-                                       cs, &dummy))
+          if (String::needs_conversion(tmp->length(), tmp->charset(), cs, &dummy))
           {
             conv.copy(tmp->ptr(), tmp->length(), cs);
-            interval->type_names[i]= session->mem_root->strmake_root(conv.ptr(), conv.length());
+            interval->type_names[i]= session->mem.strmake(conv);
             interval->type_lengths[i]= conv.length();
           }
 
           // Strip trailing spaces.
-          lengthsp= cs->cset->lengthsp(cs, interval->type_names[i],
-                                       interval->type_lengths[i]);
+          lengthsp= cs->cset->lengthsp(cs, interval->type_names[i], interval->type_lengths[i]);
           interval->type_lengths[i]= lengthsp;
           ((unsigned char *)interval->type_names[i])[lengthsp]= '\0';
         }
@@ -661,10 +656,10 @@
           String str, *def= sql_field->def->val_str(&str);
           if (def == NULL) /* SQL "NULL" maps to NULL */
           {
-            if ((sql_field->flags & NOT_NULL_FLAG) != 0)
+            if (sql_field->flags & NOT_NULL_FLAG)
             {
               my_error(ER_INVALID_DEFAULT, MYF(0), sql_field->field_name);
-              return(true);
+              return true;
             }
 
             /* else, the defaults yield the correct length for NULLs. */
@@ -675,7 +670,7 @@
             if (interval->find_type2(def->ptr(), def->length(), cs) == 0) /* not found */
             {
               my_error(ER_INVALID_DEFAULT, MYF(0), sql_field->field_name);
-              return(true);
+              return true;
             }
           }
         }
@@ -688,7 +683,7 @@
 
     sql_field->create_length_to_internal_length();
     if (prepare_blob_field(session, sql_field))
-      return(true);
+      return true;
 
     if (!(sql_field->flags & NOT_NULL_FLAG))
       null_fields++;
@@ -696,7 +691,7 @@
     if (check_column_name(sql_field->field_name))
     {
       my_error(ER_WRONG_COLUMN_NAME, MYF(0), sql_field->field_name);
-      return(true);
+      return true;
     }
 
     /* Check if we have used the same field name before */
@@ -713,7 +708,7 @@
 	if (field_no < select_field_pos || dup_no >= select_field_pos)
 	{
 	  my_error(ER_DUP_FIELDNAME, MYF(0), sql_field->field_name);
-	  return(true);
+	  return true;
 	}
 	else
 	{
@@ -767,7 +762,7 @@
 
     if (prepare_create_field(sql_field, &blob_columns,
 			     &timestamps, &timestamps_with_niladic))
-      return(true);
+      return true;
     sql_field->offset= record_offset;
     if (MTYP_TYPENR(sql_field->unireg_check) == Field::NEXT_NUMBER)
       auto_increment++;
@@ -776,26 +771,26 @@
   {
     my_message(ER_TOO_MUCH_AUTO_TIMESTAMP_COLS,
                ER(ER_TOO_MUCH_AUTO_TIMESTAMP_COLS), MYF(0));
-    return(true);
+    return true;
   }
   if (auto_increment > 1)
   {
     my_message(ER_WRONG_AUTO_KEY, ER(ER_WRONG_AUTO_KEY), MYF(0));
-    return(true);
+    return true;
   }
   if (auto_increment &&
       (engine->check_flag(HTON_BIT_NO_AUTO_INCREMENT)))
   {
     my_message(ER_TABLE_CANT_HANDLE_AUTO_INCREMENT,
                ER(ER_TABLE_CANT_HANDLE_AUTO_INCREMENT), MYF(0));
-    return(true);
+    return true;
   }
 
   if (blob_columns && (engine->check_flag(HTON_BIT_NO_BLOBS)))
   {
     my_message(ER_TABLE_CANT_HANDLE_BLOB, ER(ER_TABLE_CANT_HANDLE_BLOB),
                MYF(0));
-    return(true);
+    return true;
   }
 
   /* Create keys */
@@ -838,7 +833,7 @@
                  (fk_key->name.str ? fk_key->name.str :
                                      "foreign key without name"),
                  ER(ER_KEY_REF_DO_NOT_MATCH_TABLE_REF));
-	return(true);
+	return true;
       }
       continue;
     }
@@ -847,10 +842,10 @@
     if (key->columns.size() > tmp)
     {
       my_error(ER_TOO_MANY_KEY_PARTS,MYF(0),tmp);
-      return(true);
+      return true;
     }
     if (check_identifier_name(&key->name, ER_TOO_LONG_IDENT))
-      return(true);
+      return true;
     key_iterator2= alter_info->key_list.begin();
     if (key->type != Key::FOREIGN_KEY)
     {
@@ -889,20 +884,20 @@
         is_primary_key_name(key->name.str))
     {
       my_error(ER_WRONG_NAME_FOR_INDEX, MYF(0), key->name.str);
-      return(true);
+      return true;
     }
   }
   tmp= engine->max_keys();
   if (*key_count > tmp)
   {
     my_error(ER_TOO_MANY_KEYS,MYF(0),tmp);
-    return(true);
+    return true;
   }
 
   (*key_info_buffer)= key_info= (KeyInfo*) memory::sql_calloc(sizeof(KeyInfo) * (*key_count));
   key_part_info=(KeyPartInfo*) memory::sql_calloc(sizeof(KeyPartInfo)*key_parts);
   if (!*key_info_buffer || ! key_part_info)
-    return(true);				// Out of memory
+    return true;				// Out of memory
 
   key_iterator= alter_info->key_list.begin();
   key_number=0;
@@ -984,7 +979,7 @@
       if (!sql_field)
       {
 	my_error(ER_KEY_COLUMN_DOES_NOT_EXITS, MYF(0), column->field_name.str);
-	return(true);
+	return true;
       }
 
       while ((dup_column= cols2++) != column)
@@ -995,7 +990,7 @@
 	  my_printf_error(ER_DUP_FIELDNAME,
 			  ER(ER_DUP_FIELDNAME),MYF(0),
 			  column->field_name.str);
-	  return(true);
+	  return true;
 	}
       }
       cols2= key->columns.begin();
@@ -1081,7 +1076,7 @@
 	    else
 	    {
 	      my_error(ER_TOO_LONG_KEY,MYF(0),length);
-	      return(true);
+	      return true;
 	    }
 	  }
 	}
@@ -1089,7 +1084,7 @@
             ! Field::type_can_have_key_part(sql_field->sql_type)))
 	{
 	  my_message(ER_WRONG_SUB_KEY, ER(ER_WRONG_SUB_KEY), MYF(0));
-	  return(true);
+	  return true;
 	}
 	else if (! (engine->check_flag(HTON_BIT_NO_PREFIX_CHAR_KEYS)))
         {
@@ -1099,7 +1094,7 @@
       else if (length == 0)
       {
 	my_error(ER_WRONG_KEY_COLUMN, MYF(0), column->field_name.str);
-	  return(true);
+	  return true;
       }
       if (length > engine->max_key_part_length())
       {
@@ -1118,7 +1113,7 @@
 	else
 	{
 	  my_error(ER_TOO_LONG_KEY,MYF(0),length);
-	  return(true);
+	  return true;
 	}
       }
       key_part_info->length=(uint16_t) length;
@@ -1154,7 +1149,7 @@
 	  {
 	    my_message(ER_MULTIPLE_PRI_KEY, ER(ER_MULTIPLE_PRI_KEY),
                        MYF(0));
-	    return(true);
+	    return true;
 	  }
           static const char pkey_name[]= "PRIMARY";
 	  key_name=pkey_name;
@@ -1166,7 +1161,7 @@
 	if (check_if_keyname_exists(key_name, *key_info_buffer, key_info))
 	{
 	  my_error(ER_DUP_KEYNAME, MYF(0), key_name);
-	  return(true);
+	  return true;
 	}
 	key_info->name=(char*) key_name;
       }
@@ -1175,7 +1170,7 @@
     if (!key_info->name || check_column_name(key_info->name))
     {
       my_error(ER_WRONG_NAME_FOR_INDEX, MYF(0), key_info->name);
-      return(true);
+      return true;
     }
 
     if (!(key_info->flags & HA_NULL_PART_KEY))
@@ -1188,7 +1183,7 @@
     if (key_length > max_key_length)
     {
       my_error(ER_TOO_LONG_KEY,MYF(0),max_key_length);
-      return(true);
+      return true;
     }
 
     key_info++;
@@ -1198,13 +1193,13 @@
       (engine->check_flag(HTON_BIT_REQUIRE_PRIMARY_KEY)))
   {
     my_message(ER_REQUIRES_PRIMARY_KEY, ER(ER_REQUIRES_PRIMARY_KEY), MYF(0));
-    return(true);
+    return true;
   }
 
   if (auto_increment > 0)
   {
     my_message(ER_WRONG_AUTO_KEY, ER(ER_WRONG_AUTO_KEY), MYF(0));
-    return(true);
+    return true;
   }
   /* Sort keys in optimized order */
   internal::my_qsort((unsigned char*) *key_info_buffer, *key_count, sizeof(KeyInfo),
@@ -1237,11 +1232,11 @@
       */
 
       my_error(ER_INVALID_DEFAULT, MYF(0), sql_field->field_name);
-      return(true);
+      return true;
     }
   }
 
-  return(false);
+  return false;
 }
 
 /*
@@ -1931,7 +1926,7 @@
   }
 
   session->my_eof();
-  return(false);
+  return false;
 
 err:
   transaction_services.autocommitOrRollback(*session, true);
@@ -1939,7 +1934,7 @@
   session->close_thread_tables();			// Shouldn't be needed
   if (table)
     table->table=0;
-  return(true);
+  return true;
 }
 
   /*

=== modified file 'drizzled/sql_union.cc'
--- drizzled/sql_union.cc	2011-03-23 09:39:54 +0000
+++ drizzled/sql_union.cc	2011-06-22 20:05:58 +0000
@@ -29,19 +29,17 @@
 #include <drizzled/session.h>
 #include <drizzled/item/subselect.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
 bool drizzle_union(Session *session, LEX *, select_result *result,
 		   Select_Lex_Unit *unit, uint64_t setup_tables_done_option)
 {
-  bool res;
-  if (!(res= unit->prepare(session, result, SELECT_NO_UNLOCK |
-                           setup_tables_done_option)))
+  bool res= unit->prepare(session, result, SELECT_NO_UNLOCK | setup_tables_done_option);
+  if (!res)
     res= unit->exec();
   if (res)
     res|= unit->cleanup();
-  return(res);
+  return res;
 }
 
 
@@ -225,13 +223,13 @@
 	offset_limit_cnt= 0;
 	if (result->prepare(sl->join->fields_list, this))
 	{
-	  return(true);
+	  return true;
 	}
 	sl->join->select_options|= SELECT_DESCRIBE;
 	sl->join->reinit();
       }
     }
-    return(false);
+    return false;
   }
   prepared= 1;
   saved_error= false;
@@ -307,11 +305,10 @@
         field object without table.
       */
       assert(!empty_table);
-      empty_table= (Table*) session->calloc(sizeof(Table));
+      empty_table= (Table*) session->mem.calloc(sizeof(Table));
       types.clear();
       List<Item>::iterator it(sl->item_list.begin());
-      Item *item_tmp;
-      while ((item_tmp= it++))
+      while (Item* item_tmp= it++)
       {
 	/* Error's in 'new' will be detected after loop */
 	types.push_back(new Item_type_holder(session_arg, item_tmp));
@@ -334,7 +331,7 @@
       while ((type= tp++, item_tmp= it++))
       {
         if (((Item_type_holder*)type)->join_types(session_arg, item_tmp))
-	  return(true);
+	  return true;
       }
     }
   }
@@ -390,7 +387,7 @@
 
 err:
   session_arg->lex().current_select= lex_select_save;
-  return(true);
+  return true;
 }
 
 
@@ -462,7 +459,7 @@
         if (sl == union_distinct)
 	{
 	  if (table->cursor->ha_disable_indexes(HA_KEY_SWITCH_ALL))
-	    return(true);
+	    return true;
 	  table->no_keyread=1;
 	}
 	saved_error= sl->join->error;
@@ -529,7 +526,7 @@
 					      fake_select_lex->options, result)))
 	{
 	  fake_select_lex->table_list.clear();
-	  return(true);
+	  return true;
 	}
         fake_select_lex->join->no_const_tables= true;
 
@@ -601,7 +598,7 @@
 
   if (cleaned)
   {
-    return(false);
+    return false;
   }
   cleaned= 1;
 

=== modified file 'drizzled/sql_update.cc'
--- drizzled/sql_update.cc	2011-04-29 00:19:38 +0000
+++ drizzled/sql_update.cc	2011-06-21 21:25:17 +0000
@@ -323,14 +323,10 @@
       FileSort filesort(*session);
 
       table->sort.io_cache= new internal::io_cache_st;
+      sortorder=make_unireg_sortorder(order, &length, NULL);
 
-      if (!(sortorder=make_unireg_sortorder(order, &length, NULL)) ||
-	  (table->sort.found_records= filesort.run(table, sortorder, length,
-						   select, limit, 1,
-						   examined_rows)) == HA_POS_ERROR)
-      {
-	goto err;
-      }
+      if ((table->sort.found_records= filesort.run(table, sortorder, length, select, limit, 1, examined_rows)) == HA_POS_ERROR)
+        goto err;
       /*
 	Filesort has already found and selected the rows we want to update,
 	so we don't need the where clause
@@ -629,15 +625,11 @@
 
   session->lex().allow_sum_func= 0;
 
-  if (setup_tables_and_check_access(session, &select_lex->context,
-                                    &select_lex->top_join_list,
-                                    table_list,
-                                    &select_lex->leaf_tables,
-                                    false) ||
-      session->setup_conds(table_list, conds) ||
-      select_lex->setup_ref_array(session, order_num) ||
-      setup_order(session, select_lex->ref_pointer_array,
-		  table_list, all_fields, all_fields, order))
+  if (setup_tables_and_check_access(session, &select_lex->context, &select_lex->top_join_list, table_list, &select_lex->leaf_tables, false) ||
+      session->setup_conds(table_list, conds))
+      return true;
+  select_lex->setup_ref_array(session, order_num);
+  if (setup_order(session, select_lex->ref_pointer_array, table_list, all_fields, all_fields, order))
     return true;
 
   /* Check that we are not using table that we are updating in a sub select */

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-06-08 19:34:40 +0000
+++ drizzled/sql_yacc.yy	2011-06-21 19:11:23 +0000
@@ -1148,7 +1148,7 @@
 row_format_or_text:
           row_format
           {
-            $$.str= YYSession->strmake($1.str, $1.length);
+            $$.str= YYSession->mem.strmake($1.str, $1.length);
             $$.length= $1.length;
           }
         ;
@@ -2319,25 +2319,21 @@
         | select_item
         | '*'
           {
-            if (YYSession->add_item_to_list( new Item_field(&YYSession->lex().current_select->context, NULL, NULL, "*")))
-              DRIZZLE_YYABORT;
-
-            (YYSession->lex().current_select->with_wild)++;
+            YYSession->add_item_to_list( new Item_field(&YYSession->lex().current_select->context, NULL, NULL, "*"));
+            YYSession->lex().current_select->with_wild++;
           }
         ;
 
 select_item:
           remember_name table_wild remember_end
           {
-            if (YYSession->add_item_to_list($2))
-              DRIZZLE_YYABORT;
+            YYSession->add_item_to_list($2);
           }
         | remember_name expr remember_end select_alias
           {
             assert($1 < $3);
 
-            if (YYSession->add_item_to_list($2))
-              DRIZZLE_YYABORT;
+            YYSession->add_item_to_list($2);
 
             if ($4.str)
             {
@@ -3569,8 +3565,7 @@
                 sel->master_unit()->global_parameters=
                    sel->master_unit()->fake_select_lex;
             }
-            if ($2->init_nested_join(Lex.session))
-              DRIZZLE_YYABORT;
+            $2->init_nested_join(*Lex.session);
             $$= 0;
             /* incomplete derived tables return NULL, we must be
                nested in select_derived rule to be here. */
@@ -3691,8 +3686,7 @@
 select_derived:
           get_select_lex
           {
-            if ($1->init_nested_join(Lex.session))
-              DRIZZLE_YYABORT;
+            $1->init_nested_join(*Lex.session);
           }
           derived_table_list
           {
@@ -3956,9 +3950,9 @@
 
 group_list:
           group_list ',' order_ident order_dir
-          { if (YYSession->add_group_to_list($3,(bool) $4)) DRIZZLE_YYABORT; }
+          { YYSession->add_group_to_list($3,(bool) $4); }
         | order_ident order_dir
-          { if (YYSession->add_group_to_list($1,(bool) $2)) DRIZZLE_YYABORT; }
+          { YYSession->add_group_to_list($1,(bool) $2); }
         ;
 
 olap_opt:
@@ -3998,9 +3992,8 @@
 alter_order_item:
           simple_ident order_dir
           {
-            bool ascending= ($2 == 1) ? true : false;
-            if (YYSession->add_order_to_list($1, ascending))
-              DRIZZLE_YYABORT;
+            bool ascending= $2 == 1;
+            YYSession->add_order_to_list($1, ascending);
           }
         ;
 
@@ -4025,13 +4018,11 @@
 order_list:
           order_list ',' order_ident order_dir
           {
-            if (YYSession->add_order_to_list($3,(bool) $4))
-              DRIZZLE_YYABORT;
+            YYSession->add_order_to_list($3,(bool) $4);
           }
         | order_ident order_dir
           {
-            if (YYSession->add_order_to_list($1,(bool) $2))
-              DRIZZLE_YYABORT;
+            YYSession->add_order_to_list($1,(bool) $2);
           }
         ;
 
@@ -4466,8 +4457,8 @@
 update_elem:
           simple_ident equal expr_or_default
           {
-            if (YYSession->add_item_to_list($1) || YYSession->add_value_to_list($3))
-              DRIZZLE_YYABORT;
+            YYSession->add_item_to_list($1);
+			YYSession->add_value_to_list($3);
           }
         ;
 
@@ -4535,8 +4526,8 @@
 show_param:
            DATABASES show_wild
            {
-             if (not show::buildScemas(YYSession))
-               DRIZZLE_YYABORT;
+             if (not show::buildSchemas(YYSession))
+				DRIZZLE_YYABORT;
            }
            /* SHOW TABLES */
          | TABLES opt_db show_wild
@@ -5201,7 +5192,7 @@
           IDENT_sys    { $$=$1; }
         | keyword
           {
-            $$.str= YYSession->strmake($1.str, $1.length);
+            $$.str= YYSession->mem.strmake($1.str, $1.length);
             $$.length= $1.length;
           }
         ;
@@ -5483,7 +5474,7 @@
 internal_variable_ident:
           keyword_exception_for_variable
           {
-            $$.str= YYSession->strmake($1.str, $1.length);
+            $$.str= YYSession->mem.strmake($1.str, $1.length);
             $$.length= $1.length;
           }
         | IDENT_sys    { $$=$1; }

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2011-05-02 18:32:53 +0000
+++ drizzled/statement/alter_table.cc	2011-06-21 21:25:17 +0000
@@ -1608,16 +1608,12 @@
         tables.setSchemaName(const_cast<char *>(from->getMutableShare()->getSchemaName()));
         error= 1;
 
-        if (session->lex().select_lex.setup_ref_array(session, order_num) ||
-            setup_order(session, session->lex().select_lex.ref_pointer_array,
-                        &tables, fields, all_fields, order) ||
-            !(sortorder= make_unireg_sortorder(order, &length, NULL)) ||
-            (from->sort.found_records= filesort.run(from, sortorder, length,
-                                                    (optimizer::SqlSelect *) 0, HA_POS_ERROR,
-                                                    1, examined_rows)) == HA_POS_ERROR)
-        {
-          break;
-        }
+        session->lex().select_lex.setup_ref_array(session, order_num);
+        if (setup_order(session, session->lex().select_lex.ref_pointer_array, &tables, fields, all_fields, order))
+          break;
+        sortorder= make_unireg_sortorder(order, &length, NULL);
+        if ((from->sort.found_records= filesort.run(from, sortorder, length, (optimizer::SqlSelect *) 0, HA_POS_ERROR, 1, examined_rows)) == HA_POS_ERROR)
+          break;
       }
     }
 

=== modified file 'drizzled/sys_var.cc'
--- drizzled/sys_var.cc	2011-06-02 15:09:32 +0000
+++ drizzled/sys_var.cc	2011-06-21 18:18:14 +0000
@@ -426,8 +426,7 @@
 static void fix_session_mem_root(Session *session, sql_var_t type)
 {
   if (type != OPT_GLOBAL)
-    session->mem_root->reset_root_defaults(session->variables.query_alloc_block_size,
-                                           session->variables.query_prealloc_size);
+    session->mem.reset_defaults(session->variables.query_alloc_block_size, session->variables.query_prealloc_size);
 }
 
 
@@ -435,7 +434,6 @@
 {
 }
 
-
 void throw_bounds_warning(Session *session, bool fixed, bool unsignd, const std::string &name, int64_t val)
 {
   if (not fixed)
@@ -963,8 +961,7 @@
     if (str)
     {
       uint32_t length= strlen(str);
-      tmp= new Item_string(session->strmake(str, length), length,
-                           system_charset_info, DERIVATION_SYSCONST);
+      tmp= new Item_string(session->mem.strmake(str, length), length, system_charset_info, DERIVATION_SYSCONST);
     }
     else
     {
@@ -1408,24 +1405,19 @@
 
 drizzle_show_var* enumerate_sys_vars(Session *session)
 {
-  int size= sizeof(drizzle_show_var) * (system_variable_map.size() + 1);
-  drizzle_show_var *result= (drizzle_show_var*) session->getMemRoot()->allocate(size);
-
-  if (result)
+  drizzle_show_var *result= (drizzle_show_var*) session->mem.alloc(sizeof(drizzle_show_var) * (system_variable_map.size() + 1));
+  drizzle_show_var *show= result;
+  BOOST_FOREACH(SystemVariableMap::const_reference iter, system_variable_map)
   {
-    drizzle_show_var *show= result;
-    BOOST_FOREACH(SystemVariableMap::const_reference iter, system_variable_map)
-    {
-      sys_var *var= iter.second;
-      show->name= var->getName().c_str();
-      show->value= (char*) var;
-      show->type= SHOW_SYS;
-      ++show;
-    }
-
-    /* make last element empty */
-    memset(show, 0, sizeof(drizzle_show_var));
+    sys_var *var= iter.second;
+    show->name= var->getName().c_str();
+    show->value= (char*) var;
+    show->type= SHOW_SYS;
+    ++show;
   }
+
+  /* make last element empty */
+  memset(show, 0, sizeof(drizzle_show_var));
   return result;
 }
 
@@ -1593,15 +1585,11 @@
                                                          sql_var_t type,
                                                          const LEX_STRING *)
 {
-  unsigned char* result;
-  string engine_name;
   plugin::StorageEngine *engine= session->variables.*offset;
   if (type == OPT_GLOBAL)
     engine= global_system_variables.*offset;
-  engine_name= engine->getName();
-  result= (unsigned char *) session->strmake(engine_name.c_str(),
-                                             engine_name.size());
-  return result;
+  string engine_name= engine->getName();
+  return (unsigned char *) session->mem.strmake(engine_name);
 }
 
 

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2011-06-17 13:15:26 +0000
+++ drizzled/table.cc	2011-06-22 20:08:19 +0000
@@ -187,7 +187,7 @@
   memset(quick_key_parts, 0, sizeof(unsigned int) * MAX_KEY);
   memset(quick_n_ranges, 0, sizeof(unsigned int) * MAX_KEY);
 
-  memory::init_sql_alloc(&mem_root, TABLE_ALLOC_BLOCK_SIZE, 0);
+  mem_root.init(TABLE_ALLOC_BLOCK_SIZE);
 }
 
 
@@ -206,18 +206,12 @@
 }
 
 
-TYPELIB *typelib(memory::Root *mem_root, List<String> &strings)
+TYPELIB *typelib(memory::Root& mem_root, List<String> &strings)
 {
-  TYPELIB *result= (TYPELIB*) mem_root->alloc_root(sizeof(TYPELIB));
-  if (!result)
-    return 0;
+  TYPELIB *result= new (mem_root) TYPELIB;
   result->count= strings.size();
   result->name= "";
-  uint32_t nbytes= (sizeof(char*) + sizeof(uint32_t)) * (result->count + 1);
-  
-  if (!(result->type_names= (const char**) mem_root->alloc_root(nbytes)))
-    return 0;
-    
+  result->type_names= (const char**) mem_root.alloc((sizeof(char*) + sizeof(uint32_t)) * (result->count + 1));
   result->type_lengths= (uint*) (result->type_names + result->count + 1);
 
   List<String>::iterator it(strings.begin());
@@ -669,19 +663,14 @@
     Make sure that the blob fits into a Field_varstring which has
     2-byte lenght.
   */
-  if (convert_blob_length && convert_blob_length <= Field_varstring::MAX_SIZE &&
-      (org_field->flags & BLOB_FLAG))
+  if (convert_blob_length && convert_blob_length <= Field_varstring::MAX_SIZE && (org_field->flags & BLOB_FLAG))
   {
     table->setVariableWidth();
-    new_field= new Field_varstring(convert_blob_length,
-                                   org_field->maybe_null(),
-                                   org_field->field_name,
-                                   org_field->charset());
+    new_field= new Field_varstring(convert_blob_length, org_field->maybe_null(), org_field->field_name, org_field->charset());
   }
   else
   {
-    new_field= org_field->new_field(session->mem_root, table,
-                                    table == org_field->getTable());
+    new_field= org_field->new_field(session->mem_root, table, table == org_field->getTable());
   }
   if (new_field)
   {
@@ -735,7 +724,6 @@
 		 uint64_t select_options, ha_rows rows_limit,
 		 const char *table_alias)
 {
-  memory::Root *mem_root_save;
   uint	i,field_count,null_count,null_pack_length;
   uint32_t  copy_func_count= param->func_count;
   uint32_t  hidden_null_count, hidden_null_pack_length, hidden_field_count;
@@ -799,32 +787,25 @@
 
   table::Singular* table= &session->getInstanceTable(); // This will not go into the tableshare cache, so no key is used.
 
-  if (not table->getMemRoot()->multi_alloc_root(0,
-                                                &default_field, sizeof(Field*) * (field_count),
-                                                &from_field, sizeof(Field*)*field_count,
-                                                &copy_func, sizeof(*copy_func)*(copy_func_count+1),
-                                                &param->keyinfo, sizeof(*param->keyinfo),
-                                                &key_part_info, sizeof(*key_part_info)*(param->group_parts+1),
-                                                &param->start_recinfo, sizeof(*param->recinfo)*(field_count*2+4),
-                                                &group_buff, (group && ! using_unique_constraint ?
-                                                              param->group_length : 0),
-                                                NULL))
-  {
-    return NULL;
-  }
+  table->getMemRoot().multi_alloc(0,
+    &default_field, sizeof(Field*) * (field_count),
+    &from_field, sizeof(Field*)*field_count,
+    &copy_func, sizeof(*copy_func)*(copy_func_count+1),
+    &param->keyinfo, sizeof(*param->keyinfo),
+    &key_part_info, sizeof(*key_part_info)*(param->group_parts+1),
+    &param->start_recinfo, sizeof(*param->recinfo)*(field_count*2+4),
+    &group_buff, (group && ! using_unique_constraint ? param->group_length : 0),
+    NULL);
   /* CopyField belongs to Tmp_Table_Param, allocate it in Session mem_root */
-  if (!(param->copy_field= copy= new (session->mem_root) CopyField[field_count]))
-  {
-    return NULL;
-  }
+  param->copy_field= copy= new (session->mem_root) CopyField[field_count];
   param->items_to_copy= copy_func;
   /* make table according to fields */
 
   memset(default_field, 0, sizeof(Field*) * (field_count));
   memset(from_field, 0, sizeof(Field*)*field_count);
 
-  mem_root_save= session->mem_root;
-  session->mem_root= table->getMemRoot();
+  memory::Root* mem_root_save= session->mem_root;
+  session->mem_root= &table->getMemRoot();
 
   table->getMutableShare()->setFields(field_count+1);
   table->setFields(table->getMutableShare()->getFields(true));
@@ -854,9 +835,8 @@
   param->using_indirect_summary_function= 0;
 
   List<Item>::iterator li(fields.begin());
-  Item *item;
   Field **tmp_from_field=from_field;
-  while ((item=li++))
+  while (Item* item=li++)
   {
     Item::Type type=item->type();
     if (not_all_columns)
@@ -912,7 +892,7 @@
           }
           session->mem_root= mem_root_save;
           *argp= new Item_field(new_field);
-          session->mem_root= table->getMemRoot();
+          session->mem_root= &table->getMemRoot();
 	  if (!(new_field->flags & NOT_NULL_FLAG))
           {
 	    null_count++;
@@ -1042,10 +1022,7 @@
   {
     uint32_t alloc_length=ALIGN_SIZE(reclength+MI_UNIQUE_HASH_LENGTH+1);
     table->getMutableShare()->rec_buff_length= alloc_length;
-    if (!(table->record[0]= (unsigned char*) table->alloc_root(alloc_length*2)))
-    {
-      goto err;
-    }
+    table->record[0]= table->alloc(alloc_length*2);
     table->record[1]= table->getInsertRecord()+alloc_length;
     table->getMutableShare()->resizeDefaultValues(alloc_length);
   }
@@ -1261,9 +1238,7 @@
 			 (table->getMutableShare()->uniques ? test(null_pack_length) : 0));
     table->distinct= 1;
     table->getMutableShare()->keys= 1;
-    if (!(key_part_info= (KeyPartInfo*)
-         table->alloc_root(keyinfo->key_parts * sizeof(KeyPartInfo))))
-      goto err;
+    key_part_info= (KeyPartInfo*)table->alloc(keyinfo->key_parts * sizeof(KeyPartInfo));
     memset(key_part_info, 0, keyinfo->key_parts * sizeof(KeyPartInfo));
     table->key_info=keyinfo;
     keyinfo->key_part=key_part_info;

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2011-04-15 13:22:35 +0000
+++ drizzled/table.h	2011-06-22 20:05:58 +0000
@@ -315,37 +315,26 @@
 
   void init_mem_root()
   {
-    init_sql_alloc(&mem_root, TABLE_ALLOC_BLOCK_SIZE, 0);
+    if (not mem_root.alloc_root_inited())
+      mem_root.init(TABLE_ALLOC_BLOCK_SIZE);
   }
 public:
-  memory::Root *getMemRoot()
-  {
-    if (not mem_root.alloc_root_inited())
-    {
-      init_mem_root();
-    }
-
-    return &mem_root;
-  }
-
-  void *alloc_root(size_t arg)
-  {
-    if (not mem_root.alloc_root_inited())
-    {
-      init_mem_root();
-    }
-
-    return mem_root.alloc_root(arg);
-  }
-
-  char *strmake_root(const char *str_arg, size_t len_arg)
-  {
-    if (not mem_root.alloc_root_inited())
-    {
-      init_mem_root();
-    }
-
-    return mem_root.strmake_root(str_arg, len_arg);
+  memory::Root& getMemRoot()
+  {
+    init_mem_root();
+    return mem_root;
+  }
+
+  unsigned char* alloc(size_t arg)
+  {
+    init_mem_root();
+    return mem_root.alloc(arg);
+  }
+
+  char* strmake(const char* str_arg, size_t len_arg)
+  {
+    init_mem_root();
+    return mem_root.strmake(str_arg, len_arg);
   }
 
   filesort_info sort;
@@ -802,8 +791,8 @@
 int get_quick_record(optimizer::SqlSelect *select);
 
 void find_date(char *pos,uint32_t *vek,uint32_t flag);
-TYPELIB *convert_strings_to_array_type(char * *typelibs, char * *end);
-TYPELIB *typelib(memory::Root *mem_root, List<String> &strings);
+TYPELIB* convert_strings_to_array_type(char** typelibs, char** end);
+TYPELIB* typelib(memory::Root&, List<String>&);
 ulong get_form_pos(int file, unsigned char *head, TYPELIB *save_names);
 void append_unescaped(String *res, const char *pos, uint32_t length);
 

=== modified file 'drizzled/table/instance/base.cc'
--- drizzled/table/instance/base.cc	2011-04-13 13:04:50 +0000
+++ drizzled/table/instance/base.cc	2011-06-22 17:21:46 +0000
@@ -530,19 +530,12 @@
     identifier::Table::build_table_filename(_path, db.str, table_name.str, false);
   }
 
-  if ((path_buff= (char *)mem_root.alloc_root(_path.length() + 1)))
-  {
-    setPath(path_buff, _path.length());
-    strcpy(path_buff, _path.c_str());
-    setNormalizedPath(path_buff, _path.length());
+  path_buff= (char *)mem_root.alloc(_path.length() + 1);
+  setPath(path_buff, _path.length());
+  strcpy(path_buff, _path.c_str());
+  setNormalizedPath(path_buff, _path.length());
 
-    version= g_refresh_version;
-  }
-  else
-  {
-    assert(0); // We should throw here.
-    abort();
-  }
+  version= g_refresh_version;
 }
 
 void TableShare::init(const char *new_table_name,
@@ -640,7 +633,7 @@
   for (int indx= 0; indx < table.indexes_size(); indx++)
     key_parts+= table.indexes(indx).index_part_size();
 
-  key_info= (KeyInfo*) alloc_root( table.indexes_size() * sizeof(KeyInfo) +key_parts*sizeof(KeyPartInfo));
+  key_info= (KeyInfo*) alloc(table.indexes_size() * sizeof(KeyInfo) +key_parts*sizeof(KeyPartInfo));
 
   KeyPartInfo *key_part;
 
@@ -648,7 +641,7 @@
     (key_info+table.indexes_size());
 
 
-  ulong *rec_per_key= (ulong*) alloc_root(sizeof(ulong*)*key_parts);
+  ulong *rec_per_key= (ulong*) alloc(sizeof(ulong*)*key_parts);
 
   KeyInfo* keyinfo= key_info;
   for (int keynr= 0; keynr < table.indexes_size(); keynr++, keyinfo++)
@@ -772,10 +765,10 @@
     {
       keyinfo->flags|= HA_USES_COMMENT;
       keyinfo->comment.length= indx.comment().length();
-      keyinfo->comment.str= strmake_root(indx.comment().c_str(), keyinfo->comment.length);
+      keyinfo->comment.str= strmake(indx.comment().c_str(), keyinfo->comment.length);
     }
 
-    keyinfo->name= strmake_root(indx.name().c_str(), indx.name().length());
+    keyinfo->name= strmake(indx.name().c_str(), indx.name().length());
 
     addKeyName(string(keyinfo->name, indx.name().length()));
   }
@@ -929,9 +922,9 @@
 
     TYPELIB *t= (&intervals[interval_nr]);
 
-    t->type_names= (const char**)alloc_root((field_options.field_value_size() + 1) * sizeof(char*));
+    t->type_names= (const char**)alloc((field_options.field_value_size() + 1) * sizeof(char*));
 
-    t->type_lengths= (unsigned int*) alloc_root((field_options.field_value_size() + 1) * sizeof(unsigned int));
+    t->type_lengths= (unsigned int*)alloc((field_options.field_value_size() + 1) * sizeof(unsigned int));
 
     t->type_names[field_options.field_value_size()]= NULL;
     t->type_lengths[field_options.field_value_size()]= 0;
@@ -941,7 +934,7 @@
 
     for (int n= 0; n < field_options.field_value_size(); n++)
     {
-      t->type_names[n]= strmake_root(field_options.field_value(n).c_str(), field_options.field_value(n).length());
+      t->type_names[n]= strmake(field_options.field_value(n).c_str(), field_options.field_value(n).length());
 
       /* 
        * Go ask the charset what the length is as for "" length=1
@@ -1014,7 +1007,7 @@
       size_t len= pfield.comment().length();
       const char* str= pfield.comment().c_str();
 
-      comment.str= strmake_root(str, len);
+      comment.str= strmake(str, len);
       comment.length= len;
     }
 
@@ -1612,7 +1605,7 @@
   boost::checked_delete(outparam.cursor);
   outparam.cursor= 0;				// For easier error checking
   outparam.db_stat= 0;
-  outparam.getMemRoot()->free_root(MYF(0));       // Safe to call on zeroed root
+  outparam.getMemRoot().free_root(MYF(0));       // Safe to call on zeroed root
   outparam.clearAlias();
 
   return ret;
@@ -1644,8 +1637,7 @@
 
   records++;
 
-  if (!(record= (unsigned char*) outparam.alloc_root(rec_buff_length * records)))
-    return local_error;
+  record= outparam.alloc(rec_buff_length * records);
 
   if (records == 0)
   {
@@ -1679,10 +1671,7 @@
     memcpy(outparam.getUpdateRecord(), getDefaultValues(), null_bytes);
   }
 
-  if (!(field_ptr = (Field **) outparam.alloc_root( (uint32_t) ((_field_size+1)* sizeof(Field*)))))
-  {
-    return local_error;
-  }
+  field_ptr = (Field **) outparam.alloc((_field_size+1) * sizeof(Field*));
 
   outparam.setFields(field_ptr);
 
@@ -1693,7 +1682,7 @@
   /* Setup copy of fields from share, but use the right alias and record */
   for (uint32_t i= 0 ; i < _field_size; i++, field_ptr++)
   {
-    if (!((*field_ptr)= _fields[i]->clone(outparam.getMemRoot(), &outparam)))
+    if (!((*field_ptr)= _fields[i]->clone(&outparam.getMemRoot(), &outparam)))
       return local_error;
   }
   (*field_ptr)= 0;                              // End marker
@@ -1711,8 +1700,7 @@
     KeyPartInfo *key_part;
     uint32_t n_length;
     n_length= keys*sizeof(KeyInfo) + key_parts*sizeof(KeyPartInfo);
-    if (!(local_key_info= (KeyInfo*) outparam.alloc_root(n_length)))
-      return local_error;
+    local_key_info= (KeyInfo*) outparam.alloc(n_length);
     outparam.key_info= local_key_info;
     key_part= (reinterpret_cast<KeyPartInfo*> (local_key_info+keys));
 
@@ -1742,7 +1730,7 @@
             We are using only a prefix of the column as a key:
             Create a new field for the key part that matches the index
           */
-          local_field= key_part->field= local_field->new_field(outparam.getMemRoot(), &outparam, 0);
+          local_field= key_part->field= local_field->new_field(&outparam.getMemRoot(), &outparam, 0);
           local_field->field_length= key_part->length;
         }
       }

=== modified file 'drizzled/table/instance/base.h'
--- drizzled/table/instance/base.h	2011-04-11 21:25:46 +0000
+++ drizzled/table/instance/base.h	2011-06-22 15:11:11 +0000
@@ -170,19 +170,19 @@
 private:
   memory::Root mem_root;
 
-  void *alloc_root(size_t arg)
-  {
-    return mem_root.alloc_root(arg);
-  }
-
-  char *strmake_root(const char *str_arg, size_t len_arg)
-  {
-    return mem_root.strmake_root(str_arg, len_arg);
-  }
-
-  memory::Root *getMemRoot()
-  {
-    return &mem_root;
+  unsigned char* alloc(size_t arg)
+  {
+    return mem_root.alloc(arg);
+  }
+
+  char *strmake(const char *str_arg, size_t len_arg)
+  {
+    return mem_root.strmake(str_arg, len_arg);
+  }
+
+  memory::Root& getMemRoot()
+  {
+    return mem_root;
   }
 
   std::vector<std::string> _keynames;

=== modified file 'drizzled/table/singular.cc'
--- drizzled/table/singular.cc	2011-03-22 00:06:56 +0000
+++ drizzled/table/singular.cc	2011-06-22 17:21:46 +0000
@@ -87,7 +87,7 @@
   null_pack_length= (null_count + 7)/8;
   getMutableShare()->setRecordLength(record_length + null_pack_length);
   getMutableShare()->rec_buff_length= ALIGN_SIZE(getMutableShare()->getRecordLength() + 1);
-  record[0]= (unsigned char*)session->getMemRoot()->allocate(getMutableShare()->rec_buff_length);
+  record[0]= session->mem.alloc(getMutableShare()->rec_buff_length);
   if (not getInsertRecord())
   {
     throw "Memory allocation failure";
@@ -186,9 +186,7 @@
   if (getShare()->sizeKeys())
   {						// Get keys for ni_create
     bool using_unique_constraint= false;
-    HA_KEYSEG *seg= (HA_KEYSEG*) getMemRoot()->alloc_root(sizeof(*seg) * keyinfo->key_parts);
-    if (not seg)
-      return true;
+    HA_KEYSEG *seg= (HA_KEYSEG*) getMemRoot().alloc(sizeof(*seg) * keyinfo->key_parts);
 
     memset(seg, 0, sizeof(*seg) * keyinfo->key_parts);
     if (keyinfo->key_length >= cursor->getEngine()->max_key_length() ||
@@ -323,13 +321,13 @@
   }
 
   /* free blobs */
-  for (Field **ptr= getFields() ; *ptr ; ptr++)
+  for (Field **ptr= getFields(); *ptr; ptr++)
   {
     (*ptr)->free();
   }
   free_io_cache();
 
-  getMemRoot()->free_root(MYF(0));
+  getMemRoot().free_root(MYF(0));
   in_use->set_proc_info(save_proc_info);
 }
 

=== modified file 'drizzled/tree.cc'
--- drizzled/tree.cc	2011-04-13 16:14:00 +0000
+++ drizzled/tree.cc	2011-06-22 14:19:44 +0000
@@ -126,7 +126,7 @@
   }
   if (! (tree->with_delete= with_delete))
   {
-    tree->mem_root.init_alloc_root(default_alloc_size);
+    tree->mem_root.init(default_alloc_size);
     tree->mem_root.min_malloc= (sizeof(TREE_ELEMENT)+tree->size_of_element);
   }
 }
@@ -228,9 +228,7 @@
     if (tree->with_delete)
       element= (TREE_ELEMENT *) malloc(alloc_size);
     else
-      element= (TREE_ELEMENT *) tree->mem_root.alloc_root(alloc_size);
-    if (!element)
-      return(NULL);
+      element= (TREE_ELEMENT *) tree->mem_root.alloc(alloc_size);
     **parent= element;
     element->left= element->right= &tree->null_element;
     if (!tree->offset_to_key)

=== modified file 'drizzled/type/decimal.cc'
--- drizzled/type/decimal.cc	2011-06-20 12:15:13 +0000
+++ drizzled/type/decimal.cc	2011-06-22 20:05:58 +0000
@@ -1205,7 +1205,7 @@
                                 internal::MY_GCVT_ARG_DOUBLE,
                                 sizeof(buff) - 1, buff, NULL);
   res= string2decimal(buff, to, &end);
-  return(res);
+  return res;
 }
 
 

=== modified file 'drizzled/typelib.cc'
--- drizzled/typelib.cc	2011-06-02 13:21:47 +0000
+++ drizzled/typelib.cc	2011-06-22 14:19:44 +0000
@@ -120,14 +120,14 @@
 
 TYPELIB *TYPELIB::copy_typelib(memory::Root& root) const
 {
-  TYPELIB* to= (TYPELIB*) root.alloc_root(sizeof(TYPELIB));
-  to->type_names= (const char**)root.alloc_root((sizeof(char *) + sizeof(int)) * (count + 1));
+  TYPELIB* to= (TYPELIB*) root.alloc(sizeof(TYPELIB));
+  to->type_names= (const char**)root.alloc((sizeof(char *) + sizeof(int)) * (count + 1));
   to->type_lengths= (unsigned int*)(to->type_names + count + 1);
   to->count= count;
-  to->name= name ? root.strdup_root(name) : NULL;
+  to->name= name ? root.strdup(name) : NULL;
   for (uint32_t i= 0; i < count; i++)
   {
-    to->type_names[i]= root.strmake_root(type_names[i], type_lengths[i]);
+    to->type_names[i]= root.strmake(type_names[i], type_lengths[i]);
     to->type_lengths[i]= type_lengths[i];
   }
   to->type_names[to->count]= NULL;

=== modified file 'plugin/auth_file/auth_file.cc'
--- plugin/auth_file/auth_file.cc	2011-02-17 00:14:13 +0000
+++ plugin/auth_file/auth_file.cc	2011-06-21 12:02:57 +0000
@@ -40,23 +40,19 @@
 using namespace std;
 using namespace drizzled;
 
-namespace auth_file
-{
+namespace auth_file {
 
 static const fs::path DEFAULT_USERS_FILE= SYSCONFDIR "/drizzle.users";
 
-class AuthFile: public plugin::Authentication
+class AuthFile : public plugin::Authentication
 {
-  const fs::path users_file;
-
 public:
-
-  AuthFile(string name_arg, fs::path users_file_arg);
+  AuthFile(fs::path users_file_arg);
 
   /**
    * Retrieve the last error encountered in the class.
    */
-  string& getError(void);
+  const string& getError() const;
 
   /**
    * Load the users file into a map cache.
@@ -64,7 +60,7 @@
    * @return True on success, false on error. If false is returned an error
    *  is set and can be retrieved with getError().
    */
-  bool loadFile(void);
+  bool loadFile();
 
 private:
 
@@ -89,44 +85,41 @@
                        const string &scrambled_password);
 
   string error;
+  const fs::path users_file;
 
   /**
    * Cache or username:password entries from the file.
    */
-  std::map<string, string> users;
+  typedef std::map<string, string> users_t;
+  users_t users;
 };
 
-AuthFile::AuthFile(string name_arg, fs::path users_file_arg):
-  plugin::Authentication(name_arg),
-  users_file(users_file_arg),
-  error(),
-  users()
+AuthFile::AuthFile(fs::path users_file_arg) :
+  plugin::Authentication("auth_file"),
+  users_file(users_file_arg)
 {
 }
 
-string& AuthFile::getError(void)
+const string& AuthFile::getError() const
 {
   return error;
 }
 
-bool AuthFile::loadFile(void)
+bool AuthFile::loadFile()
 {
   ifstream file(users_file.string().c_str());
 
   if (!file.is_open())
   {
-    error = "Could not open users file: ";
-    error += users_file.string();
+    error = "Could not open users file: " + users_file.string();
     return false;
   }
 
-  while (!file.eof())
+  string line;
+  while (getline(file, line))
   {
-    string line;
-    getline(file, line);
-
     /* Ignore blank lines and lines starting with '#'. */
-    if (line == "" || line[line.find_first_not_of(" \t")] == '#')
+    if (line.empty() || line[line.find_first_not_of(" \t")] == '#')
       continue;
 
     string username;
@@ -140,19 +133,12 @@
       password = string(line, password_offset + 1);
     }
 
-    std::pair<std::map<std::string, std::string>::iterator, bool> result=
-      users.insert(std::pair<std::string, std::string>(username, password));
-
-    if (result.second == false)
+    if (not users.insert(pair<string, string>(username, password)).second)
     {
-      error = "Duplicate entry found in users file: ";
-      error += username;
-      file.close();
+      error = "Duplicate entry found in users file: " + username;
       return false;
     }
   }
-
-  file.close();
   return true;
 }
 
@@ -160,8 +146,7 @@
                                const string &scramble_bytes,
                                const string &scrambled_password)
 {
-  if (scramble_bytes.size() != SHA1_DIGEST_LENGTH ||
-      scrambled_password.size() != SHA1_DIGEST_LENGTH)
+  if (scramble_bytes.size() != SHA1_DIGEST_LENGTH || scrambled_password.size() != SHA1_DIGEST_LENGTH)
   {
     return false;
   }
@@ -173,8 +158,7 @@
 
   /* Generate the double SHA1 hash for the password stored locally first. */
   SHA1Init(&ctx);
-  SHA1Update(&ctx, reinterpret_cast<const uint8_t *>(password.c_str()),
-             password.size());
+  SHA1Update(&ctx, reinterpret_cast<const uint8_t *>(password.c_str()), password.size());
   SHA1Final(temp_hash, &ctx);
 
   SHA1Init(&ctx);
@@ -183,8 +167,7 @@
 
   /* Hash the scramble that was sent to client with the local password. */
   SHA1Init(&ctx);
-  SHA1Update(&ctx, reinterpret_cast<const uint8_t*>(scramble_bytes.c_str()),
-             SHA1_DIGEST_LENGTH);
+  SHA1Update(&ctx, reinterpret_cast<const uint8_t*>(scramble_bytes.c_str()), SHA1_DIGEST_LENGTH);
   SHA1Update(&ctx, local_scrambled_password, SHA1_DIGEST_LENGTH);
   SHA1Final(temp_hash, &ctx);
 
@@ -204,28 +187,22 @@
 
 bool AuthFile::authenticate(const identifier::User &sctx, const string &password)
 {
-  std::map<std::string, std::string>::const_iterator user= users.find(sctx.username());
-  if (user == users.end())
+  string* user= find_ptr(users, sctx.username());
+  if (not user)
     return false;
-
-  if (sctx.getPasswordType() == identifier::User::MYSQL_HASH)
-    return verifyMySQLHash(user->second, sctx.getPasswordContext(), password);
-
-  if (password == user->second)
-    return true;
-
-  return false;
+  return sctx.getPasswordType() == identifier::User::MYSQL_HASH
+    ? verifyMySQLHash(*user, sctx.getPasswordContext(), password)
+    : password == *user;
 }
 
 static int init(module::Context &context)
 {
   const module::option_map &vm= context.getOptions();
 
-  AuthFile *auth_file = new AuthFile("auth_file", fs::path(vm["users"].as<string>()));
+  AuthFile *auth_file = new AuthFile(fs::path(vm["users"].as<string>()));
   if (not auth_file->loadFile())
   {
-    errmsg_printf(error::ERROR, _("Could not load auth file: %s\n"),
-                  auth_file->getError().c_str());
+    errmsg_printf(error::ERROR, _("Could not load auth file: %s\n"), auth_file->getError().c_str());
     delete auth_file;
     return 1;
   }

=== modified file 'plugin/haildb/haildb_engine.cc'
--- plugin/haildb/haildb_engine.cc	2011-05-28 13:24:30 +0000
+++ plugin/haildb/haildb_engine.cc	2011-06-22 17:21:46 +0000
@@ -2286,19 +2286,17 @@
     }
     else if ((**field).type() == DRIZZLE_TYPE_BLOB)
     {
-      if (blobroot == NULL)
-        (reinterpret_cast<Field_blob*>(*field))->set_ptr(length,
-                                      (unsigned char*)ib_col_get_value(tuple,
-                                                                       colnr));
+      if (not blobroot)
+        (reinterpret_cast<Field_blob*>(*field))->set_ptr(length, (unsigned char*)ib_col_get_value(tuple, colnr));
       else
       {
-        if (*blobroot == NULL)
+        if (not *blobroot)
         {
           *blobroot= new drizzled::memory::Root();
-          (**blobroot).init_alloc_root();
+          (*blobroot)->init();
         }
 
-        unsigned char *blob_ptr= (unsigned char*)(**blobroot).alloc_root(length);
+        unsigned char *blob_ptr= (*blobroot)->alloc(length);
         memcpy(blob_ptr, ib_col_get_value(tuple, colnr), length);
         (reinterpret_cast<Field_blob*>(*field))->set_ptr(length, blob_ptr);
       }

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2011-04-28 18:07:05 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2011-06-21 15:43:17 +0000
@@ -7903,8 +7903,7 @@
                               tmp_update_method, tmp_delete_method, tmp_referenced_key_name,
                               tmp_foreign_fields, tmp_referenced_fields);
 
-    ForeignKeyInfo *pf_key_info = (ForeignKeyInfo *)
-      session->getMemRoot()->duplicate(&f_key_info, sizeof(ForeignKeyInfo));
+    ForeignKeyInfo *pf_key_info = (ForeignKeyInfo*)session->mem.memdup(&f_key_info, sizeof(ForeignKeyInfo));
     f_key_list->push_back(pf_key_info);
     foreign = UT_LIST_GET_NEXT(foreign_list, foreign);
   }

=== modified file 'plugin/multi_thread/multi_thread.cc'
--- plugin/multi_thread/multi_thread.cc	2011-04-22 22:25:59 +0000
+++ plugin/multi_thread/multi_thread.cc	2011-06-22 16:36:40 +0000
@@ -123,7 +123,7 @@
 #endif
 }
 
-bool MultiThreadScheduler::addSession(Session::shared_ptr &session)
+bool MultiThreadScheduler::addSession(const Session::shared_ptr& session)
 {
   if (thread_count >= max_threads)
     return true;
@@ -165,7 +165,7 @@
   }
 }
 
-void MultiThreadScheduler::killSessionNow(Session::shared_ptr &session)
+void MultiThreadScheduler::killSessionNow(const Session::shared_ptr& session)
 {
   killSession(session.get());
 

=== modified file 'plugin/multi_thread/multi_thread.h'
--- plugin/multi_thread/multi_thread.h	2011-03-29 12:49:11 +0000
+++ plugin/multi_thread/multi_thread.h	2011-06-22 16:36:40 +0000
@@ -39,8 +39,8 @@
   }
 
   ~MultiThreadScheduler();
-  bool addSession(drizzled::Session::shared_ptr &session);
-  void killSessionNow(drizzled::Session::shared_ptr &session);
+  bool addSession(const drizzled::Session::shared_ptr&);
+  void killSessionNow(const drizzled::Session::shared_ptr&);
   void killSession(drizzled::Session*);
   
   void runSession(drizzled::session_id_t);

=== modified file 'plugin/pbms/src/discover_ms.cc'
--- plugin/pbms/src/discover_ms.cc	2011-03-28 02:46:21 +0000
+++ plugin/pbms/src/discover_ms.cc	2011-06-21 14:08:41 +0000
@@ -322,7 +322,7 @@
           {
             uint cnv_errs;
             conv.copy(tmp->ptr(), tmp->length(), tmp->charset(), cs, &cnv_errs);
-            interval->type_names[i]= strmake_root(thd->mem_root, conv.ptr(),
+            interval->type_names[i]= strmake(thd->mem_root, conv.ptr(),
                                                   conv.length());
             interval->type_lengths[i]= conv.length();
           }

=== modified file 'plugin/pbms/src/events_ms.cc'
--- plugin/pbms/src/events_ms.cc	2011-03-14 15:00:51 +0000
+++ plugin/pbms/src/events_ms.cc	2011-06-22 13:08:49 +0000
@@ -100,7 +100,7 @@
 		
 		if (length > org_length) {
 			// This can only happen if the BLOB URL is actually larger than the BLOB itself.
-			blob = (char *) session.getMemRoot()->allocate(length);
+			blob = (char *) session.mem.alloc(length);
 			memcpy(blob_rec+packlength, &blob, sizeof(char*));
 		}			
 		memcpy(blob, blob_url_buffer.bu_data, length);

=== modified file 'plugin/schema_engine/schema.cc'
--- plugin/schema_engine/schema.cc	2011-04-20 22:18:30 +0000
+++ plugin/schema_engine/schema.cc	2011-06-21 20:40:13 +0000
@@ -39,6 +39,7 @@
 #include <sys/stat.h>
 #include <sys/types.h>
 
+#include <boost/foreach.hpp>
 #include <google/protobuf/io/zero_copy_stream.h>
 #include <google/protobuf/io/zero_copy_stream_impl.h>
 
@@ -49,11 +50,15 @@
 using namespace std;
 using namespace drizzled;
 
-
-#define MY_DB_OPT_FILE "db.opt"
-#define DEFAULT_FILE_EXTENSION ".dfe" // Deep Fried Elephant
-
-Schema::Schema():
+const char* MY_DB_OPT_FILE= "db.opt";
+const char* DEFAULT_FILE_EXTENSION= ".dfe"; // Deep Fried Elephant
+
+static const char* g_schema_exts[] = 
+{
+  NULL
+};
+
+Schema::Schema() :
   drizzled::plugin::StorageEngine("schema",
                                   HTON_ALTER_NOT_SUPPORTED |
                                   HTON_HAS_SCHEMA_DICTIONARY |
@@ -64,25 +69,17 @@
   table_definition_ext= DEFAULT_FILE_EXTENSION;
 }
 
-Schema::~Schema()
-{
-}
-
 void Schema::prime()
 {
   CachedDirectory directory(getDataHomeCatalog().file_string(), CachedDirectory::DIRECTORY);
   CachedDirectory::Entries files= directory.getEntries();
   boost::unique_lock<boost::shared_mutex> scopedLock(mutex);
 
-  for (CachedDirectory::Entries::iterator fileIter= files.begin();
-       fileIter != files.end(); fileIter++)
+  BOOST_FOREACH(CachedDirectory::Entries::reference entry, files)
   {
-    CachedDirectory::Entry *entry= *fileIter;
-    message::Schema schema_message;
-
     if (not entry->filename.compare(GLOBAL_TEMPORARY_EXT))
       continue;
-
+    message::Schema schema_message;
     if (readSchemaFile(entry->filename, schema_message))
     {
       identifier::Schema schema_identifier(schema_message.name());
@@ -90,29 +87,16 @@
       pair<SchemaCache::iterator, bool> ret=
         schema_cache.insert(make_pair(schema_identifier.getPath(), new message::Schema(schema_message)));
 
-      if (ret.second == false)
-      {
-        abort(); // If this has happened, something really bad is going down.
-      }
+      assert(ret.second); // If this has happened, something really bad is going down.
     }
   }
 }
 
-void Schema::startup(drizzled::Session &)
-{
-}
-
 void Schema::doGetSchemaIdentifiers(identifier::schema::vector &set_of_names)
 {
   mutex.lock_shared();
-  {
-    for (SchemaCache::iterator iter= schema_cache.begin();
-         iter != schema_cache.end();
-         iter++)
-    {
-      set_of_names.push_back(identifier::Schema(iter->second->name()));
-    }
-  }
+  BOOST_FOREACH(SchemaCache::reference iter, schema_cache)
+    set_of_names.push_back(iter.second->name());
   mutex.unlock_shared();
 }
 
@@ -120,17 +104,13 @@
 {
   mutex.lock_shared();
   SchemaCache::iterator iter= schema_cache.find(schema_identifier.getPath());
-
   if (iter != schema_cache.end())
   {
-    drizzled::message::schema::shared_ptr schema_message;
-    schema_message= iter->second;
+    drizzled::message::schema::shared_ptr schema_message= iter->second;
     mutex.unlock_shared();
-
     return schema_message;
   }
   mutex.unlock_shared();
-
   return drizzled::message::schema::shared_ptr();
 }
 
@@ -152,18 +132,11 @@
     return false;
   }
 
-  {
-    boost::unique_lock<boost::shared_mutex> scopedLock(mutex);
-    pair<SchemaCache::iterator, bool> ret=
-      schema_cache.insert(make_pair(schema_identifier.getPath(), new message::Schema(schema_message)));
-
-
-    if (ret.second == false)
-    {
-      abort(); // If this has happened, something really bad is going down.
-    }
-  }
-
+  boost::unique_lock<boost::shared_mutex> scopedLock(mutex);
+  pair<SchemaCache::iterator, bool> ret= 
+    schema_cache.insert(make_pair(schema_identifier.getPath(), new message::Schema(schema_message)));
+
+  assert(ret.second); // If this has happened, something really bad is going down.
   return true;
 }
 
@@ -219,10 +192,7 @@
     pair<SchemaCache::iterator, bool> ret=
       schema_cache.insert(make_pair(schema_identifier.getPath(), new message::Schema(schema_message)));
 
-    if (ret.second == false)
-    {
-      abort(); // If this has happened, something really bad is going down.
-    }
+    assert(ret.second); // If this has happened, something really bad is going down.
   }
 
   return true;
@@ -343,3 +313,8 @@
                                    drizzled::identifier::table::vector&)
 {
 }
+
+const char** Schema::bas_ext() const
+{
+  return g_schema_exts;
+}

=== modified file 'plugin/schema_engine/schema.h'
--- plugin/schema_engine/schema.h	2011-03-28 17:36:12 +0000
+++ plugin/schema_engine/schema.h	2011-06-21 20:40:13 +0000
@@ -27,10 +27,6 @@
 
 extern const drizzled::charset_info_st *default_charset_info;
 
-static const char *schema_exts[] = {
-  NULL
-};
-
 class Schema : public drizzled::plugin::StorageEngine
 {
   bool writeSchemaFile(const drizzled::identifier::Schema &schema_identifier, const drizzled::message::Schema &db);
@@ -38,7 +34,6 @@
   bool readSchemaFile(std::string filename, drizzled::message::Schema &schema);
 
   void prime();
-  void startup(drizzled::Session &session);
 
   typedef boost::unordered_map<std::string, drizzled::message::schema::shared_ptr> SchemaCache;
   SchemaCache schema_cache;
@@ -49,20 +44,17 @@
 public:
   Schema();
 
-  ~Schema();
-
-
-  drizzled::Cursor *create(drizzled::Table &)
+  drizzled::Cursor* create(drizzled::Table&)
   {
     return NULL;
   }
 
-  void doGetSchemaIdentifiers(drizzled::identifier::schema::vector &set_of_names);
+  void doGetSchemaIdentifiers(drizzled::identifier::schema::vector&);
   drizzled::message::schema::shared_ptr doGetSchemaDefinition(const drizzled::identifier::Schema&);
 
-  bool doCreateSchema(const drizzled::message::Schema &schema_message);
+  bool doCreateSchema(const drizzled::message::Schema&);
 
-  bool doAlterSchema(const drizzled::message::Schema &schema_message);
+  bool doAlterSchema(const drizzled::message::Schema&);
 
   bool doDropSchema(const drizzled::identifier::Schema&);
 
@@ -98,10 +90,7 @@
     return drizzled::HA_ERR_NO_SUCH_TABLE;
   }
 
-  const char **bas_ext() const 
-  {
-    return schema_exts;
-  }
+  const char** bas_ext() const;
 
   void get_auto_increment(uint64_t, uint64_t,
                           uint64_t,

